


   DECLARE SUB OPTIMUM (PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#)
   DECLARE SUB ROTATE (PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#)
   DECLARE SUB STEREO (FROT, YP$, AX1, AX2, AX3, MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)
   DECLARE SUB DIRECT (K1, K2, K3, DIP, ALPHA)
   AXX = .99999
    PI# = 4 * ATN(1!): XFACT = 1: CLS : PRINT
    SIZE = 500
30 DIM DF#(SIZE), DD#(SIZE), SP#(SIZE), ST#(SIZE), FJ#(SIZE), N1#(SIZE), N2#(SIZE), N3#(SIZE), S1#(SIZE), S2#(SIZE), S3#(SIZE), IFAULT(SIZE), COLNUM&(40)
   DIM BW(10), BW1(10), BW2(10), DAT(15)
   DIM KS(SIZE), PH(SIZE), S1P(10), S2P(10), S3P(10), PL(3), ST(3)
   PRINT
    COLOR (4)
    LOCATE 1, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 2, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 3, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I



    LOCATE 2, 25
    COLOR (15)
    PRINT "FAULTING IN THREE-DIMENSIONS"
    LOCATE 5, 1
    COLOR (2): PRINT "          Calculating and plotting preferred faults for 3D strain state"
    COLOR (6)
    PRINT "                   A QuickBasic program by Ze'ev Reches"
    PRINT "                        Version 1.1, December, 1997"
    PRINT
    COLOR (15)
    FACT = 1
    PRINT "The program determines the preferred orientations of faults and the associated"
    PRINT "    slip axes for faulting under three-dimensional strain state."
    PRINT "Derivations are presented in Reches, 1983, Tectonophysics, 95, 133-166 "
    PRINT
    PRINT "This is an interactive program that prompts for input and suggests defaults."
    PRINT "Defaults appear in [SQUARE BRACKETS] to be activated by hitting RETURN. "
    PRINT
    PRINT "Calculation results are saved in several files:"
    PRINT " TEMP-with preferred fault orientations and associated slip axes (STRESS format)"
    PRINT " 3D-same as TEMP, with friction angle and strain ratio."
    PRINT " 3D.ROT- same as 3D for the rotated fault and slip data."
    PRINT " OPTALL.TXT- results of search for an optimum solution."
    PRINT
    PRINT "NOTE:  USE ONLY UPPER CASE FOR FILENAMES!!!"
    PRINT
    INPUT " [CONTINUE] "; Y$

35 SCREEN 12
CLS
PRINT "            STRAIN AXES "
PRINT
PRINT "The three principal axes are: 1=X north, 2=Y east, 3=Z down."
AX1 = 3: AX2 = 1: AX3 = 2: AC = 1

1360 PRINT
PRINT "Three optional setting of axes orientations according to faulting style:"
PRINT "1- Normal faulting:"
PRINT "    Vertical maximum shortening; horizontal maximum extension (eastward, Y)"
PRINT "2- Strike-slip faulting:"
PRINT "    Vertical intermediate axis; horizontal maximum shortening (eastward, Y)"
PRINT "3- Reverse faulting:"
PRINT "    Vertical maximum extension; horizontal maximum shortening (eastward, Y)"
PRINT
PRINT "Current axes setting is for option ["; AC; "]:"
IF AX1 = 1 THEN PRINT "Horizontal maximum shortening (1=X, northward)"
IF AX1 = 2 THEN PRINT "Horizontal maximum shortening (2=Y, eastward)"
IF AX1 = 3 THEN PRINT "Verical maximum shortening (3=Z, down)"

IF AX2 = 1 THEN PRINT "Intermediate axis is 1=X (northward)"
IF AX2 = 2 THEN PRINT "Intermediate axis is 2=Y (eastward)"
IF AX2 = 3 THEN PRINT "Intermediate axis is 3=Z (down)"

IF AX3 = 1 THEN PRINT "Horizontal maximum extension (1=X, northward)"
IF AX3 = 2 THEN PRINT "Horizontal maximum extension (2=Y, eastward)"
IF AX3 = 3 THEN PRINT "Vertical maximum extension (3=Z, down)"
PRINT
AC1 = 0
INPUT "Enter option number (1,2 or 3) to change current axes setting [NO CHANGE] "; AC1
IF AC1 = 0 THEN GOTO 1361
IF AC1 <> 0 THEN AC = AC1
IF AC1 <> 0 THEN CLS

IF AC = 1 THEN AX1 = 3: IF AC = 1 THEN AX2 = 1: IF AC = 1 THEN AX3 = 2
IF AC = 2 THEN AX1 = 2: IF AC = 2 THEN AX2 = 3: IF AC = 2 THEN AX3 = 1
IF AC = 3 THEN AX1 = 2: IF AC = 3 THEN AX2 = 1: IF AC = 3 THEN AX3 = 3
GOTO 1360

1361
IF AC = 1 THEN PL(1) = 89.99: IF AC = 1 THEN ST(1) = .01
IF AC = 1 THEN PL(2) = .01: IF AC = 1 THEN ST(2) = .01
IF AC = 1 THEN PL(3) = .01: IF AC = 1 THEN ST(3) = 90.01

IF AC = 2 THEN PL(1) = .01: IF AC = 1 THEN ST(1) = 90.01
IF AC = 2 THEN PL(2) = 89.99: IF AC = 1 THEN ST(2) = .01
IF AC = 2 THEN PL(3) = .01: IF AC = 1 THEN ST(3) = .01

IF AC = 3 THEN PL(1) = .01: IF AC = 1 THEN ST(1) = 90.01
IF AC = 3 THEN PL(2) = .01: IF AC = 1 THEN ST(2) = .01
IF AC = 3 THEN PL(3) = 89.99: IF AC = 1 THEN ST(3) = .01


1371 PRINT
PRINT
PRINT "               STRAIN RATIO"
PRINT
PRINT "Preferred faults are calculated for a strain state defined by a strain-ratio."
PRINT "Reches (1983) used the strain-ratio K=E2/E1."
PRINT "A new strain-ratio, "; CHR$(224); ", is introduced here:     "; CHR$(224); " = (E2-E3) / (E1-E3).  "
PRINT "Clearly, "; CHR$(224); ", is equivalent to the stress-ratio: ";
PRINT CHR$(237); " = ("; CHR$(229); "2-"; CHR$(229); "3) / ("; CHR$(229); "1-"; CHR$(229); "3), "
PRINT " that is employed by most stress inversion methods (see Help of SoftStructure). "
PRINT
PRINT "Note the following rules:"

PRINT " 1. E1- maximum shortening (positive), E3- maximum extension (negative)."
PRINT " 2. E1 + E2 + E3 = 0  (constant volume)"
PRINT " 3. "; CHR$(224); " = (2K + 1) / (K + 2), and  K = (2"; CHR$(224); " - 1) / (2 - "; CHR$(224); ")."
PRINT " 4. As K = E2 / E1, then -0.5 "; CHR$(243); " K "; CHR$(243); " 1.0. "
PRINT " 5. As "; CHR$(224); " = (E2-E3) / (E1-E3), then 0.0 "; CHR$(243); " "; CHR$(224); " "; CHR$(243); " 1.0. "
PRINT " 6. Selecting "; CHR$(224); " = 0.5 may cause numerical problems."
PRINT
KMIN = 0!: KMAX = .49: KSTEP = 3
FMIN = 0: FMAX = 60: FSTEP = 2
PRINT "Enter INITIAL value of the strain ratio "; CHR$(224); " ["; KMIN; "]";
INPUT KMIN1
IF KMIN1 <> 0 THEN KMIN = KMIN1

PRINT "Enter FINAL value of the strain ratio "; CHR$(224); "["; KMAX; "]";
INPUT KMAX1
IF KMAX1 <> 0 THEN KMAX = KMAX1

PRINT "Enter NUMBER of STEPS for strain ratio calculations ["; KSTEP; "]";
INPUT KSTEP1
IF KSTEP1 <> 0 THEN KSTEP = KSTEP1
PRINT
PRINT "The preferred faults are calculated for friction angle "; CHR$(230); "= TAN (F),"
PRINT "  where "; CHR$(230); " is the friction coefficient (like Byerlee's friction)."
PRINT
PRINT "Enter INITIAL value of friction angle (degrees) ["; FMIN; "]";
INPUT FMIN1
IF FMIN1 <> 0 THEN FMIN = FMIN1
PRINT "Enter FINAL value of friction angle (degrees) ["; FMAX; "]";
INPUT FMAX1
IF FMAX1 <> 0 THEN FMAX = FMAX1
PRINT "Enter NUMBER of STEPS for friction angle calculations ["; FSTEP; "]";
INPUT FSTEP1
IF FSTEP1 <> 0 THEN FSTEP = FSTEP1


PRINT
INPUT "Display results on screen (in addition for file saving) [NO]"; PR$
IF PR$ <> "" THEN CLS
IF PR$ <> "" THEN PRINT " Friction Angle  K= E2/E1   Dip: amount, direction    Slip: plunge, trend"

AOUT$ = "3D"
TEMP$ = "TEMP"
OPEN AOUT$ FOR OUTPUT AS #3
OPEN TEMP$ FOR OUTPUT AS #4

NUMF = (KSTEP + 1) * (FSTEP + 1) * 4
PI = 4 * ATN(1!)
PRINT #3, NUMF
PRINT #4, NUMF

FOR P = 1 TO FSTEP + 1
PHE = (FMIN + ((P - 1) * (FMAX - FMIN) / FSTEP)) * PI / 180


FOR K1 = 1 TO KSTEP + 1

KT = KMIN + (K1 - 1) * (KMAX - KMIN) / KSTEP
K = (2 * KT - 1) / (2 - KT)

IF K = 0! THEN K = .01
1450 FOR ISYM = 1 TO 4
IF K > 0 THEN GOTO 2450


IF AX1 = 3 AND AX3 = 2 THEN GOTO 1401
IF AX1 = 2 AND AX3 = 1 THEN GOTO 1402
IF AX1 = 2 AND AX3 = 3 THEN GOTO 1403

1401
N3E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))
N1E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 + SIN(PHE))
N2E = (SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 + SIN(PHE))
S3E = (SQR(2) / 2) * SQR(1 + SIN(PHE))
S1E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 - SIN(PHE))
S2E = (SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 - SIN(PHE))
GOTO 1500

1402
N2E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))
N3E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 + SIN(PHE))
N1E = -(SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 + SIN(PHE))
S2E = (SQR(2) / 2) * SQR(1 + SIN(PHE))
S3E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 - SIN(PHE))
S1E = -(SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 - SIN(PHE))
GOTO 1500

1403
N2E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))
N1E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 + SIN(PHE))
N3E = -(SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 + SIN(PHE))
S2E = (SQR(2) / 2) * SQR(1 + SIN(PHE))
S1E = -(SQR(2) / 2) * SQR(ABS(K)) * SQR(1 - SIN(PHE))
S3E = -(SQR(2) / 2) * SQR(1 - ABS(K)) * SQR(1 - SIN(PHE))
GOTO 1500

2450

IF AX1 = 3 AND AX3 = 2 THEN GOTO 2401
IF AX1 = 2 AND AX3 = 1 THEN GOTO 2402
IF AX1 = 2 AND AX3 = 3 THEN GOTO 2403


2401
N3E = -.5 * SQR(2 / (1 + K)) * SQR(1 - SIN(PHE))
N1E = .5 * SQR(2 * K / (1 + K)) * SQR(1 - SIN(PHE))
N2E = -(SQR(2) / 2) * SQR(1 + SIN(PHE))
S3E = .5 * SQR(2 / (1 + K)) * SQR(1 + SIN(PHE))
S1E = -.5 * SQR(2 * K / (1 + K)) * SQR(1 + SIN(PHE))
S2E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))
GOTO 1500

2402
N2E = -.5 * SQR(2 / (1 + K)) * SQR(1 - SIN(PHE))
N3E = -.5 * SQR(2 * K / (1 + K)) * SQR(1 - SIN(PHE))
N1E = -(SQR(2) / 2) * SQR(1 + SIN(PHE))
S2E = .5 * SQR(2 / (1 + K)) * SQR(1 + SIN(PHE))
S3E = .5 * SQR(2 * K / (1 + K)) * SQR(1 + SIN(PHE))
S1E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))
GOTO 1500

2403
N2E = -.5 * SQR(2 / (1 + K)) * SQR(1 - SIN(PHE))
N1E = .5 * SQR(2 * K / (1 + K)) * SQR(1 - SIN(PHE))
N3E = -(SQR(2) / 2) * SQR(1 + SIN(PHE))
S2E = .5 * SQR(2 / (1 + K)) * SQR(1 + SIN(PHE))
S1E = -.5 * SQR(2 * K / (1 + K)) * SQR(1 + SIN(PHE))
S3E = -(SQR(2) / 2) * SQR(1 - SIN(PHE))

1500

IF ISYM = 1 THEN I1 = 1
IF ISYM = 1 THEN I2 = 1
IF ISYM = 2 THEN I1 = -1
IF ISYM = 2 THEN I2 = -1
IF ISYM = 3 THEN I1 = 1
IF ISYM = 3 THEN I2 = -1
IF ISYM = 4 THEN I1 = -1
IF ISYM = 4 THEN I2 = 1

N1ER = I1 * N1E: N2ER = I2 * N2E: N3ER = N3E
S1ER = I1 * S1E: S2ER = I2 * S2E: S3ER = S3E


NS2 = N1E ^ 2 + N2E ^ 2 + N3E ^ 2
SS2 = S1E ^ 2 + S2E ^ 2 + S3E ^ 2
NNSS = N1E * S1E + N2E * S2E + N3E * S3E

IF YP$ = "" THEN GOTO 1372

IF AC = 1 THEN GOTO 1801
IF AC = 2 THEN GOTO 1802
IF AC = 3 THEN GOTO 1803

1801
N3ER = (S1P(1) * I1 * N1E + S2P(1) * I2 * N2E + S3P(1) * N3E)
N1ER = -(S1P(2) * I1 * N1E + S2P(2) * I2 * N2E + S3P(2) * N3E)
N2ER = (S1P(3) * I1 * N1E + S2P(3) * I2 * N2E + S3P(3) * N3E)

S3ER = S1P(1) * I1 * S1E + S2P(1) * I2 * S2E + S3P(1) * S3E
S1ER = -(S1P(2) * I1 * S1E + S2P(2) * I2 * S2E + S3P(2) * S3E)
S2ER = (S1P(3) * I1 * S1E + S2P(3) * I2 * S2E + S3P(3) * S3E)
GOTO 1900

1802
N2ER = (S1P(1) * I1 * N1E + S2P(1) * I2 * N2E + S3P(1) * N3E)
N3ER = -(S1P(2) * I1 * N1E + S2P(2) * I2 * N2E + S3P(2) * N3E)
N1ER = (S1P(3) * I1 * N1E + S2P(3) * I2 * N2E + S3P(3) * N3E)

S2ER = S1P(1) * I1 * S1E + S2P(1) * I2 * S2E + S3P(1) * S3E
S3ER = -(S1P(2) * I1 * S1E + S2P(2) * I2 * S2E + S3P(2) * S3E)
S1ER = (S1P(3) * I1 * S1E + S2P(3) * I2 * S2E + S3P(3) * S3E)
GOTO 1900
1803

1900
SP1 = S1P(1) * S1P(2) + S2P(1) * S2P(2) + S3P(1) * S3P(2)
SP2 = S1P(2) * S1P(3) + S2P(2) * S2P(3) + S3P(2) * S3P(3)

NN1 = N1E ^ 2 + N2E ^ 2 + N3E ^ 2
NN2 = N1ER ^ 2 + N2ER ^ 2 + N3ER ^ 2
SS1 = S1E ^ 2 + S2E ^ 2 + S3E ^ 2
SS2 = S1ER ^ 2 + S2ER ^ 2 + S3ER ^ 2

1372
CALL DIRECT(N1ER, N2ER, N3ER, DF, DD)
CALL DIRECT(S1ER, S2ER, S3ER, SP, ST)
DF = DF + 90
DD1 = DD: ST1 = ST
IF DF > 90 AND ST1 >= 180 THEN ST = ST - 180
IF DF > 90 AND ST1 < 180 THEN ST = ST + 180
IF DF > 90 THEN SP = -SP
IF DF > 90 AND DD1 >= 180 THEN DD = DD - 180
IF DF > 90 AND DD1 < 180 THEN DD = DD + 180
IF DF > 90 THEN DF = 180 - DF

KN = (2 * K + 1) / (2 + K)
IF PR$ <> "" THEN PRINT USING " #####.### "; PHE * 180 / PI, KN, DF, DD, SP, ST
PRINT #3, USING " #####.### "; DF, DD, SP, ST, KN, PHE * 180 / PI
PRINT #4, USING " #####.### "; DF, DD, SP, ST

NEXT ISYM
NEXT K1
NEXT P

CLOSE


37
    SXI# = -1.5: SYI# = -1!: SZI# = -2!: SXYI# = .0001: SXZI# = .0001: SYZI# = .0001
40

BK$ = "1": SI = 1

36  SI$ = "": SI = 0
    PRINT
    PRINT "Input files have the format of fault-slip files for STRESS (see readme file)."
    PRINT "A file called "; AOUT$; " contains the solutions for the 3D fault orientations."
    IF FROT <> 0 THEN PRINT "A file called "; XH$; " contains the ROTATED fault orientations."
PRINT

    PRINT "Enter input filename for plotting faults ["; AOUT$; "] ";
    INPUT A$
    IF A$ <> "" THEN CL = 1
    IF A$ = "" THEN A$ = AOUT$
    LOCATE 1, 1
    PRINT "                                                     "
    PRINT "                                                     "
    PRINT "                                                     "


'**** Reading the data file*********
   
38  IF CL <> 1 THEN CLS
          FOR I = 0 TO 15
                    IF NOBLUE$ = "R" OR NOBLUE$ = "r" THEN COLNUM&(I) = (15 - I) * 4 + 256 * I * 4
          NEXT I
          FOR I = 0 TO 15
                    IF NOBLUE$ = "" AND I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF NOBLUE$ = "" AND I > 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR I = 1 TO 10
                COL1 = I
                IF NOBLUE$ = "P" OR NOBLUE$ = "p" THEN COLNUM&(I) = COL2
          NEXT I
       FOR J = 1 TO 15
                IF NOBLUE$ <> "P" AND NOBLUE$ <> "p" THEN PALETTE J, COLNUM&(J)
          NEXT J
   
26  OPEN A$ FOR INPUT AS #2
        INPUT #2, NR
        NUMF = NR
    FOR I = 1 TO NR
    IFAULT(I) = 0
    NEXT I
235 FOR I = 1 TO NR
'    PRINT A$, XH$, AOUT$
'    INPUT OK
    IF A$ = AOUT$ OR A$ = XH$ THEN INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I), KS(I), PH(I)
    IF A$ <> AOUT$ AND A$ <> XH$ THEN INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I)

    NF = I
    N1#(I) = COS(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N2#(I) = SIN(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N3#(I) = COS((180 - DF#(I)) * PI# / 180)
    S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S3#(I) = -COS((SP#(I) + 90) * PI# / 180)
    IF SP#(I) = ST#(I) AND SP#(I) = 1 THEN IFAULT(I) = 1
360 NEXT I
370 CLOSE #2

     BK$ = ""


999  SX# = SXI#: SY# = SYI#: SZ# = SZI#: SXY# = SXYI#: SXZ# = SXZI#: SYZ# = SYZI#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     THET = 180 * THET / PI#
     IF SY# < SX# THEN THET = THET + 90

'******* Invariant calculations***************
    
     A1# = -(SX# + SY# + SZ#)
     A2# = (SY# * SZ# + SZ# * SX# + SX# * SY#) - (SYZ# ^ 2 + SXZ# ^ 2 + SXY# ^ 2)
     A3# = -(SX# * SY# * SZ# + 2 * SYZ# * SXZ# * SXY# - SX# * (SYZ#) ^ 2 - SY# * (SXZ#) ^ 2 - SZ# * (SXY#) ^ 2)
     Q# = (3 * A2# - A1# ^ 2) / 9
     R# = (9 * A1# * A2# - 27 * A3# - 2 * A1# ^ 3) / 54
     C# = Q# ^ 3 + R# ^ 2
     IF C# > O THEN PRINT "No real roots"
     CT# = -R# / (SQR(-Q# ^ 3))
     T# = ATN(SQR(1 - CT# ^ 2) / CT#)
     T# = ATN(CT# / SQR(1 - CT# ^ 2)) + PI# / 2
     X1# = 2 * SQR(-Q#) * COS(T# / 3) - A1# / 3
     X2# = 2 * SQR(-Q#) * COS(T# / 3 + 120 * PI# / 180) - A1# / 3
     X3# = 2 * SQR(-Q#) * COS(T# / 3 + 240 * PI# / 180) - A1# / 3

     T1# = X1#: T2# = X2#: T3# = X3#
     IF X1# <= X2# AND X2# <= X3# THEN GOTO 4327
     IF X1# <= X3# AND X3# <= X2# THEN GOTO 155
     IF X2# <= X3# AND X3# <= X1# THEN GOTO 156
     IF X2# <= X1# AND X1# <= X3# THEN GOTO 157
     IF X3# <= X1# AND X1# <= X2# THEN GOTO 158
     IF X3# <= X2# AND X2# <= X1# THEN GOTO 159
155  X1# = T1#: X2# = T3#: X3# = T2#
     GOTO 4327
156  X1# = T2#: X2# = T3#: X3# = T1#
     GOTO 4327
157  X1# = T2#: X2# = T1#: X3# = T3#
     GOTO 4327
158  X1# = T3#: X2# = T1#: X3# = T2#
     GOTO 4327
159  X1# = T3#: X2# = T2#: X3# = T1#
     GOTO 4327


4327 GOTO 8000


8000 COTOT = 0: NORM = 0
     FOR I = 1 TO NF
                A1 = N1#(I) ^ 2: B1 = N1#(I) * S1#(I)
                A2 = N2#(I) ^ 2: B2 = N2#(I) * S2#(I)
                A3 = N3#(I) ^ 2: B3 = N3#(I) * S3#(I)
                A4 = 2 * N2#(I) * N3#(I): B4 = N2#(I) * S3#(I) + S2#(I) * N3#(I)
                A5 = 2 * N1#(I) * N3#(I): B5 = N3#(I) * S1#(I) + S3#(I) * N1#(I)
                A6 = 2 * N1#(I) * N2#(I): B6 = N1#(I) * S2#(I) + S1#(I) * N2#(I)
        SN = A1 * SX# + A2 * SY# + A3 * SZ# + A4 * SYZ# + A5 * SXZ# + A6 * SXY#
        SSH = B1 * SX# + B2 * SY# + B3 * SZ# + B4 * SYZ# + B5 * SXZ# + B6 * SXY#

22     NEXT I
     Y$ = ""
8171 SCON = SCON + 1:  NUMISLP = 0: KFC = 0
     FOR I = 1 TO NF
                RX = (N1#(I) * SX# + N2#(I) * SXY# + N3#(I) * SXZ#)
                RY = (N1#(I) * SXY# + N2#(I) * SY# + N3#(I) * SYZ#)
                RZ = (N1#(I) * SXZ# + N2#(I) * SYZ# + N3#(I) * SZ#)
                RP = SQR(RX ^ 2 + RY ^ 2 + RZ ^ 2)
        sign = N1#(I) * RX + N2#(I) * RY + N3#(I) * RZ
        SIGS = SQR(RP ^ 2 - sign ^ 2)
                        IF Y$ <> "" THEN LINE (0, 0)-(640, 148), 0, BF
                RXF = RX: RYF = RY: RZF = RZ
                RX = RX / RP: RY = RY / RP: RZ = RZ / RP
'****CALCULATION OF ANGLE BETWEEN OBSERVED AND CALCULATED MAXIMUM SHEAR
        B1 = N2#(I) * RZ - N3#(I) * RY
        B2 = N3#(I) * RX - N1#(I) * RZ
        B3 = N1#(I) * RY - N2#(I) * RX
        RB = SQR(B1 ^ 2 + B2 ^ 2 + B3 ^ 2)
        B1 = B1 / RB: B2 = B2 / RB: B3 = B3 / RB
     Q1 = N2#(I) * B3 - N3#(I) * B2
     Q2 = N3#(I) * B1 - N1#(I) * B3
     Q3 = N1#(I) * B2 - N2#(I) * B1
     RQ = SQR(Q1 ^ 2 + Q2 ^ 2 + Q3 ^ 2)
     Q1 = -Q1 / RQ: Q2 = -Q2 / RQ: Q3 = -Q3 / RQ
     ROTS# = (Q1 * S1#(I) + Q2 * S2#(I) + Q3 * S3#(I))

     IF ABS(ROTS#) >= 1 THEN ROTS# = .999999
     ROTS# = PI# / 2 - ATN(ROTS# / SQR(1 - ROTS# ^ 2))
     ROTS# = ABS(ROTS# * 180 / PI#)
     IF ROTS# > 90 THEN NUMISLP = NUMISLP + 1
     ROTSN# = (N1#(I) * S1#(I) + N2#(I) * S2#(I) + N3#(I) * S3#(I))
     IF ROTSN# = 1 THEN ROTSN# = .99999
     ROTSN# = (PI# / 2) - ATN(ROTSN# / SQR(1 - ROTSN# ^ 2))
     ROTSN# = ABS(ROTSN# * 180 / PI#)

     LOCATE 2, 1
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "Fault # "; I; "/"; NUMF; " :  Plane ";
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.#"; DF#(I);
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT CHR$(248); "/";
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.#"; DD#(I);
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT CHR$(248); ", slip axis: ";
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.#"; SP#(I);
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT CHR$(248); "/";
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.#"; ST#(I);
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT CHR$(248)

1385 IF A$ = AOUT$ OR A$ = XH$ THEN GOTO 1387
GOTO 1386
1387 IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "Preferred fault for strain ratio "; CHR$(224); " = ";
IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "##.## "; KS(I);
IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT " and friction angle of ";
IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "##.## "; PH(I);
IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT CHR$(248)
1386
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "Fault # "; I; " :  Plane "; DF#(I); CHR$(248); "/"; DD#(I); CHR$(248)
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "The slip direction of this fracture is not specified in input file."
IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "Angle between fault-normal and slip axis: ";
     COLOR (1)
IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.# "; ROTSN#;
IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT ; CHR$(248);
     COLOR (15)

 
9688    FLAG = 1
    IF S3#(I) < 0 THEN FLAG = 0
    N11# = -N1#(I): N22# = -N2#(I): N33# = -N3#(I)
    S11 = -S1#(I): S22 = -S2#(I): S33 = -S3#(I)
    RR# = SQR(N11# ^ 2 + N22# ^ 2)
    XN# = N22# * 150 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    YN# = 300 - N11# * 150 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    RS = SQR(S11 ^ 2 + S22 ^ 2)
    IF RS = 0 THEN RS = .000001
    XS# = -S22 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    YS# = 300 + S11 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN XS# = S22 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN YS# = 300 - S11 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    


 
95 IF MAP = 1 AND FRIC > 0 AND FC < FRIC THEN FCOL = 1
    IF MAP = 1 AND FRIC > 0 AND FC >= FRIC THEN FCOL = 8

    IF MAP = 2 AND ABS(sign) > ABS(PORE) THEN FCOL = 1
    IF MAP = 2 AND ABS(sign) <= ABS(PORE) THEN FCOL = 8

IF A$ = AOUT$ OR A$ = XH$ THEN FC1 = 15
IF A$ <> AOUT$ AND A$ <> XH$ THEN FC1 = 1
   
    IF SI$ = "" AND Y$ <> "" THEN PSET (300 + XFACT * XN#, YN#)
        AP = -ST#(I)
    IF SI$ = "" AND Y$ <> "" THEN DRAW "TA=" + VARPTR$(AP) + "NU20"
    IF SI$ = "" AND Y$ <> "" THEN CIRCLE (300 + XFACT * XN#, YN#), 1, FC1
    IF SI$ = "" AND Y$ <> "" THEN CIRCLE (300 + XFACT * XN#, YN#), 2, FC1


    DEL = 5
    IF DD#(I) < 268 THEN END1 = 270 - DD#(I) - DEL
    IF DD#(I) < 268 THEN START1 = 270 - DD#(I) + DEL
    IF DD#(I) >= 268 THEN END1 = 630 - DD#(I) - DEL
    IF DD#(I) >= 268 THEN START1 = 630 - DD#(I) + DEL
    IF END1 < START1 THEN S1 = END1
    IF END1 < START1 THEN E1 = START1
    IF END1 > START1 THEN S1 = START1
    IF END1 > START1 THEN E1 = END1
    IF E1 > 360 THEN E1 = E1 - 360

    RN1 = 150 * SQR(2) * SIN(DF#(I) * PI# / 360)
    IF SI$ = "" THEN GOTO 9687
    AP = 0: DRAW "TA=" + VARPTR$(AP)

    RT1 = RN1 - 7.5: RT2 = RN1 + 7.5
    IF RT1 < 3 THEN RT1 = 3
    IF RT2 < 3 THEN RT2 = 3
    IF RT1 > 149 THEN RT1 = 149
    IF RT2 > 149 THEN RT2 = 149

    IF SCON = 3 THEN DRAW "C=" + VARPTR$(FCOL)
    IF SCON = 3 THEN CIRCLE (300, 300), RT1, FCOL, -S1 * 2 * PI# / 360, E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT2, FCOL, S1 * 2 * PI# / 360, -E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT1, FCOL, S1 * 2 * PI# / 360, -E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT2, FCOL, -S1 * 2 * PI# / 360, E1 * 2 * PI# / 360

    X1 = 300 + XFACT * XN#: Y1 = YN#
    IF SCON = 3 THEN DRAW "BM=" + VARPTR$(X1) + ",=" + VARPTR$(Y1)
    IF SCON = 3 THEN DRAW "P=" + VARPTR$(FCOL) + ",=" + VARPTR$(FCOL)
    IF SCON = 5 THEN PSET (300 + XFACT * XN#, YN#), FCOL
    IF SCON = 5 AND SLA = 1 THEN CIRCLE (300 + XFACT * XN#, YN#), 1, 0
    AP = -ST#(I)
    IF SCON = 5 AND SLA = 1 THEN DRAW "TA=" + VARPTR$(AP) + "C0NU8"
9687 IF SI$ <> "" THEN GOTO 8190
     PRINT


     DR = 0


1901 IF SI = 1 AND SI$ = "" THEN INPUT "1-stop; 2-other options; 3- rotate fault results [CONTINUE PLOTTING] "; DR
     IF DR = 3 THEN CALL ROTATE(PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, TK1#, TK2#, TK3#, TL1#, TL2#, TL3#, TM1#, TM2#, TM3#)
   

     IF DR = 2 THEN GOTO 34
     IF DR = 1 THEN GOTO 8213

8190 NEXT I
33   SI = 1: Y$ = ""
                 IF FROT <> 99 THEN GOTO 1375
                 K1# = TK1#: K2# = TK2#: K3# = TK3#
                 L1# = TL1#: L2# = TL2#: L3# = TL3#
                 M1# = TM1#: M2# = TM2#: M3# = TM3#
        GOTO 1380
1375    K1# = S1P(1): K2# = S2P(1): K3# = S3P(1)
                 L1# = S1P(2): L2# = S2P(2): L3# = S3P(2)
                 M1# = S1P(3): M2# = S2P(3): M3# = S3P(3)
1380
CALL STEREO(FROT, YP$, AX1, AX2, AX3, MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)
34   LOCATE 1, 1
     LINE (0, 0)-(640, 148), 0, BF
     SCON = SCON + 1
     IF SCON = 4 AND SI$ = "M" THEN GOTO 8171
     IF SCON > 5 THEN SCON = 0
8119     IF SI = 1 THEN PRINT "D-open data file, X-exit, R-rotate results [ Plot faults in "; A$; " ] ";
    
     IF SI = 1 THEN INPUT Y$
     IF Y$ = "" THEN Y$ = "y"
     IF Y$ = "R" OR Y$ = "r" THEN GOTO 1901
     IF Y$ = "X" OR Y$ = "x" THEN GOTO 8212
     IF Y$ <> "" THEN LINE (0, 0)-(640, 148), 0, BF
     IF Y$ = "D" OR Y$ = "d" THEN GOTO 36

     IF SI = 1 THEN PRINT
     IF SI = 1 THEN PRINT
     IF Y$ = "Y" OR Y$ = "y" THEN GOTO 8171
8212 PRINT
     INPUT "Any key to exit [RETURN] "; Y$
     IF Y$ = "" THEN GOTO 8119
8213  PRINT
      INPUT "Want to find the best-fit strain rate and friction angle [NO] "; OPT$
     IF OPT$ <> "" THEN CALL OPTIMUM(PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#)
     GOTO 8119
      CLS : END

SUB DIRECT (K1, K2, K3, DIP, ALPHA)
PI = 4 * ATN(1)
'Print tk1, tk2, tk3
   'If tk2 > 90 Then tk2 = tk2 - 180
        'If tk3 > 90 Then tk3 = tk3 - 180
          
     'K1 = COS(tk2 * pi / 180)
     'K2 = COS(tk3 * pi / 180)
     'K3 = COS(tk1 * pi / 180)
     'Print tk1, tk2, tk3, K1, K2, K3
     sumk = K1 ^ 2 + K2 ^ 2 + K3 ^ 2
     ALPH = ATN(K2 / K1)
     'Print ALPHA * 180 / pi, K1, K2, K3
     IF K1 < 0 THEN ALPH = PI + ALPH
     IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPH = INT(100# * 180# * ALPH / PI) / 100#
     IF ALPH > 360# THEN ALPH = ALPH - 360#
     IF ALPH < 0 THEN ALPH = 360# + ALPH
     IF K3 = 1 THEN K3 = .9999999000000001#
     DI = ATN(K3 / SQR(1 - K3 ^ 2))
     DI = INT(100# * 180# * DI / PI) / 100#
     DIP = DI
     ALPHA = ALPH



END SUB

SUB OPTIMUM (PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#)
 CLS
 PI = 4! * ATN(1!)
 SIZE = 500
   DIM DFP(SIZE), DDP(SIZE), SPP(SIZE), STP(SIZE), K1(SIZE), F1(SIZE), OPT(SIZE)
   DIM DFF(SIZE), DDF(SIZE), SPF(SIZE), STF(SIZE)
   DIM N1P(SIZE), N2P(SIZE), N3P(SIZE), S1P(SIZE), S2P(SIZE), S3P(SIZE)
   DIM N1F(SIZE), N2F(SIZE), N3F(SIZE), S1F(SIZE), S2F(SIZE), S3F(SIZE)
  PRINT
  PRINT
  PRINT "The program will search now for the preferred fault with its slip axis"
  PRINT "  that best fit a set of faults measure in the field."
  PRINT
  PRINT "Enter filename with preferred faults (with or without rotation) ["; XH$; "]";
  INPUT XH1$
  IF XH1$ <> "" THEN XH$ = XH1$
  INPUT "Enter filename with field data [DIXIE]"; F1$
  F$ = "DIXIE"
  IF F1$ <> "" THEN F$ = F1$
  XOUT$ = F$ + ".OPT"
  PRINT "Enter filename for ouput ["; XOUT$; "]";
  INPUT XOUT1$
  IF XOUT1$ <> "" THEN XOUT$ = XOUT1$

CLOSE
B$ = "OPTALL.TXT"

OPEN XH$ FOR INPUT AS #2
OPEN F$ FOR INPUT AS #3
    INPUT #2, NR2
    INPUT #3, NR3
    FOR I = 1 TO NR2
    INPUT #2, DFP(I), DDP(I), SPP(I), STP(I), K1(I), F1(I)
    N1P(I) = COS(DDP(I) * PI# / 180) * SIN(DFP(I) * PI# / 180)
    N2P(I) = SIN(DDP(I) * PI# / 180) * SIN(DFP(I) * PI# / 180)
    N3P(I) = COS((180 - DFP(I)) * PI# / 180)
    S1P(I) = COS(STP(I) * PI# / 180) * SIN((SPP(I) + 90) * PI# / 180)
    S2P(I) = SIN(STP(I) * PI# / 180) * SIN((SPP(I) + 90) * PI# / 180)
    S3P(I) = -COS((SPP(I) + 90) * PI# / 180)
    NEXT I
   
    FOR I = 1 TO NR3
    INPUT #3, DFF(I), DDF(I), SPF(I), STF(I)
    N1F(I) = COS(DDF(I) * PI# / 180) * SIN(DFF(I) * PI# / 180)
    N2F(I) = SIN(DDF(I) * PI# / 180) * SIN(DFF(I) * PI# / 180)
    N3F(I) = COS((180 - DFF(I)) * PI# / 180)
    S1F(I) = COS(STF(I) * PI# / 180) * SIN((SPF(I) + 90) * PI# / 180)
    S2F(I) = SIN(STF(I) * PI# / 180) * SIN((SPF(I) + 90) * PI# / 180)
    S3F(I) = -COS((SPF(I) + 90) * PI# / 180)
    NEXT I
CLOSE
OPEN XOUT$ FOR OUTPUT AS #3
   
   
    PRINT #3, NR2
    
    FOR K = 1 TO NR2 STEP 4
    OPT = 0
    FOR J = 1 TO NR3
    OPTMAX = 0: OPT1 = 0: OPT2 = 0: OPT3 = 0: OPT4 = 0

    I = K

    OPT1 = N1F(J) * N1P(I) + N2F(J) * N2P(I) + N3F(J) * N3P(I) + S1F(J) * S1P(I) + S2F(J) * S2P(I) + S3F(J) * S3P(I)
    I = K + 1
    OPT2 = N1F(J) * N1P(I) + N2F(J) * N2P(I) + N3F(J) * N3P(I) + S1F(J) * S1P(I) + S2F(J) * S2P(I) + S3F(J) * S3P(I)
    I = K + 2
    OPT3 = N1F(J) * N1P(I) + N2F(J) * N2P(I) + N3F(J) * N3P(I) + S1F(J) * S1P(I) + S2F(J) * S2P(I) + S3F(J) * S3P(I)
    I = K + 3
    OPT4 = N1F(J) * N1P(I) + N2F(J) * N2P(I) + N3F(J) * N3P(I) + S1F(J) * S1P(I) + S2F(J) * S2P(I) + S3F(J) * S3P(I)
    IF OPT1 > OPTMAX THEN OPTMAX = OPT1
    IF OPT2 > OPTMAX THEN OPTMAX = OPT2
    IF OPT3 > OPTMAX THEN OPTMAX = OPT3
    IF OPT4 > OPTMAX THEN OPTMAX = OPT4
    OPT = OPT + OPTMAX
    NEXT J
    OPT(K) = OPT
    NEXT K
  
 M = 1: OMAX = 0
    FOR I = 1 TO NR2
    IF OPT(I) > OMAX THEN M = I
    IF OPT(I) > OMAX THEN OMAX = OPT(I)
    PRINT #3, DFP(I), DDP(I), SPP(I), STP(I), K1(I), F1(I), OPT(I) / (NR3 * 2)
    NEXT I
    CLOSE

    OPEN B$ FOR APPEND AS #3
100
CLS
PRINT
PRINT "In search for the best fit under these principal axes:"
PRINT "  Maximum shortening  E1: ";
PRINT USING "###.#"; PL(1);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(1);
PRINT CHR$(248)
PRINT "  Intermediate strain E2: ";
PRINT USING "###.#"; PL(2);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(2);
PRINT CHR$(248)
PRINT "  Maximum extension   E3: ";
PRINT USING "###.#"; PL(3);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(3);
PRINT CHR$(248)
PRINT
PRINT "The program calcualtes the angles between OBSERVED fault-normal"
PRINT "  of each data point in "; F$; " and THEORETICAL fault-normal of faults"
PRINT "  (rotated or not) in "; XH$; ".  Similarly, angles are calculated"
PRINT "  between OBSERBVED and THEORETICAL slip-axes in these files."
PRINT "These angles are the MISFIT ANGLES."
PRINT
PRINT "The strain state and friction angle with the SMALLEST MEAN MISFIT ANGLE"
PRINT "  are considered the BEST solution for the above strain axes."
PRINT
PRINT "For the present case, best solution is:"
     PRINT "  Plane: ";
     PRINT USING "###.#"; DFP(M);
     PRINT CHR$(248); "/";
     PRINT USING "###.#"; DDP(M);
     PRINT CHR$(248); ", and slip axis of: ";
     PRINT USING "###.#"; SPP(M);
     PRINT CHR$(248); " / ";
     PRINT USING "###.#"; STP(M);
     PRINT CHR$(248)
     PRINT " (three additional faults in orthorhombic symmetry fit the same strain state)"

PRINT "This fault is for strain ratio "; CHR$(224); "=";
PRINT USING "##.## "; K1(M);
PRINT " and friction angle of ";
PRINT USING "##.## "; F1(M);
PRINT CHR$(248)
'PRINT "The optimization factor should be as close to 1.  For this case it is ";
'PRINT USING " #.### "; OPT(M) / (NR3 * 2)

AMIS = OPT(M) / (NR3 * 2)
AMIS = (PI / 2) - ATN(AMIS / SQR(1# - AMIS ^ 2))
PRINT "Mean misfit angle: ";
PRINT USING " ###.## "; AMIS * 180 / PI;
PRINT CHR$(248)

PRINT #3, DATE$, TIME$, F$;
PRINT #3, USING " ###.### "; DFP(M), DDP(M), SPP(M), STP(M), K1(M), F1(M), OPT(M) / (NR2 * 2), AMIS * 180 / PI, PL(1), ST(1), PL(2), ST(2), PL(3), ST(3)
PRINT
PRINT "Best-fit results of all run are appended to OPTALL.TXT with this format:"
PRINT "  date, time, field data file, preferred fault: dip/dip direction + plung/trend"
PRINT "  slip axis, strain ratio, friction angle, optimizing factor, mean misfit angle,"
PRINT "  plunge / trend of the three principal starin axes."

CLOSE
PRINT
INPUT "Return for another try; any key to exit [CONTINUE] "; Y$

IF Y$ <> "" THEN STOP

END SUB

SUB ROTATE (PL(), ST(), AOUT$, XH$, FROT, AX1, AX2, AX3, PI#, K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#)
60 CLS
        FROT = 99
        SIZE = 500
   DIM DF#(SIZE), DD#(SIZE), SP#(SIZE), ST#(SIZE)
   DIM N1#(SIZE), N2#(SIZE), N3#(SIZE), S1#(SIZE), S2#(SIZE), S3#(SIZE), SPS(SIZE), IFAULT(SIZE)
   DIM K1(SIZE), F1(SIZE), DFR(SIZE), DDR(SIZE), SPR(SIZE), STR(SIZE), SRR(SIZE)
   DIM NA1(5), NA2(5), NA3(5), N1I(SIZE), N2I(SIZE), N3I(SIZE)
    A$ = AOUT$
    XH$ = A$ + ".ROT"

FOR I = 1 TO 3
NA1(I) = .0000001#: NA2(I) = .00000001#: NA3(I) = .00000001#
NEXT I
AXX = .9999999899999999#
IF AX1 = 1 THEN NA1(1) = AXX
IF AX2 = 1 THEN NA1(2) = AXX
IF AX3 = 1 THEN NA1(3) = AXX
IF AX1 = 2 THEN NA2(1) = AXX
IF AX2 = 2 THEN NA2(2) = AXX
IF AX3 = 2 THEN NA2(3) = AXX
IF AX1 = 3 THEN NA3(1) = AXX
IF AX2 = 3 THEN NA3(2) = AXX
IF AX3 = 3 THEN NA3(3) = AXX

K1 = NA1(1): K2 = NA2(1): K3 = NA3(1)
L1 = NA1(2): L2 = NA2(2): L3 = NA3(2)
M1 = NA1(3): M2 = NA2(3): M3 = NA3(3)

CALL DIRECT(K1, K2, K3, PL(1), ST(1))
CALL DIRECT(L1, L2, L3, PL(2), ST(2))
CALL DIRECT(M1, M2, M3, PL(3), ST(3))


BF = 20: BD = 60

PRINT "Faults and slip axes are rotated according to the following rotation rules."
PRINT "1. Rotation about a vertical axis; clockwise rotation is positive."
PRINT "2. After stage 1., retilting of a virtual in these steps:"
PRINT "  a. Select DIP AMOUNT and DIP DIRECTION of a virtual layer. "
PRINT "  b. The tilted layer will be rotated back to horizontality around the"
PRINT "     strike and by the dip amount."
PRINT "   "
PRINT "Enter angle of rotation about a vertical axis (-90"; CHR$(248); " to 90"; CHR$(248); ") [0] ";
INPUT VERT
IF VERT = 0 THEN GOTO 88
        CLOSE
  T$ = "TEMP1"
OPEN A$ FOR INPUT AS #2
OPEN T$ FOR OUTPUT AS #3

    INPUT #2, NR
    PRINT #3, NR
    FOR I = 1 TO NR
    INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I), K1(I), F1(I)
    DD#(I) = DD#(I) + VERT: ST#(I) = ST#(I) + VERT
    IF ST#(I) > 360 THEN ST#(I) = ST#(I) - 360
    IF ST#(I) < 0 THEN ST#(I) = ST#(I) + 360
    IF DD#(I) > 360 THEN DD#(I) = DD#(I) - 360
    IF DD#(I) < 0 THEN DD#(I) = DD#(I) + 360
    PRINT #3, DF#(I), DD#(I), SP#(I), ST#(I), K1(I), F1(I)
    NEXT I
CLOSE
IF PL(1) < 80 THEN ST(1) = ST(1) + VERT
IF PL(2) < 80 THEN ST(2) = ST(2) + VERT
IF PL(3) < 80 THEN ST(3) = ST(3) + VERT
FOR I = 1 TO 3
    IF ST(I) > 360 THEN ST(I) = ST(I) - 360
    IF ST(I) < 0 THEN ST(I) = ST(I) + 360
NEXT I


88 PRINT "Enter DIP AMOUNT ["; BF; "] ";
INPUT BF1
IF BF1 <> 0 THEN BF = BF1

PRINT "Enter DIP DIRECTION ["; BD; "] ";
INPUT BD1
IF BD1 <> 0 THEN BD = BD1
41 PI# = 4 * ATN(1!): COUNT = 0: PI = PI#
   NA = 0
    typed = 1
200 REM **** Reading the data file*********
        CLOSE
220 IF VERT = 0 THEN OPEN A$ FOR INPUT AS #2
    IF VERT <> 0 THEN OPEN T$ FOR INPUT AS #2
225 OPEN XH$ FOR OUTPUT AS #3

    INPUT #2, NR
230 FOR I = 1 TO NR
    KP = 0
240 INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I), K1(I), F1(I)
    IF BD = 0 OR BD = 360 THEN BD = .01
    IF BD = 90 THEN BD = 90.01
    IF BD = 180 THEN BD = 180.01
    IF BD = 270 THEN BD = 270.01
   
    IF ST#(I) = 0 OR ST#(I) = 360 THEN ST#(I) = .01
    IF ST#(I) = 90 THEN ST#(I) = 90.01
    IF ST#(I) = 180 THEN ST#(I) = 180.01
    IF ST#(I) = 270 THEN ST#(I) = 270.01
    IF DD#(I) = 0 OR DD#(I) = 360 THEN DD#(I) = .01
    IF DD#(I) = 90 THEN DD#(I) = 90.01
    IF DD#(I) = 180 THEN DD#(I) = 180.01
    IF DD#(I) = 270 THEN DD#(I) = 270.01
    NEXT I
    DF#(NR + 1) = PL(1): DD#(NR + 1) = ST(1): SP#(NR + 1) = PL(1): ST#(NR + 1) = ST(1)
    DF#(NR + 2) = PL(2): DD#(NR + 2) = ST(2): SP#(NR + 2) = PL(2): ST#(NR + 2) = ST(2)
    DF#(NR + 3) = PL(3): DD#(NR + 3) = ST(3): SP#(NR + 3) = PL(3): ST#(NR + 3) = ST(3)


    FOR I = 1 TO NR + 3
    N1#(I) = COS(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N2#(I) = SIN(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N3#(I) = COS((180 - DF#(I)) * PI# / 180)
    S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S3#(I) = -COS((SP#(I) + 90) * PI# / 180)
  
N1I(I) = N1#(I): N2I(I) = N2#(I): N3I(I) = N3#(I)
    SPS(I) = S3#(I)
    NEXT I
   
    CLOSE #2

355
    BN1 = -(COS(BD * PI# / 180) * SIN(BF * PI# / 180))
    BN2 = -(SIN(BD * PI# / 180) * SIN(BF * PI# / 180))
    BN3 = -(COS((180 - BF) * PI# / 180))
    IF BD < 90 THEN BALP = BD
    IF BD >= 90 AND BD < 270 THEN BALP = 180 - BD
    IF BD >= 270 THEN BALP = BD - 360
    SDIP = COS(BALP * PI / 180) * SIN(BF * PI / 180)
    ALPN = SQR(1 - SDIP ^ 2)
    ALPN = ATN(-ALPN / SQR(1 - ALPN ^ 2)) + PI / 2
    BETA = TAN(ALPN) / TAN(BF * PI / 180)
    BETA = ATN(-BETA / SQR(1 - BETA * BETA)) + PI / 2
    IF BD <= 90 THEN BETA = BD * PI / 180 - BETA
    IF BD > 90 AND BD <= 180 THEN BETA = BD * PI / 180 + BETA
    IF BD > 180 AND BD <= 270 THEN BETA = BD * PI / 180 - BETA
    IF BD > 270 THEN BETA = BD * PI / 180 + BETA
  
    FBD = 1
    IF BD >= 90 AND BD <= 270 THEN FBD = -1
    BS1 = FBD * (COS(BETA) * SIN(ALPN + PI / 2))
    BS2 = FBD * (SIN(BETA) * SIN(ALPN + PI / 2))
    BS3 = -FBD * COS(ALPN + PI / 2)
    BB1 = BN2 * BS3 - BN3 * BS2
    BB2 = BN3 * BS1 - BN1 * BS3
    BB3 = BN1 * BS2 - BN2 * BS1


    FOR I = 1 TO NR + 3

    N1T = N1#(I): N2T = N2#(I): N3T = N3#(I)
    S1T = S1#(I): S2T = S2#(I): S3T = S3#(I)
    N1#(I) = N1T * BS1 + N2T * BS2 + N3T * BS3
    N2#(I) = (N1T * BB1 + N2T * BB2 + N3T * BB3)
    N3#(I) = (N1T * BN1 + N2T * BN2 + N3T * BN3)
    S1#(I) = S1T * BS1 + S2T * BS2 + S3T * BS3
    S2#(I) = (S1T * BB1 + S2T * BB2 + S3T * BB3)
    S3#(I) = (S1T * BN1 + S2T * BN2 + S3T * BN3)

    T33 = -ATN(N3#(I) / SQR(1 - N3#(I) * N3#(I))) + PI / 2
'PRINT I, S3#(I), SQR(1 - S3#(I) * S3#(I))
    TS33 = ATN(S3#(I) / SQR(1 - S3#(I) * S3#(I)))
    T33 = T33 * 180 / PI
    TS33 = TS33 * 180 / PI
    IF T33 > 90 THEN T33 = 180 - T33
    DFR(I) = T33
    SPR(I) = TS33
250 K1 = S1#(I): K2 = S2#(I): K3 = S3#(I)
255 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    STR(I) = ALPHA
    TSB33 = ATN(BS3 / SQR(1 - BS3 ^ 2))
    SPB = TSB33 * 180 / PI
    K1 = BS1: K2 = BS2: K3 = BS3
    IF BS3 > 0 THEN GOTO 955
    K1 = -BS1: K2 = -BS2: K3 = -BS3
955 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    STB = ALPHA
260 K1 = N1#(I): K2 = N2#(I): K3 = N3#(I)


    IF N3#(I) < 0 THEN GOTO 262
    K1 = -N1#(I): K2 = -N2#(I): K3 = -N3#(I)
262 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    DDR(I) = ALPHA
    N1#(I) = COS(DDR(I) * PI# / 180) * SIN(DFR(I) * PI# / 180)
    N2#(I) = SIN(DDR(I) * PI# / 180) * SIN(DFR(I) * PI# / 180)
    N3#(I) = COS((180 - DFR(I)) * PI# / 180)
    S1#(I) = COS(STR(I) * PI# / 180) * SIN((SPR(I) + 90) * PI# / 180)
    S2#(I) = SIN(STR(I) * PI# / 180) * SIN((SPR(I) + 90) * PI# / 180)
    S3#(I) = -COS((SPR(I) + 90) * PI# / 180)

COSR = N1#(I) * N1I(I) + N2#(I) * N2I(I) + N3#(I) * N3I(I)
SRR(I) = 1
IF COSR < 0 THEN SRR(I) = 0
    NEXT I
   
PRINT
INPUT "To display rotation results on screen-hit any key [NO DISPLAY] "; CNN$
PRINT
    PRINT #3, NR
    KP = 1
  
    FOR I = 1 TO NR + 3
    RT = ABS(S1#(I) * N1#(I) + S2#(I) * N2#(I) + S3#(I) * N3#(I))
    IF RT >= 1 THEN RT = .99999
    RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
    RT = ABS(RT * 180 / PI#)
    DIF = ABS(ST#(I) - DD#(I))
    IF ST#(I) = DD#(I) THEN SENSE$ = "     NORMAL     "
    IF ST#(I) > DD#(I) AND DIF <= 45 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) > DD#(I) AND DIF = 90 THEN SENSE$ = "     DEXTRAL     "
    IF ST#(I) > DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) > DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE      "
    IF ST#(I) > DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) > DD#(I) AND DIF = 270 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) > DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) > DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    IF ST#(I) < DD#(I) AND DIF <= 45 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) < DD#(I) AND DIF = 90 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) < DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE    "
    IF ST#(I) < DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) < DD#(I) AND DIF = 270 THEN SENSE$ = "     DEXTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) < DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    IF CNN$ <> "" THEN PRINT
320
    IF CNN$ <> "" THEN PRINT "Case # "; I; "  Fault plane:    Slip axes:       Sense of slip:   Bedding:"
    IF CNN$ <> "" THEN PRINT "Original:   ";
    IF CNN$ <> "" THEN PRINT USING "##"; INT(DF#(I) + .5);
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###        "; INT(DD#(I) + .5);
    IF CNN$ <> "" THEN PRINT USING " ###"; INT(SP#(I) + .5);
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###          "; INT(ST#(I) + .5);
    IF CNN$ <> "" THEN PRINT SENSE$;
    IF CNN$ <> "" THEN PRINT USING "   ##"; BF;
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###"; BD
    DIF = ABS(STR(I) - DDR(I))
    IF STR(I) = DDR(I) THEN SENSER$ = "     NORMAL     "
    IF STR(I) > DDR(I) AND DIF <= 45 THEN SENSER$ = " NORMAL-DEXTRAL "
    IF STR(I) > DDR(I) AND DIF > 45 AND DIF < 90 THEN SENSER$ = " DEXTRAL-NORMAL "
    IF STR(I) > DDR(I) AND DIF = 90 THEN SENSER$ = "    DEXTRAL    "
    IF STR(I) > DDR(I) AND DIF > 90 AND DIF < 135 THEN SENSER$ = " DEXTRAL-REVERSE "
    IF STR(I) > DDR(I) AND DIF >= 135 AND DIF < 180 THEN SENSER$ = " REVERSE-DEXTRAL "
    IF STR(I) > DDR(I) AND DIF = 180 THEN SENSER$ = "    REVERSE    "
    IF STR(I) > DDR(I) AND DIF > 180 AND DIF < 225 THEN SENSER$ = "REVERSE-SINISTRAL"
    IF STR(I) > DDR(I) AND DIF >= 225 AND DIF < 270 THEN SENSER$ = "SINISTRAL-REVERSE"
    IF STR(I) > DDR(I) AND DIF = 270 THEN SENSER$ = "   SINISTRAL   "
    IF STR(I) > DDR(I) AND DIF > 270 AND DIF < 315 THEN SENSER$ = "SINISTRAL-NORMAL"
    IF STR(I) > DDR(I) AND DIF >= 315 AND DIF < 360 THEN SENSER$ = "NORMAL-SINISTRAL"
    IF STR(I) > DDR(I) AND DIF = 360 THEN SENSER$ = "     NORMAL     "
    IF STR(I) < DDR(I) AND DIF <= 45 THEN SENSER$ = "NORMAL-SINISTRAL"
    IF STR(I) < DDR(I) AND DIF > 45 AND DIF < 90 THEN SENSER$ = "SINISTRAL-NORMAL"
    IF STR(I) < DDR(I) AND DIF = 90 THEN SENSER$ = "   SINISTRAL   "
    IF STR(I) < DDR(I) AND DIF > 90 AND DIF < 135 THEN SENSER$ = "SINISTRAL-REVERSE"
    IF STR(I) < DDR(I) AND DIF >= 135 AND DIF < 180 THEN SENSER$ = "REVERSE-SINISTRAL"
    IF STR(I) < DDR(I) AND DIF = 180 THEN SENSER$ = "    REVERSE     "
    IF STR(I) < DDR(I) AND DIF > 180 AND DIF < 225 THEN SENSER$ = " REVERSE-DEXTRAL "
    IF STR(I) < DDR(I) AND DIF >= 225 AND DIF < 270 THEN SENSER$ = " DEXTRAL-REVERSE "
    IF STR(I) < DDR(I) AND DIF = 270 THEN SENSER$ = "    DEXTRAL    "
    IF STR(I) < DDR(I) AND DIF > 270 AND DIF < 315 THEN SENSER$ = " DEXTRAL-NORMAL "
    IF STR(I) < DDR(I) AND DIF >= 315 AND DIF < 360 THEN SENSER$ = " NORMAL-DEXTRAL "
    IF STR(I) < DDR(I) AND DIF = 360 THEN SENSER$ = "     NORMAL     "
  
    IF CNN$ <> "" THEN PRINT "Retilted:   ";
    IF CNN$ <> "" THEN PRINT USING "##"; INT(DFR(I) + .5);
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###        "; INT(DDR(I) + .5);

    FLAGS = 1
'    IF SPS(I) * S3#(I) < 0 THEN FLAGS = 0
    IF SRR(I) = 0 THEN FLAGR = 0
    IF SRR(I) = 1 THEN FLAGR = 1
    IF FLAGR <> FLAGS THEN SPR(I) = -SPR(I)
    IF FLAGR <> FLAGS THEN STR(I) = STR(I) + 180
    IF STR(I) > 360 AND FLAGR <> FLAGS THEN STR(I) = STR(I) - 360
   
   
    IF CNN$ <> "" THEN PRINT USING " ###"; INT(SPR(I) + .5);
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###          "; INT(STR(I) + .5);
    IF CNN$ <> "" THEN PRINT SENSER$;
    IF CNN$ <> "" THEN PRINT USING "   ##"; BF;
    IF CNN$ <> "" THEN PRINT "/";
    IF CNN$ <> "" THEN PRINT USING "###"; BD
    IF CNN$ <> "" THEN PRINT
   

    IF I > NR THEN GOTO 644
    IF CNN$ <> "" THEN INPUT "Is the RELATIVE SENSE of slip OK (any key to change) [YES] "; CON$
    IF CON$ = "" THEN GOTO 644
  
    SPR(I) = -SPR(I)
    STR(I) = STR(I) + 180
    IF STR(I) > 360 THEN STR(I) = STR(I) - 360
    GOTO 320
644 IF I <= NR THEN PRINT #3, USING " ####.## "; INT(DFR(I) + .5), INT(DDR(I) + .5), INT(SPR(I) + .5), INT(STR(I) + .5), K1(I), F1(I)
  
    IF I = NR + 1 THEN K1# = S1#(I)
    IF I = NR + 1 THEN K2# = S2#(I)
    IF I = NR + 1 THEN K3# = S3#(I)
    IF I = NR + 2 THEN L1# = S1#(I)
    IF I = NR + 2 THEN L2# = S2#(I)
    IF I = NR + 2 THEN L3# = S3#(I)
    IF I = NR + 3 THEN M1# = S1#(I)
    IF I = NR + 3 THEN M2# = S2#(I)
    IF I = NR + 3 THEN M3# = S3#(I)


    NEXT I
    GOTO 670
665 PRINT
    PRINT "Error in computation.  You can restart."
    PRINT
670 CLOSE

K1 = K1#: K2 = K2#: K3 = K3#
L1 = L1#: L2 = L2#: L3 = L3#
M1 = M1#: M2 = M2#: M3 = M3#


CALL DIRECT(K1, K2, K3, PL(1), ST(1))
CALL DIRECT(L1, L2, L3, PL(2), ST(2))
CALL DIRECT(M1, M2, M3, PL(3), ST(3))
PRINT
PRINT "The selected rotation yield the following orientations of the principal axes:"
PRINT "  Maximum shortening  E1: ";
PRINT USING "###.#"; PL(1);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(1);
PRINT CHR$(248)
PRINT "  Intermediate strain E2: ";
PRINT USING "###.#"; PL(2);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(2);
PRINT CHR$(248)
PRINT "  Maximum extension   E3: ";
PRINT USING "###.#"; PL(3);
PRINT CHR$(248); "/";
PRINT USING "###.#"; ST(3);
PRINT CHR$(248)
PRINT
INPUT "Want to re-run rotation with different angles [NO] "; RR$
IF RR$ <> "" THEN GOTO 60
PRINT
CLOSE

CLS

END SUB

SUB STEREO (FROT, YP$, AX1, AX2, AX3, MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)
IF YP$ <> "" THEN GOTO 140
IF FROT = 99 THEN GOTO 140
K1T# = K1#: K2T# = K2#: K3T# = K3#
L1T# = L2#: L2T# = L2#: L3T# = L3#
M1T# = M1#: M2T# = M2#: M3T# = M3#
IF AX1 = 1 THEN GOTO 111
IF AX1 = 2 THEN GOTO 112
IF AX1 = 3 THEN GOTO 113
111 K1# = .9999: K2# = .0001: K3# = .0001
GOTO 120
112 K1# = .0001: K2# = .9999: K3# = .0001
GOTO 120
113 K1# = .0001: K2# = .0001: K3# = .9999

120
IF AX2 = 1 THEN GOTO 121
IF AX2 = 2 THEN GOTO 122
IF AX2 = 3 THEN GOTO 123
121 L1# = .9999: L2# = .0001: L3# = .0001
GOTO 130
122 L1# = .0001: L2# = .9999: L3# = .0001
GOTO 130
123 L1# = .0001: L2# = .0001: L3# = .9999

130
IF AX3 = 1 THEN GOTO 131
IF AX3 = 2 THEN GOTO 132
IF AX3 = 3 THEN GOTO 133
131 M1# = .9999: M2# = .0001: M3# = .0001
GOTO 140
132 M1# = .0001: M2# = .9999: M3# = .0001
GOTO 140
133 M1# = .0001: M2# = .0001: M3# = .9999
GOTO 140
140

'  The stereographic projection
'  The circle
    FOR I = 1 TO 720
    ANN = 2 * PI# / 720
    AN = ANN * I
    X = 150 * SIN(AN)
    Y = 150 * COS(AN)
    X = 300 + XFACT * X
    Y = 300 + Y
    PSET (X, Y)
    NEXT I
661 LINE (300 - 150 * XFACT, 300)-(300 + 150 * XFACT, 300)
    LINE (300, 150)-(300, 450)
 GOTO 807
'   Printing (on screen) the stress results on screen
   
880  IF MAP = 2 THEN GOTO 881
     IF FRIC < 0 AND MAP = 0 THEN GOTO 882
     LOCATE 12, 1
     PRINT "SHEAR/NORMAL cut-off:";
     PRINT USING "#.# "; FRIC
     PRINT "BLUE:shear/normal >";
     PRINT USING "#.# "; FRIC
     PRINT "RED:shear/normal <";
     PRINT USING "#.# "; FRIC
     GOTO 882
881  LOCATE 12, 1
     PRINT "PORE PRESSURE:";
     PRINT USING " ##.# "; PORE
     PRINT "BLUE:"; CHR$(229); "n <";
     PRINT USING " ##.# "; PORE;
    PRINT " dilated"
     PRINT "RED:"; CHR$(229); "n >";
     PRINT USING " ##.# "; PORE;
     PRINT " tight"

882 LOCATE 24, 1
    PRINT "Pore pressure="; PORE
    KD = 1
    PRINT ""; CHR$(229); "-1";
     PRINT USING " ##"; DAT(10);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(11);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(7)
     PRINT ""; CHR$(229); "-2";
     PRINT USING " ##"; DAT(12);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(13);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(8)
     PRINT ""; CHR$(229); "-3";
     PRINT USING " ##"; DAT(14);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(15);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(9)
807
LOCATE 25, 1: PRINT "File: "; A$
    LOCATE 1, 1
    'PRINT "Hit any key to continue "
    LOCATE 25, 60: PRINT "Equal area plot."
    LOCATE 26, 52: PRINT "Green dot-expected fault pole"
    LOCATE 27, 50: PRINT "Red dot-observed fault pole"
    LOCATE 28, 48: PRINT "Green line-slip axis trend"
    LOCATE 21, 58: IF FRIC < 0 AND MAP = 0 THEN PRINT "Intensity of ratio:"
    LOCATE 22, 57: IF FRIC < 0 AND MAP = 0 THEN PRINT "T={shear/(normal-pore)}"
'    LOCATE 28, 50: PRINT "Expected slip-black line+dot"
'     Stereoplot of the principal stresses with the fracture data.
'     Three tensor are presented: the least-square and the confidence level.
'
4820 C1 = K1#: C2 = K2#: C3 = K3#: F = 1
4830 IF C3 > 0 THEN GOTO 4850
     C1 = -C1: C2 = -C2: C3 = -C3
4850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 150 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 300 - C1 * 150 * SQR(2) * SIN(TAX / 2) / RR#
     IF F = 3 THEN GOTO 4980
     IF F <> 1 THEN GOTO 4940
     X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 5)
      AP = 0
      DRAW "TA=" + VARPTR$(AP)
'DRAW "L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
DRAW "L8D5R8L8D5R8"
      PSET (X + 8, Y + 2)
      DRAW "D5L1U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 4830
4940 IF F <> 2 THEN GOTO 4960
     X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 5)
      'DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      DRAW "L8D5R8L8D5R8"
      PSET (X + 8, Y + 3)
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
4960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 4830
4980 X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 5)
      'DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      DRAW "L8D5R8L8D5R8"
      PSET (X + 8, Y + 3)
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
END SUB

