30 CLS
    COLOR (4)
    LOCATE 1, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 2, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 3, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I



    LOCATE 2, 35
    COLOR (15)
    PRINT "RETILT"
    LOCATE 5, 1
    COLOR (2): PRINT "                Entering and retilting oriented field data "
    COLOR (6)
    PRINT "                   A QuickBasic program by Ze'ev Reches"
    PRINT "                          Version 1.7 November, 2000"
    PRINT
    COLOR (15)

   DIM E#(6, 6), F#(6), R#(100), R2#(100), X#(6), CO(100), COMIN(100)
   DIM DF#(100), DD#(100), SP#(100), ST#(100), SS(100), FC(100)
   DIM N1#(100), N2#(100), N3#(100), S1#(100), S2#(100), S3#(100), IFAULT(100)
   DIM A#(100, 6), B1#(100), B2#(100), B3#(100), B#(100), ROTAT(100)
   DIM BW(10), BW1(10), BW2(10), BD(100), BF(100), DFR(100), DDR(100), SPR(100), STR(100)
40 PI# = 4 * ATN(1!): COUNT = 0: PI = PI#
   NA = 0
   PRINT
PRINT "The program is used for two purposes. First, to enter oriented field data "
PRINT "    in a format that fits SoftStructure programs (STRESS and SHEAR). "
PRINT "    Second, to rotate oriented field data about the strike of the host layer"
PRINT "    and by the amount of the host layer dip."
PRINT "Data format is given below; to prepare your own text file (*.BED) see"
PRINT "    in Help menu of SoftStructure under 'Stress Inversion:STRESS, RETILT."
PRINT "Once field file (with extension *.BED) is ready, it can be re-entered for "
PRINT "    retilting only (to generate *.RTL file)."
PRINT
INPUT "Continute [YES]"; OK
CLS
    PRINT
    PRINT "Data format for surfaces (layers, veins..):"
    PRINT "   DIP amount (0 to 90 degrees from the horizon),"
    PRINT "   DIP DIRECTION (0-360 degrees clockwise from north)."
    PRINT "Data format for vectors or axes (slip directions, stylolites...):"
    PRINT "   PLUNGE amount: (0 to 90 degrees from the horizon for DOWNWARD pointing"
    PRINT "                     axes such as slip axis along a normal fault),"
    PRINT "                  (0 to -90 degrees from the horizon for UPWARD pointing"
    PRINT "                     axes such as slip axis along a reverse fault)"
    PRINT "   TREND (0-360 degrees clockwise from north)."
    PRINT

PRINT "Data entering:"
PRINT "         1. Enter FILEMANE (e.g., *.BED) with original field data that you wish"
PRINT "            to be rotated, or,"
INPUT "         2. [Hit return to enter raw field data from keyboard] "; A$
    PRINT
    PRINT "Type of data (in input file or to be entered by keyboard): "
    PRINT "             1-fault planes with slip axes"
    PRINT "             2-planes (faults, veins, cross-bedding..)"
    PRINT "             3-axes (stylolites, vectors...) "
   
    INPUT "Current data type [1] "; typed
    IF typed = 0 THEN typed = 1
        IF A$ = "" THEN GOTO 162
        GOTO 171
162 INPUT "Filename to save your input data (extension *.BED will be added) [TEMP.BED] "; A$
    IF A$ = "" THEN A$ = "TEMP"
    BADOT = INSTR(A$, ".")
    IF BADOT > 0 THEN RA$ = LEFT$(A$, BADOT - 1)
    IF BADOT = 0 THEN RA$ = A$
    H$ = RA$ + ".BED"
    XH$ = RA$ + ".RTL"
    CLOSE
    OPEN H$ FOR OUTPUT AS #3
    INPUT "Is bedding inclination CONSTANT for ALL data points [NO] "; YB$
    IF YB$ <> "" THEN INPUT "Enter: dip, direction (of bedding)"; DIPB, DIRB
117 INPUT "Number of data points in present set "; NR
    IF NR = 0 THEN PRINT "NOTE: Number of data points should be larger then 0"
    IF NR = 0 THEN PRINT
    IF NR = 0 THEN GOTO 117

    PRINT
    PRINT #3, NR
    IF typed = 1 AND YB$ = "" THEN PRINT "Enter data in lines; each line contains SIX numbers separated by commas."
    IF typed = 1 AND YB$ <> "" THEN PRINT "Enter data in lines; each line contains FOUR numbers separated by commas."
    IF typed = 1 THEN PRINT "  Fault plane dip amount, fault plane dip direction,"
    IF typed = 1 THEN PRINT "  slip axis plunge, slip axis trend,"
    IF typed = 1 AND YB$ = "" THEN PRINT "  host bedding dip amount, host bedding dip direction"
    IF typed = 2 AND YB$ = "" THEN PRINT "Enter data in lines; each line contains FOUR numbers separated by commas."
    IF typed = 2 AND YB$ <> "" THEN PRINT "Enter data in lines; each line contains TWO numbers separated by commas."
    IF typed = 2 THEN PRINT "  plane dip amount, plane dip direction,"
    IF typed = 2 AND YB$ = "" THEN PRINT "  host bedding dip amount, host bedding dip direction."
    IF typed = 3 AND YB$ = "" THEN PRINT "Enter data in lines; each line contains FOUR numbers separated by commas."
    IF typed = 3 AND YB$ <> "" THEN PRINT "Enter data in lines; each line contains TWO numbers separated by commas."
    IF typed = 3 THEN PRINT "  axis plunge, axis trend,"
    IF typed = 3 AND YB$ = "" THEN PRINT "  host bedding dip amount, host bedding dip direction."
   
    PRINT
'    IF YB$ <> "" THEN PRINT "Do not enter bedding below (only four numbers) "
    FOR I = 1 TO NR
    PRINT "Point # "; I; " data ";
    IF YB$ = "" AND typed = 1 THEN INPUT Z1, Z2, Z3, Z4, Z5, Z6
    IF YB$ <> "" AND typed = 1 THEN INPUT Z1, Z2, Z3, Z4
    IF YB$ = "" AND typed = 1 THEN PRINT #3, USING " ####.# "; Z1, Z2, Z3, Z4, Z5, Z6
    IF YB$ <> "" AND typed = 1 THEN PRINT #3, USING " ####.# "; Z1, Z2, Z3, Z4, DIPB, DIRB

    IF YB$ = "" AND typed = 2 THEN INPUT Z1, Z2, Z5, Z6
    IF YB$ <> "" AND typed = 2 THEN INPUT Z1, Z2
    IF YB$ = "" AND typed = 2 THEN PRINT #3, USING " ####.# "; Z1, Z2, Z5, Z6
    IF YB$ <> "" AND typed = 2 THEN PRINT #3, USING " ####.# "; Z1, Z2, DIPB, DIRB
   
    IF YB$ = "" AND typed = 3 THEN INPUT Z3, Z4, Z5, Z6
    IF YB$ <> "" AND typed = 3 THEN INPUT Z3, Z4
    IF YB$ = "" AND typed = 3 THEN PRINT #3, USING " ####.# "; 1, 1, Z3, Z4, Z5, Z6
    IF YB$ <> "" AND typed = 3 THEN PRINT #3, USING " ####.# "; 1, 1, Z3, Z4, DIPB, DIRB
   
    NEXT I
    CLOSE #3
    GOTO 175

171 H$ = A$
    BADOT = INSTR(A$, ".")
    IF BADOT > 0 THEN RA$ = LEFT$(A$, BADOT - 1)
    IF BADOT = 0 THEN RA$ = A$
    XH$ = RA$ + ".RTL"

175 PRINT "Name of output file with retilted data ["; XH$; "] "; : INPUT P$
180 IF P$ = "" THEN P$ = XH$
190 REM
200 REM **** Reading the data file*********
210 REM
    CLOSE

220 OPEN H$ FOR INPUT AS #2
225 OPEN P$ FOR OUTPUT AS #3
    INPUT #2, NR
230 FOR I = 1 TO NR
    KP = 0
    REM ***READ FAULT PLANE AND SLIP DATA, AMOUNT AND DIRECTION OF DIP OF BED*****
240
    IF typed = 1 THEN INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I), BF(I), BD(I)
    IF typed = 2 THEN INPUT #2, DF#(I), DD#(I), BF(I), BD(I)
    IF typed = 3 THEN INPUT #2, SP#(I), ST#(I), BF(I), BD(I)

IF DF#(I) = BF(I) AND DD#(I) = BD(I) THEN BD(I) = BD(I) - .5
IF SP#(I) = BF(I) AND ST#(I) = BD(I) THEN BD(I) = BD(I) - .5
    IF BF(I) < 1 THEN BF(I) = 1

    REM****READ FAULT DATA, SLIP DATA, AND BEDDING DATA (PLUNGE AND TREND)*****
    REM *******CALCULATION OF DIRECTIONAL COSINES*******
    IF BD(I) = 0 OR BD(I) = 360 THEN BD(I) = .1
    IF BD(I) = 90 THEN BD(I) = 90.1
    IF BD(I) = 180 THEN BD(I) = 180.1
    IF BD(I) = 270 THEN BD(I) = 270.1
    IF ST#(I) = 0 OR ST#(I) = 360 THEN ST#(I) = .1
    IF ST#(I) = 90 THEN ST#(I) = 90.1
    IF ST#(I) = 180 THEN ST#(I) = 180.1
    IF ST#(I) = 270 THEN ST#(I) = 270.1
    IF DD#(I) = 0 OR DD#(I) = 360 THEN DD#(I) = .1
    IF DD#(I) = 90 THEN DD#(I) = 90.1
    IF DD#(I) = 180 THEN DD#(I) = 180.1
    IF DD#(I) = 270 THEN DD#(I) = 270.1
300 N1#(I) = COS(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
310 N2#(I) = SIN(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
325 N3#(I) = COS((180 - DF#(I)) * PI# / 180)
330 S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
340 S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
350 S3#(I) = -COS((SP#(I) + 90) * PI# / 180)
    NEXT I
    CLOSE #2
    INPUT "Want to see data list [NO]"; G$
    IF G$ = "" THEN GOTO 355
    IF typed = 1 THEN PRINT "Fault plane:      Slip axes:    Angle (normal/slip)     Bedding:"
    IF typed = 2 THEN PRINT "Fault plane:       Bedding:"
    IF typed = 3 THEN PRINT "Slip axes:         Bedding:"
    FOR I = 1 TO NR
    RT = ABS(S1#(I) * N1#(I) + S2#(I) * N2#(I) + S3#(I) * N3#(I))
    IF RT >= 1 THEN RT = .99999
    RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
    RT = ABS(RT * 180 / PI#)
    IF typed = 2 THEN GOTO 902
    IF typed = 3 THEN GOTO 903
    PRINT USING "##"; INT(DF#(I) + .5);
    PRINT "/";
    PRINT USING "###              "; INT(DD#(I) + .5);
    PRINT USING " ###"; INT(SP#(I) + .5);
    PRINT "/";
    PRINT USING "###             "; INT(ST#(I) + .5);
    PRINT USING "##.#             "; INT(100 * RT) / 100;
    PRINT USING "##"; BF(I);
    PRINT "/"; BD(I)
    GOTO 900
902 PRINT USING "##"; INT(DF#(I) + .5);
    PRINT "/";
    PRINT USING "###              "; INT(DD#(I) + .5);
    PRINT USING "##"; BF(I);
    PRINT "/"; BD(I)
    GOTO 900
903 PRINT USING " ###"; INT(SP#(I) + .5);
    PRINT "/";
    PRINT USING "###             "; INT(ST#(I) + .5);
    PRINT USING "##"; BF(I);
    PRINT "/"; BD(I)

900 NEXT I
    INPUT "Is list O.K. ? [YES]"; G$
    IF G$ <> "" THEN STOP
355 FOR I = 1 TO NR

    BN1 = -(COS(BD(I) * PI# / 180) * SIN(BF(I) * PI# / 180))
    BN2 = -(SIN(BD(I) * PI# / 180) * SIN(BF(I) * PI# / 180))
    BN3 = -(COS((180 - BF(I)) * PI# / 180))
    IF BD(I) < 90 THEN BALP = BD(I)
    IF BD(I) >= 90 AND BD(I) < 270 THEN BALP = 180 - BD(I)
    IF BD(I) >= 270 THEN BALP = BD(I) - 360
    SDIP = COS(BALP * PI / 180) * SIN(BF(I) * PI / 180)
    ALPN = SQR(1 - SDIP ^ 2)
    ALPN = ATN(-ALPN / SQR(1 - ALPN ^ 2)) + PI / 2
    BETA = TAN(ALPN) / TAN(BF(I) * PI / 180)
    BETA = ATN(-BETA / SQR(1 - BETA * BETA)) + PI / 2
    IF BD(I) <= 90 THEN BETA = BD(I) * PI / 180 - BETA
    IF BD(I) > 90 AND BD(I) <= 180 THEN BETA = BD(I) * PI / 180 + BETA
    IF BD(I) > 180 AND BD(I) <= 270 THEN BETA = BD(I) * PI / 180 - BETA
    IF BD(I) > 270 THEN BETA = BD(I) * PI / 180 + BETA
    FBD = 1
    IF BD(I) >= 90 AND BD(I) <= 270 THEN FBD = -1
    BS1 = FBD * (COS(BETA) * SIN(ALPN + PI / 2))
    BS2 = FBD * (SIN(BETA) * SIN(ALPN + PI / 2))
'    PRINT I, ALPN, ALPN + PI / 2
'    INPUT OK
    BS3 = -FBD * COS(ALPN + PI / 2)
    BB1 = BN2 * BS3 - BN3 * BS2
    BB2 = BN3 * BS1 - BN1 * BS3
    BB3 = BN1 * BS2 - BN2 * BS1
    N1T = N1#(I): N2T = N2#(I): N3T = N3#(I)
    S1T = S1#(I): S2T = S2#(I): S3T = S3#(I)
    N1#(I) = N1T * BS1 + N2T * BS2 + N3T * BS3
    N2#(I) = (N1T * BB1 + N2T * BB2 + N3T * BB3)
    N3#(I) = (N1T * BN1 + N2T * BN2 + N3T * BN3)
    S1#(I) = S1T * BS1 + S2T * BS2 + S3T * BS3
    S2#(I) = (S1T * BB1 + S2T * BB2 + S3T * BB3)
    S3#(I) = (S1T * BN1 + S2T * BN2 + S3T * BN3)
    T33 = -ATN(N3#(I) / SQR(1 - N3#(I) * N3#(I))) + PI / 2
    TS33 = ATN(S3#(I) / SQR(1 - S3#(I) * S3#(I)))
    T33 = T33 * 180 / PI
    TS33 = TS33 * 180 / PI
    IF T33 > 90 THEN T33 = 180 - T33
    DFR(I) = T33
    SPR(I) = TS33
250 K1 = S1#(I): K2 = S2#(I): K3 = S3#(I)
255 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    STR(I) = ALPHA
    TSB33 = ATN(BS3 / SQR(1 - BS3 ^ 2))
    SPB = TSB33 * 180 / PI
    K1 = BS1: K2 = BS2: K3 = BS3
    IF BS3 > 0 THEN GOTO 955
    K1 = -BS1: K2 = -BS2: K3 = -BS3
955 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    STB = ALPHA
260 K1 = N1#(I): K2 = N2#(I): K3 = N3#(I)
    IF N3#(I) < 0 THEN GOTO 262
    K1 = -N1#(I): K2 = -N2#(I): K3 = -N3#(I)
262 ALPHA = ATN(K2 / K1)
    IF K1 < 0 THEN ALPHA = PI + ALPHA
    IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
    ALPHA = (180 * ALPHA / PI)
    DDR(I) = ALPHA
    N1#(I) = COS(DDR(I) * PI# / 180) * SIN(DFR(I) * PI# / 180)
    N2#(I) = SIN(DDR(I) * PI# / 180) * SIN(DFR(I) * PI# / 180)
    N3#(I) = COS((180 - DFR(I)) * PI# / 180)
    S1#(I) = COS(STR(I) * PI# / 180) * SIN((SPR(I) + 90) * PI# / 180)
    S2#(I) = SIN(STR(I) * PI# / 180) * SIN((SPR(I) + 90) * PI# / 180)
    S3#(I) = -COS((SPR(I) + 90) * PI# / 180)
    NEXT I
    PRINT #3, NR
    KP = 1
    CLS : SCREEN 0
    IF typed = 1 THEN PRINT "    SENSE OF SLIP ALONG RETILTED FAULTS  "
    IF typed = 2 THEN PRINT "    RETILTED FAULTS  "
    IF typed = 3 THEN PRINT "    RETILTED LINEAMENTS  "
    PRINT
    FOR I = 1 TO NR
    RT = ABS(S1#(I) * N1#(I) + S2#(I) * N2#(I) + S3#(I) * N3#(I))
    IF RT >= 1 THEN RT = .99999
    RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
    RT = ABS(RT * 180 / PI#)
    DIF = ABS(ST#(I) - DD#(I))
    IF ST#(I) = DD#(I) THEN SENSE$ = "     NORMAL     "
    IF ST#(I) > DD#(I) AND DIF <= 45 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) > DD#(I) AND DIF = 90 THEN SENSE$ = "     DEXTRAL     "
    IF ST#(I) > DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) > DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE      "
    IF ST#(I) > DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) > DD#(I) AND DIF = 270 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) > DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) > DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    IF ST#(I) < DD#(I) AND DIF <= 45 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) < DD#(I) AND DIF = 90 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) < DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE    "
    IF ST#(I) < DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) < DD#(I) AND DIF = 270 THEN SENSE$ = "     DEXTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) < DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    PRINT
320
    IF typed = 1 THEN PRINT "Case # "; I; "  Fault plane:    Slip axes:       Sense of slip:   Bedding:"
    IF typed = 2 THEN PRINT "Case # "; I; "  Fault plane:    Bedding:"
    IF typed = 3 THEN PRINT "Case # "; I; "  Slip axes:       Bedding:"
    PRINT "Original:   ";
    IF typed = 1 OR typed = 2 THEN PRINT USING "##"; INT(DF#(I) + .5);
    IF typed = 1 OR typed = 2 THEN PRINT "/";
    IF typed = 1 OR typed = 2 THEN PRINT USING "###        "; INT(DD#(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT USING " ###"; INT(SP#(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT "/";
    IF typed = 1 OR typed = 3 THEN PRINT USING "###          "; INT(ST#(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT SENSE$;
    PRINT USING "   ##"; BF(I);
    PRINT "/";
    'PRINT USING "###"; BD(I)
    PRINT BD(I)
    DIF = ABS(STR(I) - DDR(I))
    IF STR(I) = DDR(I) THEN SENSER$ = "     NORMAL     "
    IF STR(I) > DDR(I) AND DIF <= 45 THEN SENSER$ = " NORMAL-DEXTRAL "
    IF STR(I) > DDR(I) AND DIF > 45 AND DIF < 90 THEN SENSER$ = " DEXTRAL-NORMAL "
    IF STR(I) > DDR(I) AND DIF = 90 THEN SENSER$ = "    DEXTRAL    "
    IF STR(I) > DDR(I) AND DIF > 90 AND DIF < 135 THEN SENSER$ = " DEXTRAL-REVERSE "
    IF STR(I) > DDR(I) AND DIF >= 135 AND DIF < 180 THEN SENSER$ = " REVERSE-DEXTRAL "
    IF STR(I) > DDR(I) AND DIF = 180 THEN SENSER$ = "    REVERSE    "
    IF STR(I) > DDR(I) AND DIF > 180 AND DIF < 225 THEN SENSER$ = "REVERSE-SINISTRAL"
    IF STR(I) > DDR(I) AND DIF >= 225 AND DIF < 270 THEN SENSER$ = "SINISTRAL-REVERSE"
    IF STR(I) > DDR(I) AND DIF = 270 THEN SENSER$ = "   SINISTRAL   "
    IF STR(I) > DDR(I) AND DIF > 270 AND DIF < 315 THEN SENSER$ = "SINISTRAL-NORMAL"
    IF STR(I) > DDR(I) AND DIF >= 315 AND DIF < 360 THEN SENSER$ = "NORMAL-SINISTRAL"
    IF STR(I) > DDR(I) AND DIF = 360 THEN SENSER$ = "     NORMAL     "
    IF STR(I) < DDR(I) AND DIF <= 45 THEN SENSER$ = "NORMAL-SINISTRAL"
    IF STR(I) < DDR(I) AND DIF > 45 AND DIF < 90 THEN SENSER$ = "SINISTRAL-NORMAL"
    IF STR(I) < DDR(I) AND DIF = 90 THEN SENSER$ = "   SINISTRAL   "
    IF STR(I) < DDR(I) AND DIF > 90 AND DIF < 135 THEN SENSER$ = "SINISTRAL-REVERSE"
    IF STR(I) < DDR(I) AND DIF >= 135 AND DIF < 180 THEN SENSER$ = "REVERSE-SINISTRAL"
    IF STR(I) < DDR(I) AND DIF = 180 THEN SENSER$ = "    REVERSE     "
    IF STR(I) < DDR(I) AND DIF > 180 AND DIF < 225 THEN SENSER$ = " REVERSE-DEXTRAL "
    IF STR(I) < DDR(I) AND DIF >= 225 AND DIF < 270 THEN SENSER$ = " DEXTRAL-REVERSE "
    IF STR(I) < DDR(I) AND DIF = 270 THEN SENSER$ = "    DEXTRAL    "
    IF STR(I) < DDR(I) AND DIF > 270 AND DIF < 315 THEN SENSER$ = " DEXTRAL-NORMAL "
    IF STR(I) < DDR(I) AND DIF >= 315 AND DIF < 360 THEN SENSER$ = " NORMAL-DEXTRAL "
    IF STR(I) < DDR(I) AND DIF = 360 THEN SENSER$ = "     NORMAL     "
    PRINT "Retilted:   ";
    IF typed = 1 OR typed = 2 THEN PRINT USING "##"; INT(DFR(I) + .5);
    IF typed = 1 OR typed = 2 THEN PRINT "/";
    IF typed = 1 OR typed = 2 THEN PRINT USING "###        "; INT(DDR(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT USING " ###"; INT(SPR(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT "/";
    IF typed = 1 OR typed = 3 THEN PRINT USING "###          "; INT(STR(I) + .5);
    IF typed = 1 OR typed = 3 THEN PRINT SENSE$;
    PRINT USING "   ##"; BF(I);
    PRINT "/";
    PRINT USING "###"; BD(I)
    INPUT "OK [YES] "; CON$
    IF CON$ = "" THEN GOTO 644
    SPR(I) = -SPR(I)
    STR(I) = STR(I) + 180
    IF STR(I) > 360 THEN STR(I) = STR(I) - 360
    GOTO 320
644 IF typed = 1 THEN PRINT #3, USING " ##### "; INT(DFR(I) + .5), INT(DDR(I) + .5), INT(SPR(I) + .5), INT(STR(I) + .5)
    IF typed = 2 THEN PRINT #3, USING " ##### "; INT(DFR(I) + .5), INT(DDR(I) + .5)
    IF typed = 3 THEN PRINT #3, USING " ##### "; INT(SPR(I) + .5), INT(STR(I) + .5)
    IF typed = 1 THEN PRINT "Printed to file: ";
    IF typed = 1 THEN PRINT USING " ##### "; INT(DFR(I) + .5), INT(DDR(I) + .5), INT(SPR(I) + .5), INT(STR(I) + .5)
    IF typed = 2 THEN PRINT "Printed to file: ";
    IF typed = 2 THEN PRINT USING " ##### "; INT(DFR(I) + .5), INT(DDR(I) + .5)
    IF typed = 3 THEN PRINT "Printed to file: ";
    IF typed = 3 THEN PRINT USING " ##### "; INT(SPR(I) + .5), INT(STR(I) + .5)

    NEXT I
    GOTO 670
665 PRINT
    PRINT "Error in computation.  You can restart."
    PRINT
670 CLOSE
    INPUT "More [NO] "; M$
    IF M$ <> "" THEN GOTO 30
    CLOSE

