   DECLARE SUB SETCOL (COL1, COL2) '$DYNAMIC
   DECLARE SUB PRINCIP (SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#)
   DECLARE SUB STEREO (MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)
    'COLOR 7, 12
    PI# = 4 * ATN(1!): XFACT = 1: CLS : PRINT
    SIZE = 1000
30 DIM DF#(SIZE), DD#(SIZE), SP#(SIZE), ST#(SIZE), FJ#(SIZE), N1#(SIZE), N2#(SIZE), N3#(SIZE), S1#(SIZE), S2#(SIZE), S3#(SIZE), IFAULT(SIZE), COLNUM&(40)
   DIM slip$(SIZE), DSLIP$(300), FRIC(SIZE), BW(10), BW1(10), BW2(10), DAT(15), FDATA(500, 5), DFDATA(400, 5)
   PRINT
    COLOR (4)
    LOCATE 1, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 2, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I
    LOCATE 3, 20
    FOR I = 1 TO 36
    PRINT CHR$(219);
    NEXT I



    LOCATE 2, 35
    COLOR (15)
    PRINT "SHEAR"
    LOCATE 5, 1
    COLOR (2): PRINT "          Mapping 3-D stress components associated with faults and joints"
    COLOR (6)
    PRINT "                   A QuickBasic program by Ze'ev Reches"
    PRINT "                          Version 2.1 March, 1996"
    PRINT
    COLOR (15)
    FACT = 1
    PRINT "The program determines the stress components acting on planar fractures"
    PRINT "    (faults or joints) that are subjected to a given stress state. It also"
    PRINT "    tests the likelihood of fractures to slip under a given friction or to"
    PRINT "    dilate for a given pore pressure."
    PRINT
    PRINT "This is an interactive program that prompts for input and suggests defaults."
    PRINT "Defaults appear in [SQUARE BRACKETS] to be activated by hitting RETURN. "
    PRINT "The file STANDARD (supplied with this program) must reside in default directory."
    INPUT "For general instructions - hit any letter [CONTINUE] "; Y$
    IF Y$ = "" THEN GOTO 37
    CLS
    PRINT "The user's input includes the stress-state; it can be determined by:"
    PRINT "  1.  Stress-inversion by STRESS program (see README file), or"
    PRINT "  2.  Independent measurements (in-situ stresses, other field data or estimate)."
    PRINT "  3.  'Guessing' by trial and error"
    PRINT "The stress state is entered as PRINCIPAL STRESSES, or as SIX components tensor."
    PRINT "The six components tensor can be saved by STRESS and used here."
    PRINT
    PRINT "The program reads two types of fracture data files: "
    PRINT "  1.  Fracture data for STRESS (see README for input format). "
    PRINT "      The program calculates the direction of the maximum resolved shear;"
    PRINT "      but plots the direction of the observed slip !!"
    PRINT "  2.  Fractures for which the direction of slip is unknown.  Make a file "
    PRINT "      for STRESS, but enter 1 for plunge of slip and 1 for trend of slip."
    PRINT
    PRINT "Coordinates of the stress tensor:  X= North, Y= East and Z= Down."
    PRINT "Compressive stresses are negative."
    PRINT
    INPUT "Continue [YES]"; Y4
    CLS
37  SXI# = -1.5: SYI# = -1!: SZI# = -2!: SXYI# = .4: SXZI# = -.3: SYZI# = .001
    PRINT
    PRINT "Options to enter stress state (compression is negative, X north, Y east, Z down:"
    PRINT "  1.  Read a file with six tensor components (enter FILENAME below), or"
    PRINT "  2.  Enter the principal stresses from the keyboard (hit P below), or"
    PRINT "  3.  Enter six tensor components from the keyboard [default below]"
    INPUT "Select stress entry: FILENAME, P, or [KEYBOARD ENTRY OF STRESS TENSOR] "; FILE$
    IF FILE$ = "P" OR FILE$ = "p" THEN CALL PRINCIP(SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#)
    IF FILE$ = "P" OR FILE$ = "p" THEN GOTO 40
    IF FILE$ <> "" THEN OPEN FILE$ FOR INPUT AS #2
    IF FILE$ <> "" THEN INPUT #2, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#
    IF FILE$ <> "" THEN CLOSE #2
    PRINT "                                     "; CHR$(229); "x = [";
    PRINT USING " #####.## "; SXI#;
    PRINT "], new "; : INPUT SXVI#
    IF SXVI# <> 0 THEN SXI# = SXVI#
    PRINT "                                     "; CHR$(229); "y = [";
    PRINT USING " #####.## "; SYI#;
    PRINT "], new "; : INPUT SYVI#
    IF SYVI# <> 0 THEN SYI# = SYVI#
    PRINT "                                     "; CHR$(229); "z = [";
    PRINT USING " #####.## "; SZI#;
    PRINT "], new "; : INPUT SZVI#
    IF SZVI# <> 0 THEN SZI# = SZVI#
    PRINT "                                     "; CHR$(229); "xy= [";
    PRINT USING " #####.## "; SXYI#;
    PRINT "], new "; : INPUT SXYVI#
    IF SXYVI# <> 0 THEN SXYI# = SXYVI#
    PRINT "                                     "; CHR$(229); "xz= [";
    PRINT USING " #####.## "; SXZI#;
    PRINT "], new "; :  INPUT SXZVI#
    IF SXZVI# <> 0 THEN SXZI# = SXZVI#
    PRINT "                                     "; CHR$(229); "yz= [";
    PRINT USING " #####.## "; SYZI#;
    PRINT "], new "; : INPUT SYZVI#
    IF SYZVI# <> 0 THEN SYZI# = SYZVI#
40   BK$ = "1": SI = 1
     GOSUB 999
    PRINT
    INPUT "Hit 1- to modify this stress state, FILENAME to save this tensor [CONTINUE] "; B$
    IF B$ = "" THEN GOTO 35
    IF B$ = "1" THEN GOTO 37
    IF B$ <> "" AND B$ <> "1" THEN OPEN B$ FOR OUTPUT AS #3
    IF B$ <> "" AND B$ <> "1" THEN PRINT #3, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#
    IF B$ <> "" AND B$ <> "1" THEN CLOSE #3

35  PRINT
    CLS
    PRINT "The analysis displays maps on stereographic projections.  Three mapping options:"
    PRINT "  1. Orientations of SLIPPING fault versus orientations of LOCKED faults."
    PRINT "        Set friction coefficient that will be used as a cut-off value."
    PRINT "        The program will calculate the orientations of faults for which "
    PRINT "        {shear stress/(normal stress-pore pressure)} < friction coefficient;"
    PRINT "        these faults are assumed to be locked."
    PRINT "  2. Orientations of DILATING fractures versus orientations of TIGHT fractures."
    PRINT "        Set PORE PRESSURE that will be used as a cut-off value."
    PRINT "        Fractures with {normal stress} < {pore pressure} will be dilated, "
    PRINT "        and fractures with {normal stress} > {pore pressure} will remain tight."
    PRINT "  3. Ratio {shear stress/(normal stress-pore pressure)} for all possible faults."

    'PRINT "By examining a set of field data with fracture orientations, one can separate"
    'PRINT "    the fractures into two subsets: *.LRG and *.SML with large and small"
    'PRINT "    {shear / normal} ratio or {pore pressure/normal stress}."
    PRINT
    PRINT "Select stress map type:"
    PRINT "     SLIPPING vs LOCKED faults- hit 1"
    PRINT "     DILATED vs TIGHT fractures- hit 2"
    INPUT "     [SHEAR STRESS / NORMAL STRESS - PORE PRESSURE] "; MAP
    PRINT
    PRINT "Entering pore-pressure value. Note that the selected pore-pressure "
    PRINT "   should be less compressive then current "; CHR$(229); "1= "; INT(1000 * X1#) / 1000; ","
    PRINT "   should be more compressive then current "; CHR$(229); "3= "; INT(1000 * X3#) / 1000; " for dilation to occur,"
    PRINT "   should be less compressive then current "; CHR$(229); "3= "; INT(1000 * X3#) / 1000; " for slip/lock analyses."
    INPUT "Enter pore-pressure (negative!)  [NONE]"; PORE
    PRINT
     FMAX = ABS(.5 * (X1# - X3#) / (SQR(ABS(X1# - PORE)) * SQR(ABS(X3# - PORE))))
     IF MAP = 1 OR MAP = 2 THEN GOTO 29
     PRINT "For present conditions: Tmax=maximum {shear/normal-pore} ratio is "; INT(100 * FMAX) / 100
     PRINT "Enter 1 to plot {shear/normal-pore} in their actual values ('friction'), OR"
     INPUT "  [Plot {shear/normal-pore} / Tmax ] "; TMAX
    PRINT
29    INPUT "Enter 1 to plot theoretical slip axes [NO PLOT] "; SLA
    PRINT
    PRINT "Three color-grading options in stress maps:"
    PRINT "   Color-grading for B&W print on AppleLaserWriter- Enter P,"
    PRINT "   Red-Green color-grading- Enter R,"
    INPUT "   [Red-Blue-Green] "; NOBLUE$
    PRINT
    IF MAP = 1 THEN INPUT "Friction coefficient to be used for slip/lock zonation [NONE] "; FRIC
    IF FRIC = 0 THEN FRIC = -1
    'INPUT "Map the selected stresses on the stereoplot [YES] "; SI$
    IF SI$ <> "" THEN GOTO 36
    IF SI$ = "" THEN SI$ = "M"
    IF SI$ = "M" THEN SI = 0
    A$ = "STANDARD"
    GOTO 38
36  SI$ = "": SI = 0
    PRINT "Input files have the format of fault-slip files for STRESS (see readme file)."
    PRINT "Two input options: 1. Faults with KNOWN slip directions; in this case,"
    PRINT "   examine the likelihood of the faults to slip under a given stress state."
    PRINT "   2. Fractures with UNKNOWN slip direction (faults or joints); in this case,"
    PRINT "   enter 'dummy' [plunge, trend] of [1, 1] into the input file. The program"
    PRINT "   calculates the axis of maximum shear stress, that is the EXPECTED slip axis"
    INPUT "Enter input file name for analysis "; A$
    LOCATE 1, 1
    PRINT "                                                     "
    PRINT "                                                     "
    PRINT "                                                     "

'  Setting names for output files
   
    BADOT = INSTR(A$, ".")
    IF BADOT > 0 THEN RA$ = LEFT$(A$, BADOT - 1)
    IF BADOT = 0 THEN RA$ = A$
    K$ = ".LRG": H$ = RA$ + K$: XH$ = RA$ + ".SML": XRH$ = RA$ + ".RSL"

'**** Reading the data file*********
   
38  SCREEN 12
         
          FOR I = 0 TO 15
                    IF NOBLUE$ = "R" OR NOBLUE$ = "r" THEN COLNUM&(I) = (15 - I) * 4 + 256 * I * 4
          NEXT I
          FOR I = 0 TO 15
                    IF NOBLUE$ = "" AND I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF NOBLUE$ = "" AND I > 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR I = 1 TO 10
                COL1 = I
                IF NOBLUE$ = "P" OR NOBLUE$ = "p" THEN CALL SETCOL(COL1, COL2)
                IF NOBLUE$ = "P" OR NOBLUE$ = "p" THEN COLNUM&(I) = COL2
          NEXT I
       FOR J = 1 TO 15
                IF NOBLUE$ <> "P" AND NOBLUE$ <> "p" THEN PALETTE J, COLNUM&(J)
          NEXT J
   
26    OPEN A$ FOR INPUT AS #2
    INPUT #2, NR
    FOR I = 1 TO NR
    IFAULT(I) = 0
    NEXT I
235 FOR I = 1 TO NR
    INPUT #2, DF#(I), DD#(I), SP#(I), ST#(I)

    NF = I
    N1#(I) = COS(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N2#(I) = SIN(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
    N3#(I) = COS((180 - DF#(I)) * PI# / 180)
    S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S3#(I) = -COS((SP#(I) + 90) * PI# / 180)
    IF SP#(I) = ST#(I) AND SP#(I) = 1 THEN IFAULT(I) = 1
360 NEXT I
370 CLOSE #2
     BK$ = ""
999  SX# = SXI#: SY# = SYI#: SZ# = SZI#: SXY# = SXYI#: SXZ# = SXZI#: SYZ# = SYZI#
     IF SI = 1 THEN PRINT
     IF SI = 1 THEN CLS
     IF A$ = "" THEN A$ = "DEFAULT"
     IF SI = 1 THEN PRINT "STRESSES OF "; A$; " FILE,    "; DATE$
     IF SI = 1 THEN PRINT "********************************************************"
     IF SI = 1 THEN PRINT
     IF SI = 1 THEN PRINT "Stress tensor components; (compression<0, X north, Y east,Z down)"
     IF SI = 1 THEN PRINT "  "; CHR$(229); "x=";
     IF SI = 1 THEN PRINT USING " ####.## "; SX#;
     IF SI = 1 THEN PRINT "  "; CHR$(229); "y=";
     IF SI = 1 THEN PRINT USING " ####.## "; SY#;
     IF SI = 1 THEN PRINT "  "; CHR$(229); "z=";
     IF SI = 1 THEN PRINT USING " ####.## "; SZ#
     IF SI = 1 THEN PRINT " "; CHR$(229); "yz=";
     IF SI = 1 THEN PRINT USING " ####.## "; SYZ#;
     IF SI = 1 THEN PRINT " "; CHR$(229); "xz=";
     IF SI = 1 THEN PRINT USING " ####.## "; SXZ#;
     IF SI = 1 THEN PRINT " "; CHR$(229); "xy=";
     IF SI = 1 THEN PRINT USING " ####.## "; SXY#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     THET = 180 * THET / PI#
     IF SY# < SX# THEN THET = THET + 90
     IF SI = 1 THEN PRINT CHR$(229); " HMAX= "; INT(100 * SIG1H) / 100; "    "; CHR$(229); " hmin= "; INT(100 * SIG2H) / 100; " Trend (from North)= "; INT(10 * THET) / 10; CHR$(248)
     IF SI = 1 THEN PRINT

'******* Invariant calculations***************
    
     A1# = -(SX# + SY# + SZ#)
     A2# = (SY# * SZ# + SZ# * SX# + SX# * SY#) - (SYZ# ^ 2 + SXZ# ^ 2 + SXY# ^ 2)
     A3# = -(SX# * SY# * SZ# + 2 * SYZ# * SXZ# * SXY# - SX# * (SYZ#) ^ 2 - SY# * (SXZ#) ^ 2 - SZ# * (SXY#) ^ 2)
     Q# = (3 * A2# - A1# ^ 2) / 9
     R# = (9 * A1# * A2# - 27 * A3# - 2 * A1# ^ 3) / 54
     C# = Q# ^ 3 + R# ^ 2
     IF C# > O THEN PRINT "No real roots"
     CT# = -R# / (SQR(-Q# ^ 3))
     T# = ATN(SQR(1 - CT# ^ 2) / CT#)
     T# = ATN(CT# / SQR(1 - CT# ^ 2)) + PI# / 2
     X1# = 2 * SQR(-Q#) * COS(T# / 3) - A1# / 3
     X2# = 2 * SQR(-Q#) * COS(T# / 3 + 120 * PI# / 180) - A1# / 3
     X3# = 2 * SQR(-Q#) * COS(T# / 3 + 240 * PI# / 180) - A1# / 3

     T1# = X1#: T2# = X2#: T3# = X3#
     IF X1# <= X2# AND X2# <= X3# THEN GOTO 4327
     IF X1# <= X3# AND X3# <= X2# THEN GOTO 155
     IF X2# <= X3# AND X3# <= X1# THEN GOTO 156
     IF X2# <= X1# AND X1# <= X3# THEN GOTO 157
     IF X3# <= X1# AND X1# <= X2# THEN GOTO 158
     IF X3# <= X2# AND X2# <= X1# THEN GOTO 159
155  X1# = T1#: X2# = T3#: X3# = T2#
     GOTO 4327
156  X1# = T2#: X2# = T3#: X3# = T1#
     GOTO 4327
157  X1# = T2#: X2# = T1#: X3# = T3#
     GOTO 4327
158  X1# = T3#: X2# = T1#: X3# = T2#
     GOTO 4327
159  X1# = T3#: X2# = T2#: X3# = T1#
     GOTO 4327


4327 IF SI = 1 THEN PRINT
     IF SI = 1 THEN PRINT "PRINCIPAL STRESSES "
     IF SI = 1 THEN PRINT "Magnitudes: ";
     IF SI = 1 THEN PRINT "   "; CHR$(229); "1= "; INT(1000 * X1#) / 1000; " "; CHR$(229); "2= "; INT(1000 * X2#) / 1000; " "; CHR$(229); "3= "; INT(1000 * X3#) / 1000
     FMAX = ABS(.5 * (X1# - X3#) / (SQR(ABS(X1# - PORE)) * SQR(ABS(X3# - PORE))))
     IF SI = 1 THEN PRINT "Maximum shear/normal ratio= "; INT(100 * FMAX) / 100
     DAT(7) = X1#: DAT(8) = X2#: DAT(9) = X3#
     IF SI = 1 THEN PRINT "                  Directional cosines         Plunge/trend:"
     A11# = SX# - X1#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X1#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X1#
     Z1# = (A11# * A23# - A21# * A13#) / (A12# * A23# - A22# * A13#)
     Z2# = (A11# - Z1# * A12#) / A13#
     K1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     K2# = -K1# * Z1#
     K3# = -K1# * Z2#
     K1# = -K1#: K2# = -K2#: K3# = -K3#
     RU# = A11# * K1# + A12# * K2# + A13# * K3#
     RV# = A21# * K1# + A22# * K2# + A23# * K3#
     RX# = A31# * K1# + A32# * K2# + A33# * K3#
     IF SI = 1 THEN PRINT "       "; CHR$(229); " 1   ";
     IF SI = 1 THEN PRINT USING "######.###"; K1#, K2#, K3#;
     K1 = K1#: K2 = K2#: K3 = K3#
     GOTO 4482
4465 BW1(1) = K1: BW1(2) = K2: BW1(3) = K3
     GOTO 4482
4471 BW2(1) = K1: BW2(2) = K2: BW2(3) = K3
4482 IF K3# > 0 THEN GOTO 4685
     K1 = -K1#: K2 = -K2#: K3 = -K3#
4685 ALPHA = ATN(K2# / K1#)
     IF K1 < 0 THEN ALPHA = PI# + ALPHA
     IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI# + ALPHA
     ALPHA = (180 * ALPHA / PI#)
     IF K3 = 1 THEN K3 = .9999999
     DIP = ATN(K3 / SQR(1 - K3 ^ 2))
     DIP = 180 * DIP / PI#
     IF SI = 1 THEN PRINT "    "; INT(DIP); CHR$(248); "/"; INT(ALPHA); CHR$(248)
     DAT(10) = INT(DIP): DAT(11) = INT(ALPHA)
     A11# = SX# - X2#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X2#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X2#
     Z1# = (A11# * A33# - A31# * A13#) / (A12# * A33# - A32# * A13#)
     Z2# = (A31# - Z1# * A32#) / A33#
     L1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     L2# = -L1# * Z1#
     L3# = -L1# * Z2#
     L1# = -L1#: L2# = -L2#: L3# = -L3#
     RU# = A11# * L1# + A12# * L2# + A13# * L3#
     RV# = A21# * L1# + A22# * L2# + A23# * L3#
     RX# = A31# * L1# + A32# * L2# + A33# * L3#
     IF SI = 1 THEN PRINT "       "; CHR$(229); " 2   ";
     IF SI = 1 THEN PRINT USING "######.###"; L1#, L2#, L3#;
     L1 = L1#: L2 = L2#: L3 = L3#
4578 IF L3# > 0 THEN GOTO 4579
     L1 = -L1#: L2 = -L2#: L3 = -L3#
4579 ALPHA = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA = PI# + ALPHA
     IF L2 < 0 AND L1 > 0 THEN ALPHA = 2 * PI# + ALPHA
     ALPHA = (180 * ALPHA / PI#)
     IF L3 = 1 THEN L3 = .9999999
     DIP = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP = 180 * DIP / PI#
     IF SI = 1 THEN PRINT "    "; INT(DIP); CHR$(248); "/"; INT(ALPHA); CHR$(248)
     DAT(12) = INT(DIP): DAT(13) = INT(ALPHA)
     A11# = SX# - X3#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X3#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X3#
     Z1# = (A21# * A33# - A31# * A23#) / (A22# * A33# - A32# * A23#)
     Z2# = (A21# - Z1# * A22#) / A23#
     M1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     M2# = -M1# * Z1#
     M3# = -M1# * Z2#
     RU# = A11# * M1# + A12# * M2# + A13# * M3#
     RV# = A21# * M1# + A22# * M2# + A23# * M3#
     RX# = A31# * M1# + A32# * M2# + A33# * M3#
     IF SI = 1 THEN PRINT "       "; CHR$(229); " 3   ";
     IF SI = 1 THEN PRINT USING "######.###"; M1#, M2#, M3#;
     M1 = M1#: M2 = M2#: M3 = M3#
     IF M3# > 0 THEN GOTO 4687
     M1 = -M1#: M2 = -M2#: M3 = -M3#
4687 ALPHA = ATN(M2 / M1)
     IF M1 < 0 THEN ALPHA = PI# + ALPHA
     IF M2 < 0 AND M1 > 0 THEN ALPHA = 2 * PI# + ALPHA
     ALPHA = (180 * ALPHA / PI#)
     IF M3 = 1 THEN M3 = .9999999
     DIP = ATN(M3 / SQR(1 - M3 ^ 2))
     DIP = 180 * DIP / PI#
     IF SI = 1 THEN PRINT "    "; INT(DIP); CHR$(248); "/"; INT(ALPHA); CHR$(248)
     DAT(14) = INT(DIP): DAT(15) = INT(ALPHA)
     W1# = K1# * L1# + K2# * L2# + K3# * L3#
     W2# = K1# * M1# + K2# * M2# + K3# * M3#
     W3# = L1# * M1# + L2# * M2# + L3# * M3#
     CLOSE
     IF ABS(W1#) < .01 AND ABS(W2#) < .01 AND ABS(W3#) < .01 AND BK$ = "1" THEN RETURN
     IF ABS(W1#) < .01 AND ABS(W2#) < .01 AND ABS(W3#) < .01 THEN GOTO 8000
     INPUT "Principal stress axes are not perfectly normal to each other. Any key to stop [CONTINUE] "; B$
      IF B$ <> "" THEN STOP
8000 COTOT = 0: NORM = 0
     FOR I = 1 TO NF
                A1 = N1#(I) ^ 2: B1 = N1#(I) * S1#(I)
                A2 = N2#(I) ^ 2: B2 = N2#(I) * S2#(I)
                A3 = N3#(I) ^ 2: B3 = N3#(I) * S3#(I)
                A4 = 2 * N2#(I) * N3#(I): B4 = N2#(I) * S3#(I) + S2#(I) * N3#(I)
                A5 = 2 * N1#(I) * N3#(I): B5 = N3#(I) * S1#(I) + S3#(I) * N1#(I)
                A6 = 2 * N1#(I) * N2#(I): B6 = N1#(I) * S2#(I) + S1#(I) * N2#(I)
        SN = A1 * SX# + A2 * SY# + A3 * SZ# + A4 * SYZ# + A5 * SXZ# + A6 * SXY#
        SSH = B1 * SX# + B2 * SY# + B3 * SZ# + B4 * SYZ# + B5 * SXZ# + B6 * SXY#
        FRIC(I) = ABS(SSH / (SN - PORE))
       
        'IF SP#(I) = ST#(I) AND SP#(I) = 1 THEN FRIC(I) = 99!

22     NEXT I
     Y$ = ""
8171 SCON = SCON + 1:  NUMISLP = 0: KFC = 0
     FOR I = 1 TO NF

                RX = (N1#(I) * SX# + N2#(I) * SXY# + N3#(I) * SXZ#)
                RY = (N1#(I) * SXY# + N2#(I) * SY# + N3#(I) * SYZ#)
                RZ = (N1#(I) * SXZ# + N2#(I) * SYZ# + N3#(I) * SZ#)
                RP = SQR(RX ^ 2 + RY ^ 2 + RZ ^ 2)
        SIGN = N1#(I) * RX + N2#(I) * RY + N3#(I) * RZ
        SIGS = SQR(RP ^ 2 - SIGN ^ 2)
                        IF Y$ <> "" THEN LINE (0, 0)-(640, 148), 0, BF
                RXF = RX: RYF = RY: RZF = RZ
                RX = RX / RP: RY = RY / RP: RZ = RZ / RP
'****CALCULATION OF ANGLE BETWEEN OBSERVED AND CALCULATED MAXIMUM SHEAR
        B1 = N2#(I) * RZ - N3#(I) * RY
        B2 = N3#(I) * RX - N1#(I) * RZ
        B3 = N1#(I) * RY - N2#(I) * RX
        RB = SQR(B1 ^ 2 + B2 ^ 2 + B3 ^ 2)
        B1 = B1 / RB: B2 = B2 / RB: B3 = B3 / RB
     Q1 = N2#(I) * B3 - N3#(I) * B2
     Q2 = N3#(I) * B1 - N1#(I) * B3
     Q3 = N1#(I) * B2 - N2#(I) * B1
     RQ = SQR(Q1 ^ 2 + Q2 ^ 2 + Q3 ^ 2)
     Q1 = -Q1 / RQ: Q2 = -Q2 / RQ: Q3 = -Q3 / RQ
     ROTS# = (Q1 * S1#(I) + Q2 * S2#(I) + Q3 * S3#(I))
     'PRINT Q1, Q2, Q3, ROTS#

     IF ABS(ROTS#) >= 1 THEN ROTS# = .999999
     'PRINT Q1, Q2, Q3, ROTS#
     ROTS# = PI# / 2 - ATN(ROTS# / SQR(1 - ROTS# ^ 2))
     ROTS# = ABS(ROTS# * 180 / PI#)
     IF ROTS# > 90 THEN NUMISLP = NUMISLP + 1
     ROTSN# = (N1#(I) * S1#(I) + N2#(I) * S2#(I) + N3#(I) * S3#(I))
     IF ROTSN# = 1 THEN ROTSN# = .999999
     ROTSN# = PI# / 2 - ATN(ROTSN# / SQR(1 - ROTSN# ^ 2))
     ROTSN# = ABS(ROTSN# * 180 / PI#)

     LOCATE 2, 1
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "Fracture # "; I; " :  Plane "; DF#(I); CHR$(248); "/"; DD#(I); CHR$(248); ", Observed slip axis: "; SP#(I); CHR$(248); " / "; ST#(I); CHR$(248)
     IF Y$ <> "" AND SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "Fracture # "; I; " :  Plane "; DF#(I); CHR$(248); "/"; DD#(I); CHR$(248)
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "The slip direction of this fracture is not specified in input file."
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "Fracture normal to slip axis angle=";
     COLOR (1)
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING "###.# "; ROTSN#;
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT ; CHR$(248);
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "; if not 89.8-90.2 expect inaccuracies"
     COLOR (15)
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "   Calculated-Observed angle: ";
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING " ###.#"; ROTS#;
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT ; CHR$(248);
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "   Maximum shear axis: ";
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "Maximum shear axis=expected slip direction under current stresses: ";
     'IF SI = 1 AND SI$ = "" THEN PRINT USING " ##.### "; Q1, Q2, Q3;
9685 ALPHA = ATN(Q2 / Q1)
     IF Q1 < 0 THEN ALPHA = PI# + ALPHA
     IF Q2 < 0 AND Q1 > 0 THEN ALPHA = 2 * PI# + ALPHA
     ALPHA = INT(180 * ALPHA / PI#)
     IF Q3 = 1 THEN Q3 = .9999999
     DIP = ATN(Q3 / SQR(1 - Q3 ^ 2))
     DIP = INT(180 * DIP / PI#)
     IF ALPHA > 360 THEN ALPHA = ALPHA - 360
     IF SI = 1 AND SI$ = "" THEN PRINT USING "###"; DIP;
     IF SI = 1 AND SI$ = "" THEN PRINT ; CHR$(248);
     IF SI = 1 AND SI$ = "" THEN PRINT "/";
     IF SI = 1 AND SI$ = "" THEN PRINT USING "####"; ALPHA;
     IF SI = 1 AND SI$ = "" THEN PRINT ; CHR$(248)
    
    DIF = ABS(ST#(I) - DD#(I))
    IF ST#(I) = DD#(I) THEN SENSE$ = "     NORMAL     "
    IF ST#(I) > DD#(I) AND DIF <= 45 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) > DD#(I) AND DIF = 90 THEN SENSE$ = "     DEXTRAL     "
    IF ST#(I) > DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) > DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) > DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE      "
    IF ST#(I) > DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) > DD#(I) AND DIF = 270 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) > DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) > DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) > DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    IF ST#(I) < DD#(I) AND DIF <= 45 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST#(I) < DD#(I) AND DIF = 90 THEN SENSE$ = "    SINISTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST#(I) < DD#(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST#(I) < DD#(I) AND DIF = 180 THEN SENSE$ = "    REVERSE    "
    IF ST#(I) < DD#(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST#(I) < DD#(I) AND DIF = 270 THEN SENSE$ = "     DEXTRAL    "
    IF ST#(I) < DD#(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST#(I) < DD#(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST#(I) < DD#(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "   Calculated slip sense: "; SENSE$
     IF SI = 1 AND SI$ = "" THEN PRINT "Resultant stress: ";
     IF SI = 1 AND SI$ = "" THEN PRINT USING " ####.### "; RXF, RYF, RZF
     IF SI = 1 AND SI$ = "" THEN PRINT "Normal and shear stress:  ";
     IF SI = 1 AND SI$ = "" THEN PRINT USING " ####.### "; SIGN, SIGS
     IF SI = 1 AND SI$ = "" THEN PRINT "Maximum {shear/normal-pore} ratio on this fracture: ";
     FC = ABS(SIGS / (SIGN - PORE))
     'FC = ABS(SIGS / SIGN)
     IF SI = 1 AND SI$ = "" THEN PRINT USING " ##.## "; FC
     IF SP#(I) = ST#(I) AND SP#(I) = 1 THEN GOTO 9682
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT "{Shear/normal-pore} ratio in observed slip direction: ";
     IF SI = 1 AND SI$ = "" AND IFAULT(I) = 0 THEN PRINT USING " ##.## "; FRIC(I)
     'IF SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT "Slip direction not indicated in input data (probably a joint surface)"
     'IF SI = 1 AND SI$ = "" AND IFAULT(I) = 1 THEN PRINT USING " ##.## "; FRIC(I)



9682 IF SI$ <> "" THEN GOTO 9689

    IF SP#(I) <> ST#(I) THEN GOTO 9688
    IF SP#(I) <> 1 THEN 9688
9689
    SP#(I) = DIP
    ST#(I) = ALPHA
    S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
    S3#(I) = -COS((SP#(I) + 90) * PI# / 180)
 
9688    FLAG = 1
    IF S3#(I) < 0 THEN FLAG = 0
    N11# = -N1#(I): N22# = -N2#(I): N33# = -N3#(I)
    S11 = -S1#(I): S22 = -S2#(I): S33 = -S3#(I)
    RR# = SQR(N11# ^ 2 + N22# ^ 2)
    XN# = N22# * 150 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    YN# = 300 - N11# * 150 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    RS = SQR(S11 ^ 2 + S22 ^ 2)
    IF RS = 0 THEN RS = .000001
    XS# = -S22 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    YS# = 300 + S11 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN XS# = S22 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN YS# = 300 - S11 * 150 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    


IF TMAX = 1 THEN FMAX = 1
FCOL = INT(15.5 * FC / FMAX)
IF FCOL >= 15 THEN FCOL = 15
IF NOBLUE$ <> "P" AND NOBLUE$ <> "p" THEN GOTO 95
 FCOL = INT(10.5 * FC / FMAX)
 CALL SETCOL(FCOL, COL2)
 FCOL = COL2
 

'PRINT I, FC, TMAX, FMAX, FCOL
'INPUT OK

95 IF MAP = 1 AND FRIC > 0 AND FC < FRIC THEN FCOL = 1
    IF MAP = 1 AND FRIC > 0 AND FC >= FRIC THEN FCOL = 8

    IF MAP = 2 AND ABS(SIGN) > ABS(PORE) THEN FCOL = 1
    IF MAP = 2 AND ABS(SIGN) <= ABS(PORE) THEN FCOL = 8

    IF SI$ = "" AND Y$ <> "" THEN CIRCLE (300 + XFACT * XN#, YN#), 1
    IF SI$ = "" AND Y$ <> "" THEN CIRCLE (300 + XFACT * XN#, YN#), 2
    IF SI$ = "" AND Y$ <> "" THEN CIRCLE (300 + XFACT * XN#, YN#), 3
    IF SI$ = "" AND Y$ <> "" THEN PSET (300 + XFACT * XN#, YN#)
    AP = -ST#(I)
    IF SI$ = "" AND Y$ <> "" THEN DRAW "TA=" + VARPTR$(AP) + "NU20"


    DEL = 5
    IF DD#(I) < 268 THEN END1 = 270 - DD#(I) - DEL
    IF DD#(I) < 268 THEN START1 = 270 - DD#(I) + DEL
    IF DD#(I) >= 268 THEN END1 = 630 - DD#(I) - DEL
    IF DD#(I) >= 268 THEN START1 = 630 - DD#(I) + DEL
    IF END1 < START1 THEN S1 = END1
    IF END1 < START1 THEN E1 = START1
    IF END1 > START1 THEN S1 = START1
    IF END1 > START1 THEN E1 = END1
    IF E1 > 360 THEN E1 = E1 - 360

    RN1 = 150 * SQR(2) * SIN(DF#(I) * PI# / 360)
    IF SI$ = "" THEN GOTO 9687
    AP = 0: DRAW "TA=" + VARPTR$(AP)

    RT1 = RN1 - 7.5: RT2 = RN1 + 7.5
    IF RT1 < 3 THEN RT1 = 3
    IF RT2 < 3 THEN RT2 = 3
    IF RT1 > 149 THEN RT1 = 149
    IF RT2 > 149 THEN RT2 = 149

'    PRINT I, S1, 270 - DD#(I), E1, ATN(XN# / (YN# - 300)) * 180 / PI#
'    INPUT OK
    IF SCON = 3 THEN DRAW "C=" + VARPTR$(FCOL)
    IF SCON = 3 THEN CIRCLE (300, 300), RT1, FCOL, -S1 * 2 * PI# / 360, E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT2, FCOL, S1 * 2 * PI# / 360, -E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT1, FCOL, S1 * 2 * PI# / 360, -E1 * 2 * PI# / 360
    IF SCON = 3 THEN CIRCLE (300, 300), RT2, FCOL, -S1 * 2 * PI# / 360, E1 * 2 * PI# / 360

    X1 = 300 + XFACT * XN#: Y1 = YN#
    IF SCON = 3 THEN DRAW "BM=" + VARPTR$(X1) + ",=" + VARPTR$(Y1)
    IF SCON = 3 THEN DRAW "P=" + VARPTR$(FCOL) + ",=" + VARPTR$(FCOL)
    IF SCON = 5 THEN PSET (300 + XFACT * XN#, YN#), FCOL
    IF SCON = 5 AND SLA = 1 THEN CIRCLE (300 + XFACT * XN#, YN#), 1, 0
    'IF SCON = 3 THEN CIRCLE (300 + XFACT * XN#, YN#), 1, 0
    AP = -ST#(I)
    IF SCON = 5 AND SLA = 1 THEN DRAW "TA=" + VARPTR$(AP) + "C0NU8"
9687 IF SI$ <> "" THEN GOTO 8180
     DR = 0
     IF SI = 1 AND SI$ = "" THEN INPUT "1-delete [CONTINUE] "; DR
      IF DR = 1 THEN GOTO 9698
     KFC = KFC + 1
     slip$(KFC) = SENSE$
     FDATA(KFC, 1) = DF#(I): FDATA(KFC, 2) = DD#(I): FDATA(KFC, 3) = SP#(I): FDATA(KFC, 4) = ST#(I)

     IF ST#(I) = 1 AND SP#(I) = 1 THEN FDATA(KFC, 3) = DIP
     IF ST#(I) = 1 AND SP#(I) = 1 THEN FDATA(KFC, 4) = ALPHA
     FDATA(KFC, 5) = FC
     GOTO 9697
   
9698 DKFC = DKFC + 1
     DSLIP$(DKFC) = SENSE$
     DFDATA(DKFC, 1) = DF#(I): DFDATA(DKFC, 2) = DD#(I): DFDATA(DKFC, 3) = SP#(I): DFDATA(DKFC, 4) = ST#(I): DFDATA(DKFC, 5) = FC
     IF ST#(I) = 1 AND SP#(I) = 1 THEN DFDATA(DKFC, 3) = DIP
     IF ST#(I) = 1 AND SP#(I) = 1 THEN DFDATA(DKFC, 4) = ALPHA

9697 IF SI = 1 AND SI$ = "" THEN PRINT
     IF SI = 1 AND SI$ = "" THEN PRINT
8180 SIGNOR = SIGN * MU
8190 NEXT I
     IF SI = 1 THEN PRINT
     IF SI = 1 THEN PRINT
33   SI = 1: Y$ = ""
                'screen 12

                 CALL STEREO(MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)
   
    FOR J = 1 TO 15
        IF NOBLUE$ = "P" AND J > 10 OR NOBLUE$ = "p" AND J > 10 THEN GOTO 28
        IF FRIC < 0 AND MAP = 0 AND NOBLUE$ <> "P" AND NOBLUE$ <> "p" THEN LINE (540, 280 - (J - 4) * 10)-(550, 280 - (J - 3) * 10), J, BF
        COL1 = J
        IF NOBLUE$ = "P" OR NOBLUE$ = "p" THEN CALL SETCOL(COL1, COL2)
        IF NOBLUE$ = "P" OR NOBLUE$ = "p" THEN LINE (540, 280 - (J - 4) * 15)-(550, 280 - (J - 3) * 15), COL2, BF

28 NEXT J


    FOR J = 1 TO 8 STEP 7
        IF FRIC > 0 AND MAP = 1 THEN LINE (560, 260 - (J - 4) * 15)-(580, 260 - (J - 3) * 15), J, BF
        IF FRIC < 0 AND MAP = 2 THEN LINE (560, 260 - (J - 4) * 15)-(580, 260 - (J - 3) * 15), J, BF
    NEXT J


    FOR J = 1 TO 3
        'LINE (560, 260 - (J - 4 + 5) * 15)-(580, 260 - (J - 3 + 5) * 15), 7 + (J - 1) * 2, BF
    NEXT J
                                                        
    LOCATE 11, 73: IF FRIC < 0 AND TMAX <> 1 OR MAP = 0 AND TMAX <> 1 THEN PRINT "T/Tmax=1"
    LOCATE 11, 73: IF FRIC < 0 AND TMAX = 1 OR MAP = 0 AND TMAX = 1 THEN PRINT "T >=1.0"
    LOCATE 20, 74: IF FRIC < 0 AND MAP = 0 THEN PRINT "  0.0"
    LOCATE 13, 62: IF FRIC > 0 AND MAP = 1 THEN PRINT "SLIPPING"
    LOCATE 19, 62: IF FRIC > 0 AND MAP = 1 THEN PRINT "LOCKED"
    LOCATE 13, 62: IF MAP = 2 THEN PRINT "DILATED"
    LOCATE 19, 62: IF MAP = 2 THEN PRINT "TIGHT"

34   LOCATE 1, 1
     LINE (0, 0)-(640, 148), 0, BF
     SCON = SCON + 1
     IF SCON = 4 AND SI$ = "M" THEN GOTO 8171
     IF SCON > 5 THEN SCON = 0
     IF SI = 1 THEN INPUT "R-read data file, Y-check individual fractures, M-map shear stresses [exit] "; Y$
     IF Y$ <> "" THEN LINE (0, 0)-(640, 148), 0, BF
     IF Y$ = "M" OR Y$ = "m" THEN GOTO 8000
     IF Y$ = "R" OR Y$ = "r" THEN GOTO 36

     IF SI = 1 THEN PRINT
     IF SI = 1 THEN PRINT
     IF Y$ = "A" OR Y$ = "a" THEN KCONF = 1
     IF Y$ = "Y" OR Y$ = "y" THEN GOTO 8171
     IF KCONF = 1 THEN GOTO 8171
     LINE (0, 0)-(640, 148), 0, BF
     PRINT "Y-Save results in "; XRH$; ",  FILENAME- new file, [NO]";
        INPUT " "; NF$
     IF NF$ = "" THEN GOTO 8211
     IF NF$ = "Y" OR NF$ = "y" THEN NF$ = XRH$
     OPEN NF$ FOR OUTPUT AS #3
     PRINT #3, "PRINCIPAL STRESSES, "; A$; " DATA SET,    "; DATE$
     PRINT #3, "Input stress tensor: (compression<0, X north, Y east, Z down)"
     PRINT #3, "  Sx="; : PRINT #3, USING " ####.## "; SX#;
     PRINT #3, "  Sy="; : PRINT #3, USING " ####.## "; SY#;
     PRINT #3, "  Sz="; : PRINT #3, USING " ####.## "; SZ#
     PRINT #3, " Syz="; : PRINT #3, USING " ####.## "; SYZ#;
     PRINT #3, " Sxz="; : PRINT #3, USING " ####.## "; SXZ#;
     PRINT #3, " Sxy="; : PRINT #3, USING " ####.## "; SXY#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     THET = 180 * THET / PI#
     IF SY# < SX# THEN THET = THET + 90
     PRINT #3, "MAX. HOR. SIG.= "; INT(100 * SIG1H) / 100; "Min. hor. sig.= "; INT(100 * SIG2H) / 100; " Trend (from North)= "; INT(10 * THET) / 10
     PRINT #3, "PRINCIPAL STRESSES "
     PRINT #3, "Magnitudes: ";
     PRINT #3, "   S1= "; INT(1000 * X1#) / 1000; " S2= "; INT(1000 * X2#) / 1000; " S3= "; INT(1000 * X3#) / 1000
     PRINT #3, "Orientations   Plunge/trend:"
     PRINT #3, "   Sigma 1   "; DAT(10); "/"; DAT(11)
     PRINT #3, "   Sigma 2   "; DAT(12); "/"; DAT(13)
     PRINT #3, "   Sigma 3   "; DAT(14); "/"; DAT(15)
     PRINT #3,
     PRINT #3, KFC; " Fractures with LARGE shear stress/normal stress ratio: "
     PRINT #3, ""
     PRINT #3, " #    fracture plane      observed slip axis    shear/normal    calculated slip"
     FOR I = 1 TO KFC
        PRINT #3, I; "  "; FDATA(I, 1); "  "; FDATA(I, 2); "            "; FDATA(I, 3); "  "; FDATA(I, 4); "     "; FDATA(I, 5); "     "; slip$(I)
     NEXT I

     PRINT #3, DKFC; " fractures with SMALL shear stress/normal stress ratio: "
     PRINT #3, ""
     PRINT #3, " #    fracture plane      observed slip axis    shear/normal    calculated slip"
     FOR I = 1 TO DKFC
        PRINT #3, I; "  "; DFDATA(I, 1); "  "; DFDATA(I, 2); "            "; DFDATA(I, 3); "  "; DFDATA(I, 4); "     "; DFDATA(I, 5); "     "; DSLIP$(I)
     NEXT I
     CLOSE
    K$ = ".LRG": H$ = RA$ + K$: XH$ = RA$ + ".SML": XRH$ = RA$ + ".RSL"
8211 PRINT "Y-to save fractures with SMALL {shear/normal} for STRESS in "; XH$; " [NO] ";
     INPUT NF$
     IF NF$ = "" THEN GOTO 8213
     IF NF$ = "Y" OR NF$ = "y" THEN NF$ = XH$
     OPEN NF$ FOR OUTPUT AS #3
     PRINT #3, DKFC
     FOR I = 1 TO DKFC
        PRINT #3, DFDATA(I, 1); "  "; DFDATA(I, 2); "   "; DFDATA(I, 3); "  "; DFDATA(I, 4)
     NEXT I
     CLOSE
8213 PRINT "Y-to save fractures with LARGE {shear/normal} for STRESS in "; H$; " [NO] ";
     INPUT NF$
     IF NF$ = "" THEN GOTO 8212
     IF NF$ = "Y" OR NF$ = "y" THEN NF$ = H$
     OPEN NF$ FOR OUTPUT AS #3
     PRINT #3, KFC
     FOR I = 1 TO KFC
                 PRINT #3, FDATA(I, 1); "  "; FDATA(I, 2); "   "; FDATA(I, 3); "  "; FDATA(I, 4)
     NEXT I
     CLOSE
8212 PRINT
     INPUT "For more analyses-restart program !!!       "; OK
     CLS : END

REM $STATIC
SUB PRINCIP (SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#)
PI# = 4 * ATN(1!)
DIM S1#(3), S2#(3), S3#(3)
10 PRINT
PRINT "Compressive stresses are negative.  Use any units (results in same units)."
PRINT "Principal axes given as PLUNGE (0-90) and TREND (0-360 from north)."
PRINT "Using angles 0, 90, 180, 360 may cause overflow; change them by 0.1"
PRINT
INPUT "Maximum compression: MAGNITUDE, PLUNGE, TREND = "; M1, P1, T1
INPUT "Intermediate       : MAGNITUDE, PLUNGE, TREND = "; M2, P2, T2
INPUT "Least compression  : MAGNITUDE, PLUNGE, TREND = "; M3, P3, T3
    FOR I = 1 TO 3
    IF I = 1 THEN ST = T1: IF I = 1 THEN SP = P1
    IF I = 2 THEN ST = T2: IF I = 2 THEN SP = P2
    IF I = 3 THEN ST = T3: IF I = 3 THEN SP = P3
    S1#(I) = COS(ST * PI# / 180) * SIN((SP + 90) * PI# / 180)
    S2#(I) = SIN(ST * PI# / 180) * SIN((SP + 90) * PI# / 180)
    S3#(I) = -COS((SP + 90) * PI# / 180)
    NEXT I
  
A12 = S1#(1) * S1#(2) + S2#(1) * S2#(2) + S3#(1) * S3#(2)
A23 = S1#(3) * S1#(2) + S2#(3) * S2#(2) + S3#(3) * S3#(2)
A13 = S1#(1) * S1#(3) + S2#(1) * S2#(3) + S3#(1) * S3#(3)
IF ABS(A12) > .05 OR ABS(A23) > .05 OR ABS(A13) > .05 THEN PRINT "ERROR: principal stress axes not normal to each other."
IF ABS(A12) > .05 OR ABS(A23) > .05 OR ABS(A13) > .05 THEN INPUT "1- STOP, or 2- RE-ENTER DATA, or [CONTINUE] "; RD$
IF RD$ = "1" THEN STOP
IF RD$ = "2" THEN GOTO 10
   
    S11# = COS(T1 * PI# / 180) * SIN((P1 + 90) * PI# / 180)
    S12# = SIN(T1 * PI# / 180) * SIN((P1 + 90) * PI# / 180)
    S13# = -COS((P1 + 90) * PI# / 180)
    S21# = COS(T2 * PI# / 180) * SIN((P2 + 90) * PI# / 180)
    S22# = SIN(T2 * PI# / 180) * SIN((P2 + 90) * PI# / 180)
    S23# = -COS((P2 + 90) * PI# / 180)
    S31# = COS(T3 * PI# / 180) * SIN((P3 + 90) * PI# / 180)
    S32# = SIN(T3 * PI# / 180) * SIN((P3 + 90) * PI# / 180)
    S33# = -COS((P3 + 90) * PI# / 180)
  
     A1 = S11# ^ 2: B1 = S11# * S12#
     A2 = S21# ^ 2: B2 = S21# * S22#
     A3 = S31# ^ 2: B3 = S31# * S32#
     SXI# = A1 * M1 + A2 * M2 + A3 * M3
     SXYI# = B1 * M1 + B2 * M2 + B3 * M3
     A1 = S12# ^ 2: B1 = S12# * S13#
     A2 = S22# ^ 2: B2 = S22# * S23#
     A3 = S32# ^ 2: B3 = S32# * S33#
     SYI# = A1 * M1 + A2 * M2 + A3 * M3
     SYZI# = B1 * M1 + B2 * M2 + B3 * M3
     A1 = S13# ^ 2: B1 = S13# * S11#
     A2 = S23# ^ 2: B2 = S23# * S21#
     A3 = S33# ^ 2: B3 = S33# * S31#
     SZI# = A1 * M1 + A2 * M2 + A3 * M3
     SXZI# = B1 * M1 + B2 * M2 + B3 * M3
END SUB

REM $DYNAMIC
'
SUB SETCOL (COL1, COL2) '

IF COL1 <= 1.5 THEN COL2 = 0
IF COL1 <= 2.5 AND COL1 > 1.5 THEN COL2 = 14
IF COL1 <= 3.5 AND COL1 > 2.5 THEN COL2 = 7
IF COL1 <= 4.5 AND COL1 > 3.5 THEN COL2 = 10
IF COL1 <= 5.5 AND COL1 > 4.5 THEN COL2 = 8
IF COL1 <= 6.5 AND COL1 > 5.5 THEN COL2 = 13
IF COL1 <= 7.5 AND COL1 > 6.5 THEN COL2 = 12
IF COL1 <= 8.5 AND COL1 > 7.5 THEN COL2 = 5
IF COL1 <= 9.5 AND COL1 > 8.5 THEN COL2 = 9
IF COL1 > 9.5 THEN COL2 = 1


END SUB

REM $STATIC
SUB STEREO (MAP, PORE, A$, XFACT!, NF, N1#(), N2#(), N3#(), S1#(), S2#(), S3#(), DF#(), DD#(), SP#(), ST#(), PI#, DAT(), K1#, K2#, K3#, L1#, L2#, L3#, M1#, M2#, M3#, FRIC)

'  The stereographic projection
'  The circle
    FOR I = 1 TO 720
    ANN = 2 * PI# / 720
    AN = ANN * I
    X = 150 * SIN(AN)
    Y = 150 * COS(AN)
    X = 300 + XFACT * X
    Y = 300 + Y
    PSET (X, Y)
    NEXT I
661 LINE (300 - 150 * XFACT, 300)-(300 + 150 * XFACT, 300)
    LINE (300, 150)-(300, 450)
    
'   Printing (on screen) the stress results on screen
   
880  IF MAP = 2 THEN GOTO 881
     IF FRIC < 0 AND MAP = 0 THEN GOTO 882
     LOCATE 12, 1
     PRINT "SHEAR/NORMAL cut-off:";
     PRINT USING "#.# "; FRIC
     PRINT "BLUE:shear/normal >";
     PRINT USING "#.# "; FRIC
     PRINT "RED:shear/normal <";
     PRINT USING "#.# "; FRIC
     GOTO 882
881  LOCATE 12, 1
     PRINT "PORE PRESSURE:";
     PRINT USING " ##.# "; PORE
     PRINT "BLUE:"; CHR$(229); "n <";
     PRINT USING " ##.# "; PORE;
     PRINT " dilated"
     PRINT "RED:"; CHR$(229); "n >";
     PRINT USING " ##.# "; PORE;
     PRINT " tight"

882 LOCATE 24, 1
    PRINT "Pore pressure="; PORE
    KD = 1
    PRINT ""; CHR$(229); "-1";
     PRINT USING " ##"; DAT(10);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(11);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(7)
     PRINT ""; CHR$(229); "-2";
     PRINT USING " ##"; DAT(12);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(13);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(8)
     PRINT ""; CHR$(229); "-3";
     PRINT USING " ##"; DAT(14);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; DAT(15);
     PRINT CHR$(248);
     PRINT USING "+###.##"; DAT(9)
807 PRINT "File: "; A$; "             ";
    LOCATE 1, 1
    'PRINT "Hit any key to continue "
    LOCATE 25, 60: PRINT "Equal area plot."
    LOCATE 26, 55: PRINT "Fracture pole-green circle"
    LOCATE 27, 52: PRINT "Slip axis-green line"
    LOCATE 21, 58: IF FRIC < 0 AND MAP = 0 THEN PRINT "Intensity of ratio:"
    LOCATE 22, 57: IF FRIC < 0 AND MAP = 0 THEN PRINT "T={shear/(normal-pore)}"
    LOCATE 28, 50: PRINT "Expected slip-black line+dot"
'     Stereoplot of the principal stresses with the fracture data.
'     Three tensor are presented: the least-square and the confidence level.
'
4820 C1 = K1#: C2 = K2#: C3 = K3#: F = 1
4830 IF C3 > 0 THEN GOTO 4850
     C1 = -C1: C2 = -C2: C3 = -C3
4850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 150 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 300 - C1 * 150 * SQR(2) * SIN(TAX / 2) / RR#
     IF F = 3 THEN GOTO 4980
     IF F <> 1 THEN GOTO 4940
     X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      AP = 0
      DRAW "TA=" + VARPTR$(AP)
      DRAW "L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
      PSET (X + 8, Y + 2)
      DRAW "D5L1U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 4830
4940 IF F <> 2 THEN GOTO 4960
     X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
4960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 4830
4980 X = 300 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
END SUB

