
    CLS : COLOR (4)
    FOR J = 1 TO 5
        LOCATE J, 1
    FOR I = 1 TO 80
        PRINT CHR$(219);
    NEXT I
    NEXT J
    COLOR (15): LOCATE 2, 32
    PRINT "STRESS"
    LOCATE 3, 10
    PRINT "Inversion of fault slip data and focal-plane solutions"
    LOCATE 4, 28
    PRINT "by Ze'ev Reches": PRINT
    COLOR (2): PRINT "                VERSION 2.9, February, 1996, QuickBasic 4.0"
    PRINT : PRINT "Background appears in INVERT.WRI supplied with this disk."
    PRINT "   (including information on input files, hard copies and theory)"
    PRINT "Defaults are shown in [SQUARE BRACKETS]."
    PRINT : XFACT = 1: YFACT = 2.4
    NFF = 1000
    PRINT "Maximum number of faults allowed in this run is "; NFF
    DIM E(6, 6), F(6), X(6), G(5), MIS(18), MISS(36), MISP(18), MISSP(18)
   DIM DF(NFF), DD(NFF), SP(NFF), ST(NFF), NUMBER(NFF), DFP(NFF), DDP(NFF), SPP(NFF), STP(NFF)
   DIM N1(NFF), N2(NFF), N3(NFF), S1(NFF), S2(NFF), S3(NFF), IFAULT(NFF), FRIC(NFF)
   DIM BW(10), BW1(10), BW2(10), DAT(50, 16), UL$(50), TEMP(5, NFF), BOOT(11, 520)
   DIM B1(NFF), B2(NFF), B3(NFF), B(2 * NFF), A(2 * NFF, 5)
40 PI# = 4 * ATN(1!): PI = PI#: SMARK = 0: MISANG = 60: MISSLP = 90: NA = 0: PRINT
    PRINT "Friction coefficient is changed incrementally by the program."
    PRINT "Current range is: minimum=0.0, maximum=2.0, step=0.1,  [ACCEPT THIS RANGE] ";
    INPUT SFC$
    PRINT
    IF SFC$ <> "" THEN GOTO 130
    MUM = 0!: MUX = 2!: MUS = .1
    GOTO 131
130  PRINT "Note: friction of 0.0 may fail in few cases.  Restart with MIN.>0.01"
     INPUT "New coefficient of friction: minimum, maximum, step "; MUM, MUX, MUS
131 PRINT "Stresses are given by the units of the vertical stress (overburden load),"
    PRINT "  and are normalized by its magnitude. Note that compressive stress is negative."
    INPUT "Enter your choice for vertical stress [-100] "; SVERT
    IF SVERT = 0 THEN SVERT = -100
    PRINT
    INPUT "Mean cohesion of the faults, < 1.0 (fraction of vertical stress) [0] "; CH
    INPUT "Pore pressure, < 1.0 (fraction of vertical stress) [0] "; PP
    PRINT
    IF KCONF = 1 THEN CON = 1
    IF KCONF = 1 THEN PRINT
    'IF KCONF = 1 THEN PRINT "Running with no screen display includes automatic delete"
    'IF KCONF = 1 THEN PRINT "of faults with misfit angles larger then current setting of "; MISANG; " and "; MISSLP
    PRINT
35  COLOR (2)
    INPUT "Input FILENAME (if necessary include directory), or [DIRECTORY] "; A$
    PRINT
    IF A$ = "A" OR A$ = "a" THEN FILES "A:*.*"
    IF A$ = "B" OR A$ = "b" THEN FILES "B:*.*"
    IF A$ = "C" OR A$ = "c" THEN FILES "C:*.*"
    IF A$ = "" THEN FILES
    PRINT
    IF A$ = "A" OR A$ = "a" OR A$ = "B" OR A$ = "b" OR A$ = "C" OR A$ = "c" OR A$ = "" THEN GOTO 35
    BADOT = INSTR(A$, ".")
    IF BADOT > 0 THEN RA$ = LEFT$(A$, BADOT - 1)
    IF BADOT = 0 THEN RA$ = A$
    K$ = ".ONE"
    H$ = RA$ + K$
    XH$ = RA$ + ".TWO"
    XRH$ = RA$ + ".RSL"
    PR$ = RA$ + ".PRN"
    STS$ = RA$ + ".STR"
    CLOSE
    DFACTOR = 2
    OPEN A$ FOR INPUT AS #2
    NMR = 0: KDAT = 0
    INPUT #2, NR
    MR = NR: NRF = NR
    FOR I = 1 TO NRF
    INPUT #2, DFP(I), DDP(I), SPP(I), STP(I)
    DF(I) = DFP(I): DD(I) = DDP(I): SP(I) = SPP(I): ST(I) = STP(I)
    NEXT I
    CLOSE #2
    KBOOT = 0: KBOOTN = 0: FBOOT = 1
225 FOR I = 1 TO NRF
    DF(I) = DFP(I): DD(I) = DDP(I): SP(I) = SPP(I): ST(I) = STP(I)
    NEXT I
230 IF KBOOT = 0 THEN GOTO 235
    INPUT "Friction coefficient [0.5]: "; MUM
    IF MUM = 0 THEN MUM = .5
    MUX = MUM: MUS = .1
    INPUT "Mean cohesion of the faults, < 1.0 (fraction of vertical load) [0] "; CH
    INPUT "Pore pressure, < 1.0 (fraction of vertical load) [0] "; PP
    KCONF = 1
    PRINT "Select confidence margins afterwards: "
    PRINT "      enter 1 for margins of "; CHR$(241); " 1 S.D. (one standard deviation)"
    PRINT "      enter 2 for margins of "; CHR$(241); " 2 S.D. (two standard deviations)"
    PRINT "      any fracdtion of the cases calculated"
    FCUT = 0
    IF KCONF = 1 THEN CON = 1
    PRINT
    MISANG = 90: MISSLP = 180
    IF KCONF = 1 THEN PRINT "Note that faults with misfit angles larger then: "; MISANG; " and "; MISSLP
    IF KCONF = 1 THEN PRINT "  will be deleted.  Change misfit angles("; MISANG; ", "; MISSLP; "),1-YES [NO] ";
    INPUT KM
    IF KM = 0 THEN GOTO 231
    INPUT "Enter new misfit angles [principal, slip] "; MISANG, MISSLP
    DELBOOT = 0
    PRINT
231 FOR I = 1 TO 50
    FOR J = 1 TO 15
    DAT(I, J) = 0
    NEXT J
    NEXT I
    IF KBOOTN = 0 THEN GOTO 235
233 FOR I = 1 TO NRF
    RANDOMIZE (1 / SIN(TIMER))
    J = INT(1 + NRF * RND)
    DF(I) = DFP(J): DD(I) = DDP(J): SP(I) = SPP(J): ST(I) = STP(J)
    NEXT I
235 FOR I = 1 TO NR
    KP = 0
    CC$ = "0"
    IF I > MR THEN GOTO 370
    NUMBER(I) = I
    IF DFACTOR <> 1 THEN NF = I
    N1(I) = COS(DD(I) * PI# / 180) * SIN(DF(I) * PI# / 180)
    N2(I) = SIN(DD(I) * PI# / 180) * SIN(DF(I) * PI# / 180)
    N3(I) = COS((180 - DF(I)) * PI# / 180)
    S1(I) = COS(ST(I) * PI# / 180) * SIN((SP(I) + 90) * PI# / 180)
    S2(I) = SIN(ST(I) * PI# / 180) * SIN((SP(I) + 90) * PI# / 180)
    S3(I) = -COS((SP(I) + 90) * PI# / 180)
    IF IFAULT(I) = 0 THEN GOTO 360
    IFAULT(I) = 0
    I = I - 1
    NR = NR - 1
    FOR J = I TO NR
    K = J + 1
    IFAULT(J) = IFAULT(K)
    NEXT J
360 NEXT I

370 CLOSE
    IF CON = 1 THEN G$ = ""
    IF CON <> 1 AND KBOOT = 0 THEN INPUT "Show list and plot of input data [NO] "; G$
    YD$ = "": DFL = 0
    IF G$ = "" THEN GOTO 902
    PRINT "Fault plane:          Slip axes:          Angle (normal/slip):"
    FOR I = 1 TO NF
    RT = ABS(S1(I) * N1(I) + S2(I) * N2(I) + S3(I) * N3(I))
    IF RT >= 1 THEN RT = .99999
    RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
    RT = ABS(RT * 180 / PI#)
    PRINT USING "###"; DF(I);
    PRINT "/";
    PRINT USING "###                "; DD(I);
    PRINT USING " ###"; SP(I);
    PRINT "/";
    PRINT USING "###                "; ST(I);
    PRINT USING "##.#"; INT(100 * RT) / 100
    NEXT I
    PRINT
    PRINT
    PRINT "Hit any key to continue "
650 G$ = INKEY$
    IF G$ = "" THEN GOTO 650
660 IF KBOOTN > 0 THEN RETURN
    CLS : SCREEN 12
    LINE (0, 0)-(640, 480), 15, BF
    FOR I = 1 TO 360
    ANN = 2 * PI / 360
    AN = ANN * I
    X = 238.8 * SIN(AN)
    Y = 99.5 * COS(AN) * YFACT
    X = 400 + XFACT * X
    Y = 240 + Y
    CIRCLE (X, Y), 1, 9
    NEXT I
    LINE (400 - 238.8 * XFACT, 240)-(400 + 238.8 * XFACT, 240), 9
    LINE (400, 0)-(400, 480), 9
    IF KBOOT = 0 THEN GOTO 661
   
    LINE (0, 0)-(159, 480), 0, BF
    FOR I = 1 TO 1440
    ANN = 2 * PI / 1440
    AN = ANN * I
    X = 238.8 * SIN(AN)
    Y = 100 * COS(AN) * YFACT
    X = 400 + XFACT * X
    Y = 240 + Y
    IF X < 400 THEN LINE (159, Y)-(X - 1, Y), 0
    IF X > 400 THEN LINE (640, Y)-(X + 1, Y), 0
    NEXT I
    FOR I = 1 TO 1440
    ANN = 2 * PI / 1440
    AN = ANN * I
    X = 238.8 * SIN(AN)
    Y = 99.5 * COS(AN) * YFACT
    X = 400 + XFACT * X
    Y = 240 + Y
    CIRCLE (X, Y), 1, 9
    NEXT I

    IF KBOOT <> 0 THEN RETURN
661    RC = 240
    FOR I = 1 TO NF
    IF SP(I) < 0 THEN GOTO 662
    AN = ST(I) - 180
    IF AN < 0 THEN AN = 360 + AN
    BN = 90 - SP(I)
    IF BN = 0 THEN BN = 1
    SX = -RC * SIN(AN * PI / 180) * TAN(BN * PI / 360)
    SY = RC * COS(AN * PI / 180) * TAN(BN * PI / 360)
    GOTO 664
662 AN = ST(I)
    IF AN < 0 THEN AN = 360 + AN
    BN = 90 - ABS(SP(I))
    IF BN = 0 THEN BN = 1
    SX = -RC * SIN(AN * PI / 180) * TAN(BN * PI / 360)
    SY = RC * COS(AN * PI / 180) * TAN(BN * PI / 360)
664
    CIRCLE (400 + SX, 240 + SY), 5, 1
    CIRCLE (400 + SX, 240 + SY), 6, 1
    IF SP(I) < 0 THEN CIRCLE (400 + SX, 240 + SY), 1, 1
    IF SP(I) < 0 THEN CIRCLE (400 + SX, 240 + SY), 2, 1
    AN = DD(I) - 180
    IF AN < 0 THEN AN = 360 + AN
    BN = 90 - DF(I)
    IF BN = 0 THEN BN = 1
    RG = RC / SIN(BN * PI / 180)
    XA = 400 + RC * COS(AN * PI / 180)
    YA = 240 + RC * SIN(AN * PI / 180)
    XB = 400 - RC * COS(AN * PI / 180)
    YB = 240 - RC * SIN(AN * PI / 180)
    CX = 400 + RC * SIN(AN * PI / 180) * TAN((90 - BN) * PI / 180)
    CY = 240 - RC * COS(AN * PI / 180) * TAN((90 - BN) * PI / 180)
    CIRCLE (CX, CY), RG, 4
    X = 400 + XFACT * XS#
    Y = YS#
    DIF = ABS(ST(I) - DD(I))
800 NEXT I
    LINE (0, 0)-(159, 480), 0, BF
    FOR I = 1 TO 1440
    ANN = 2 * PI / 1440
    AN = ANN * I
    X = 238.8 * SIN(AN)
    Y = 100 * COS(AN) * YFACT
    X = 400 + XFACT * X
    Y = 240 + Y
    IF X < 400 THEN LINE (159, Y)-(X - 1, Y), 0
    IF X > 400 THEN LINE (640, Y)-(X + 1, Y), 0
    NEXT I
    FOR I = 1 TO 1440
    ANN = 2 * PI / 1440
    AN = ANN * I
    X = 238.8 * SIN(AN)
    Y = 99.5 * COS(AN) * YFACT
    X = 400 + XFACT * X
    Y = 240 + Y
    CIRCLE (X, Y), 1, 9
    NEXT I
    IF KP <> 9 THEN GOTO 805
    IF CC$ = "0" THEN PRINT "Least square"
    IF CC$ = "1" THEN PRINT "1st DEVIATION LEVEL"
    IF CC$ = "2" THEN PRINT "2nd DEVIATION LEVEL"
    GOSUB 4820
    GOSUB 880
    IF CC$ = "2" AND KCONF <> 0 THEN GOTO 805
    IF CC$ = "0" THEN KCONF = 1
    IF CC$ = "0" THEN CC$ = "1"
    IF CC$ = "0" THEN PRINT "Least square"
    IF CC$ = "1" THEN PRINT "1st DEVIATION LEVEL"
    IF CC$ = "2" THEN PRINT "2nd DEVIATION LEVEL"
    GOSUB 910
    GOSUB 4820
    GOSUB 880
    IF CC$ = "1" THEN KCONF = 1
    IF CC$ = "1" THEN CC$ = "2"
    IF CC$ = "0" THEN PRINT "Least square"
    IF CC$ = "1" THEN PRINT "1st DEVIATION LEVEL"
    IF CC$ = "2" THEN PRINT "2nd DEVIATION LEVEL"
    GOSUB 910
    GOSUB 4820
    GOSUB 880
805 KCONF = 0
    I3 = 15
    IF KP = 9 THEN I3 = 3
    FOR I = 1 TO I3
    PRINT
    NEXT I
808 PRINT : PRINT : PRINT : PRINT : PRINT
    X = 125: Y = 342
    CIRCLE (X, Y), 5, 1
    CIRCLE (X, Y), 6, 1
    CIRCLE (X, Y + 20), 5, 1
    CIRCLE (X, Y + 20), 6, 1
    CIRCLE (X, Y + 20), 1, 1
    PRINT "SLIP AXIS"
    PRINT "  Normal slip"
    PRINT "  Reverse slip"
    PRINT : PRINT
    PRINT "Equal angle,"
    PRINT "Lower hemisphere projection."
    PRINT "Planes shown as great circles,"
    GOTO 807
     
     
880 KD = KDAT
    COLOR (2)
    PRINT "S-1";
     PRINT USING " ##"; DAT(KD, 10);
     PRINT "/";
     PRINT USING "### "; DAT(KD, 11);
     PRINT USING "+###.##"; DAT(KD, 7)
     PRINT "S-2";
     PRINT USING " ##"; DAT(KD, 12);
     PRINT "/";
     PRINT USING "### "; DAT(KD, 13);
     PRINT USING "+###.##"; DAT(KD, 8)
     PRINT "S-3";
     PRINT USING " ##"; DAT(KD, 14);
     PRINT "/";
     PRINT USING "### "; DAT(KD, 15);
     PRINT USING "+###.##"; DAT(KD, 9)
     RETURN
807 PRINT "Results of "; A$;
    IF KP = 9 THEN PRINT ", friction ";
    IF KP = 9 THEN PRINT USING "#.#"; MF;
    LOCATE 1, 1
    PRINT "Hit any key to continue "
850 G$ = INKEY$
    IF G$ = "" THEN GOTO 850
    IF KBOOT = 0 THEN SCREEN 0
    IF SCOL = 12 THEN COLOR 7, 12
    IF KBOOT = 0 THEN CLS
    IF KP = 9 THEN RETURN
902 MF = MUM
     
    
910 IF MF = 0! THEN MF = .01
    MU = MF
    IF KBOOT <> 0 THEN LOCATE 1, 1
    IF KBOOT <> 0 AND KBOOTN > 0 THEN PRINT "Any key to stop "
    ASTOP$ = INKEY$
    IF ASTOP$ = "" THEN GOTO 912
    LOCATE 1, 1
    INPUT "Hit 1 to STOP, [CONTINUE] "; ASTOP
    IF ASTOP = 1 THEN KBOOT = KBOOTN
    IF ASTOP = 1 THEN GOTO 8800
912 KDAT = KDAT + 1
    IF KDAT > 49 THEN KDAT = KDAT - 1
    FOR J = 1 TO 18
    MIS(J) = 0
    MISS(J) = 0
    NEXT J
    FOR I = 1 TO NF
    SZ = SVERT
    
    B1(I) = N2(I) * S3(I) - N3(I) * S2(I)
    B2(I) = N3(I) * S1(I) - N1(I) * S3(I)
    B3(I) = N1(I) * S2(I) - N2(I) * S1(I)
    
    A(I, 1) = (-MU * N1(I) ^ 2 - N1(I) * S1(I))
    A(I, 2) = (-MU * N2(I) ^ 2 - N2(I) * S2(I))
    A(I, 3) = (-2 * N2(I) * N3(I) * MU - (N2(I) * S3(I) + S2(I) * N3(I)))
    A(I, 4) = (-2 * N1(I) * N3(I) * MU - (N3(I) * S1(I) + S3(I) * N1(I)))
     A(I, 5) = (-2 * N1(I) * N2(I) * MU - (N1(I) * S2(I) + S1(I) * N2(I)))
    
     I2 = I + NF
     A(I2, 1) = N1(I) * B1(I)
     A(I2, 2) = N2(I) * B2(I)
     A(I2, 3) = N2(I) * B3(I) + B2(I) * N3(I)
     A(I2, 4) = N3(I) * B1(I) + B3(I) * N1(I)
     A(I2, 5) = N1(I) * B2(I) + B1(I) * N2(I)
     NEXT I
     NC = 5
     NEQ = NF * 2
     IF CC$ = "0" THEN MCC = 0
     IF CC$ = "1" THEN MCC = -1
     IF CC$ = "2" THEN MCC = 1
     FOR I = 1 TO NF
     B(I) = MU * SZ * (1 - PP) + CH * SZ + MCC * RMS
     NEXT I
     NV = NF + 1
     FOR I = NV TO NEQ
     B(I) = MCC * RMS
     NEXT I
     M = NEQ: N = NC
     FOR I = 1 TO N
     FOR J = 1 TO N
     E(I, J) = 0
     F(J) = 0
     NEXT J
     NEXT I
     FOR I = 1 TO N
     FOR J = 1 TO N
     FOR K = 1 TO M
     E(I, J) = E(I, J) + A(K, I) * A(K, J)
     NEXT K
     NEXT J
     NEXT I
     FOR J = 1 TO N
     FOR K = 1 TO M
     F(J) = F(J) + A(K, J) * B(K)
     NEXT K
     NEXT J
     NN = N - 1
     FOR K = 1 TO NN
     KK = K + 1
     FOR I = KK TO N
     Z = E(I, K) / E(K, K)
     F(I) = F(I) - F(K) * Z
     FOR J = 1 TO N
     E(I, J) = E(I, J) - E(K, J) * Z
     NEXT J
     NEXT I
     NEXT K
     FOR I = 1 TO N
     Z# = E(I, I)
     FOR J = 1 TO N
     E(I, J) = E(I, J) / Z#
     NEXT J
     F(I) = F(I) / Z#
     NEXT I
     X(N) = F(N) / E(N, N)
     IF KCONF = 0 THEN PRINT
     FOR L = 1 TO NN
     K = N - L
     KL = K + 1
     G# = 0
     FOR J = KL TO N
     G# = G# + E(K, J) * X(J) / E(K, K)
     NEXT J
     X(K) = F(K) - G#
     NEXT L
     SX# = X(1) + SZ
     SY# = X(2) + SZ
     SZ# = SZ
     SYZ# = X(3)
     SXZ# = X(4)
     SXY# = X(5)
     R4# = 0
     FOR I = 1 TO M
     RI = 0
     FOR J = 1 TO N
     RI = RI + A(I, J) * X(J)
     NEXT J
     RI = RI - B(I)
     R2 = RI ^ 2
     R4# = R4# + R2
     NEXT I
     IF KCONF = 0 THEN PRINT
     IF CC$ = "0" THEN RMS = SQR(R4# / M)
     COLOR (4)
     IF KCONF = 0 THEN PRINT "STRESS INVERSION OF "; A$; ", "; NF; " FAULTS, FRICTION COEFF.= "; MF;
     IF KCONF = 0 THEN PRINT "  "; DATE$
     IF KCONF = 0 THEN PRINT "********************************************************************"
     IF KCONF = 0 THEN PRINT "The stress tensor (compression < 0;  X north, Y east, Z down; overburden=-100):"
     IF KCONF = 0 THEN PRINT "   "; CHR$(229); "x=";
     IF KCONF = 0 THEN PRINT USING "  ####.## "; SX#;
     IF KCONF = 0 THEN PRINT "  "; CHR$(229); "y=";
     IF KCONF = 0 THEN PRINT USING "  ####.## "; SY#;
     IF KCONF = 0 THEN PRINT "  "; CHR$(229); "z=";
     IF KCONF = 0 THEN PRINT USING "  ####.## "; SZ#
     IF KCONF = 0 THEN PRINT "   "; CHR$(229); "yz=";
     IF KCONF = 0 THEN PRINT USING " ####.## "; SYZ#;
     IF KCONF = 0 THEN PRINT "  "; CHR$(229); "xz=";
     IF KCONF = 0 THEN PRINT USING " ####.## "; SXZ#;
     IF KCONF = 0 THEN PRINT "  "; CHR$(229); "xy=";
     IF KCONF = 0 THEN PRINT USING " ####.## "; SXY#
     IF KCONF = 0 THEN PRINT "The root mean square error:   ";
     IF KCONF = 0 THEN PRINT USING " ####.## "; RMS
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     THET = 180 * THET / PI
     IF SY# < SX# THEN THET = THET + 90
     IF KCONF = 0 THEN PRINT CHR$(229); " HMAX= ";
     IF KCONF = 0 THEN PRINT USING " ####.# "; SIG1H;
     IF KCONF = 0 THEN PRINT "     "; CHR$(229); " hmin= ";
     IF KCONF = 0 THEN PRINT USING " ####.# "; SIG2H;
     IF KCONF = 0 THEN PRINT " Trend (from North)= ";
     IF KCONF = 0 THEN PRINT USING " ####.#"; THET;
     IF KCONF = 0 THEN PRINT CHR$(248)
     IF KCONF = 0 THEN PRINT "Selected PORE PRESSURE ";
     IF KCONF = 0 THEN PRINT USING " ####."; PP * SZ;
     IF KCONF = 0 THEN PRINT "    Selected mean COHESION ";
     IF KCONF = 0 THEN PRINT USING " ####.# "; CH * SZ
     A1# = -(SX# + SY# + SZ#)
     A2# = (SY# * SZ# + SZ# * SX# + SX# * SY#) - (SYZ# ^ 2 + SXZ# ^ 2 + SXY# ^ 2)
     A3# = -(SX# * SY# * SZ# + 2 * SYZ# * SXZ# * SXY# - SX# * (SYZ#) ^ 2 - SY# * (SXZ#) ^ 2 - SZ# * (SXY#) ^ 2)
     PI# = 4 * ATN(1!)
     Q# = (3 * A2# - A1# ^ 2) / 9
     R# = (9 * A1# * A2# - 27 * A3# - 2 * A1# ^ 3) / 54
     C# = Q# ^ 3 + R# ^ 2
     IF C# > O THEN PRINT "No real roots"
     CT# = -R# / (SQR(-Q# ^ 3))
     T# = ATN(SQR(1 - CT# ^ 2) / CT#)
     T# = ATN(CT# / SQR(1 - CT# ^ 2)) + PI# / 2
     X1# = 2 * SQR(-Q#) * COS(T# / 3) - A1# / 3
     X2# = 2 * SQR(-Q#) * COS(T# / 3 + 120 * PI# / 180) - A1# / 3
     X3# = 2 * SQR(-Q#) * COS(T# / 3 + 240 * PI# / 180) - A1# / 3

     T1# = X1#: T2# = X2#: T3# = X3#
     IF X1# <= X2# AND X2# <= X3# THEN GOTO 4338
     IF X1# <= X3# AND X3# <= X2# THEN GOTO 155
     IF X2# <= X3# AND X3# <= X1# THEN GOTO 156
     IF X2# <= X1# AND X1# <= X3# THEN GOTO 157
     IF X3# <= X1# AND X1# <= X2# THEN GOTO 158
     IF X3# <= X2# AND X2# <= X1# THEN GOTO 159
155  X1# = T1#: X2# = T3#: X3# = T2#
     GOTO 4338
156  X1# = T2#: X2# = T3#: X3# = T1#
     GOTO 4338
157  X1# = T2#: X2# = T1#: X3# = T3#
     GOTO 4338
158  X1# = T3#: X2# = T1#: X3# = T2#
     GOTO 4338
159  X1# = T3#: X2# = T2#: X3# = T1#
     GOTO 4338


     T1# = X1#: T2# = X2#: T3# = X3#
     XMIN = T1#
     XMINT = XMIN
     IF T2# >= XMIN THEN GOTO 4321
     XMIN = T2#
     T2# = XMINT
     XMINT = XMIN
4321 IF X3T# >= XMIN THEN GOTO 4322
     XMIN = T3#
     T3# = XMINT
4322 X1# = XMIN
     IF T2# >= T3# THEN GOTO 4324
     X2# = T2#: X3# = T3#: GOTO 4338
4324 X2# = T3#: X3# = T2#

4338

     IF KCONF = 0 THEN PRINT "PRINCIPAL STRESSES "
     IF KCONF = 0 THEN PRINT "               Directional cosines        Plunge/Trend       Magnitudes: "
     A11# = SX# - X1#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X1#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X1#
     Z1# = (A11# * A23# - A21# * A13#) / (A12# * A23# - A22# * A13#)
     Z2# = (A11# - Z1# * A12#) / A13#
     K1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     K2# = -K1# * Z1#
     K3# = -K1# * Z2#
     K1# = -K1#: K2# = -K2#: K3# = -K3#
     RU# = A11# * K1# + A12# * K2# + A13# * K3#
     RV# = A21# * K1# + A22# * K2# + A23# * K3#
     RX# = A31# * K1# + A32# * K2# + A33# * K3#
     IF KCONF = 0 THEN PRINT "       "; CHR$(229); " 1   ";
     IF KCONF = 0 THEN PRINT USING " ##.###  "; K1#, K2#, K3#;
     K1 = K1#: K2 = K2#: K3 = K3#
     BOOT(1, KBOOTN) = K1: BOOT(2, KBOOTN) = K2: BOOT(3, KBOOTN) = K3
     IF CC$ = "0" THEN BW(1) = K1
     IF CC$ = "0" THEN BW(2) = K2
     IF CC$ = "0" THEN BW(3) = K3
     IF CC$ = "1" THEN GOTO 4465
     IF CC$ = "2" THEN GOTO 4471
     GOTO 4482
4465 BW1(1) = K1: BW1(2) = K2: BW1(3) = K3
     GOTO 4482
4471 BW2(1) = K1: BW2(2) = K2: BW2(3) = K3
4482 IF K3# > 0 THEN GOTO 4685
     K1 = -K1#: K2 = -K2#: K3 = -K3#
4685 GOTO 4886
     IF KBOOT = 0 THEN GOTO 4886
     
4886 ALPHA = ATN(K2# / K1#)
     IF K1 < 0 THEN ALPHA = PI + ALPHA
     IF K2 < 0 AND K1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF K3 = 1 THEN K3 = .9999
     DIP = ATN(K3 / SQR(1 - K3 ^ 2))
     DIP = 180 * DIP / PI
     IF KCONF = 0 THEN PRINT "    ";
     IF KCONF = 0 THEN PRINT USING " ###"; INT(DIP);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT "/";
     IF KCONF = 0 THEN PRINT USING "###"; INT(ALPHA);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT USING "        ####.## "; X1#
     DAT(KDAT, 10) = INT(DIP): DAT(KDAT, 11) = INT(ALPHA)
     A11# = SX# - X2#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X2#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X2#
     Z1# = (A11# * A33# - A31# * A13#) / (A12# * A33# - A32# * A13#)
     Z2# = (A31# - Z1# * A32#) / A33#
     L1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     L2# = -L1# * Z1#
     L3# = -L1# * Z2#
     L1# = -L1#: L2# = -L2#: L3# = -L3#
     RU# = A11# * L1# + A12# * L2# + A13# * L3#
     RV# = A21# * L1# + A22# * L2# + A23# * L3#
     RX# = A31# * L1# + A32# * L2# + A33# * L3#
     IF KCONF = 0 THEN PRINT "       "; CHR$(229); " 2   ";
     IF KCONF = 0 THEN PRINT USING " ##.###  "; L1#, L2#, L3#;
     L1 = L1#: L2 = L2#: L3 = L3#
     BOOT(4, KBOOTN) = L1: BOOT(5, KBOOTN) = L2: BOOT(6, KBOOTN) = L3
     IF CC$ = "0" THEN BW(4) = L1
     IF CC$ = "0" THEN BW(5) = L2
     IF CC$ = "0" THEN BW(6) = L3
     IF CC$ = "1" THEN GOTO 4575
     IF CC$ = "2" THEN GOTO 4577
     GOTO 4578
4575 BW1(4) = L1: BW1(5) = L2: BW1(6) = L3
     GOTO 4578
4577 BW2(4) = L1: BW2(5) = L2: BW2(6) = L3
4578 IF L3# > 0 THEN GOTO 4579
     L1 = -L1#: L2 = -L2#: L3 = -L3#
4579 ALPHA = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA = PI + ALPHA
     IF L2 < 0 AND L1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP = 180 * DIP / PI
     IF KCONF = 0 THEN PRINT "    ";
     IF KCONF = 0 THEN PRINT USING " ###"; INT(DIP);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT "/";
     IF KCONF = 0 THEN PRINT USING "###"; INT(ALPHA);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT USING "        ####.## "; X2#
     DAT(KDAT, 12) = INT(DIP): DAT(KDAT, 13) = INT(ALPHA)
     A11# = SX# - X3#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X3#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X3#
     Z1# = (A21# * A33# - A31# * A23#) / (A22# * A33# - A32# * A23#)
     Z2# = (A21# - Z1# * A22#) / A23#
     M1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     M2# = -M1# * Z1#
     M3# = -M1# * Z2#
     RU# = A11# * M1# + A12# * M2# + A13# * M3#
     RV# = A21# * M1# + A22# * M2# + A23# * M3#
     RX# = A31# * M1# + A32# * M2# + A33# * M3#
     IF KCONF = 0 THEN PRINT "       "; CHR$(229); " 3   ";
     IF KCONF = 0 THEN PRINT USING " ##.###  "; M1#, M2#, M3#;
     M1 = M1#: M2 = M2#: M3 = M3#
     BOOT(7, KBOOTN) = M1: BOOT(8, KBOOTN) = M2: BOOT(9, KBOOTN) = M3
     IF CC$ = "0" THEN BW(7) = M1
     IF CC$ = "0" THEN BW(8) = M2
     IF CC$ = "0" THEN BW(9) = M3
     IF CC$ = "1" THEN GOTO 4691
     IF CC$ = "2" THEN GOTO 4670
     GOTO 4686
4691 BW1(7) = M1: BW1(8) = M2: BW1(9) = M3
     GOTO 4686
4670 BW2(7) = M1: BW2(8) = M2: BW2(9) = M3
4686 IF M3 > 0 THEN GOTO 4687
     M1 = -M1#: M2 = -M2#: M3 = -M3#
4687 ALPHA = ATN(M2 / M1)
     IF M1 < 0 THEN ALPHA = PI + ALPHA
     IF M2 < 0 AND M1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF M3 = 1 THEN M3 = .9999
     DIP = ATN(M3 / SQR(1 - M3 ^ 2))
     DIP = 180 * DIP / PI
     IF KCONF = 0 THEN PRINT "    ";
     IF KCONF = 0 THEN PRINT USING " ###"; INT(DIP);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT "/";
     IF KCONF = 0 THEN PRINT USING "###"; INT(ALPHA);
     IF KCONF = 0 THEN PRINT CHR$(248);
     IF KCONF = 0 THEN PRINT USING "        ####.## "; X3#
     IF KCONF = 0 THEN PRINT "Stress ratio, "; CHR$(237); "=("; CHR$(229); "2-"; CHR$(229); "3)/("; CHR$(229); "1-"; CHR$(229); "3)=";
     IF KCONF = 0 THEN PRINT USING ".##"; (X2# - X3#) / (X1# - X3#);
     PHI = (X2# - X3#) / (X1# - X3#)
     DAT(KDAT, 14) = INT(DIP): DAT(KDAT, 15) = INT(ALPHA)
     DFRIC = 0: SUMFRIC = 0
     FOR K = 1 TO NF
     DFRIC = DFRIC + (MF - FRIC(K)) ^ 2
     SUMFRIC = SUMFRIC + FRIC(K)
     NEXT K
     FDFRIC = SQR(DFRIC) / NF
     IF KCONF = 0 THEN PRINT "  Friction deviation= ";
     IF KCONF = 0 THEN PRINT USING "##.####"; FDFRIC
     DAT(KDAT, 16) = FDFRIC
     IF KBOOT <> 0 AND KBOOTN = 0 THEN GOSUB 660
     IF KBOOT <> 0 THEN GOSUB 4820
    
     W1# = K1# * L1# + K2# * L2# + K3# * L3#
     W2# = K1# * M1# + K2# * M2# + K3# * M3#
     W3# = L1# * M1# + L2# * M2# + L3# * M3#
     IF KBOOT <> 0 THEN GOTO 4740
     IF ABS(W1#) < .01 AND ABS(W2#) < .01 AND ABS(W3#) < .01 THEN GOTO 4740
     CLOSE : IF KCONF = 0 THEN PRINT
     INPUT "Principal stress axes are not normal to each other.  Stop [YES] "; B$
     IF B$ = "" THEN CLOSE
     IF B$ = "" THEN STOP

4740 GOSUB 8000
     IF KCONF = 0 AND CC$ = "0" THEN INPUT "Type Y  for stereographic plot of solution WITH confidence calculations [NO] "; B$
     IF KCONF = 1 THEN B$ = "Z"
     IF B$ = "Y" OR B$ = "y" THEN KP = 9
     IF B$ = "Y" OR B$ = "y" THEN GOSUB 660
4754 GOTO 6000


4820 C1 = K1#: C2 = K2#: C3 = K3#: F = 1
4830 IF C3 > 0 THEN GOTO 4850
     C1 = -C1: C2 = -C2: C3 = -C3
4850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TA = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 238.8 * SQR(2) * SIN(TA / 2) / RR#
     YF# = 240 - C1 * 240 * SQR(2) * SIN(TA / 2) / RR#
     IF F = 3 THEN GOTO 4980
     IF F <> 1 THEN GOTO 4940
     X = 400 + XFACT * XF#
     Y = YF#
     FOR K = 1 TO 18
     IF KBOOT = 0 THEN CIRCLE (X, Y), K, 0
     NEXT K
     IF KBOOT = 0 THEN LINE (X - 12, Y - 12)-(X + 12, Y + 12), 0, BF
     IF KBOOT = 0 OR FBT = 7 THEN PSET (X, Y), 12
     IF KBOOT = 0 THEN CIRCLE (X, Y), 18, 12
     IF FBT = 7 THEN DRAW "U24;D48;U24;L24;R48;L24"
     IF KBOOT <> 0 AND FBOOT <> 0 THEN CIRCLE (X, Y), 4, 12
     IF KBOOT <> 0 AND FBOOT = 0 THEN CIRCLE (X, Y), 4, 15
     IF KBOOT = 0 THEN PSET (X + 4, Y - 3), 12
     IF KBOOT = 0 THEN DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
     IF KBOOT = 0 THEN PSET (X + 8, Y + 2), 12
     IF KBOOT = 0 THEN DRAW "D5;L1;U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 4830
4940 IF F <> 2 THEN GOTO 4960
     X = 400 + XFACT * XF#
     Y = YF#
     FOR K = 1 TO 18
     IF KBOOT = 0 THEN CIRCLE (X, Y), K, 0
     NEXT K
    IF KBOOT = 0 THEN LINE (X - 12, Y - 12)-(X + 12, Y + 12), 0, BF
     IF KBOOT = 0 OR FBT = 7 THEN PSET (X, Y), 2
     IF KBOOT = 0 THEN CIRCLE (X, Y), 18, 2
     IF FBT = 7 THEN DRAW "U24;D48;U24;L24;R48;L24"
     IF KBOOT <> 0 AND FBOOT <> 0 THEN CIRCLE (X, Y), 3, 2
     IF KBOOT <> 0 AND FBOOT = 0 THEN CIRCLE (X, Y), 3, 15
     IF KBOOT = 0 THEN PSET (X + 4, Y - 3), 2
     IF KBOOT = 0 THEN DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
     IF KBOOT = 0 THEN PSET (X + 8, Y + 3), 2
     IF KBOOT = 0 THEN DRAW "R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
4960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 4830
4980 X = 400 + XFACT * XF#
     Y = YF#
     FOR K = 1 TO 18
     IF KBOOT = 0 THEN CIRCLE (X, Y), K, 0
     NEXT K
    IF KBOOT = 0 THEN IF KBOOT = 0 THEN LINE (X - 12, Y - 12)-(X + 12, Y + 12), 0, BF
     IF KBOOT = 0 OR FBT = 7 THEN PSET (X, Y), 9
     IF KBOOT = 0 THEN CIRCLE (X, Y), 18, 9
     IF FBT = 7 THEN DRAW "U24;D48;U24;L24;R48;L24"
     IF KBOOT <> 0 AND FBOOT <> 0 THEN CIRCLE (X, Y), 2, 9
     IF KBOOT <> 0 AND FBOOT = 0 THEN CIRCLE (X, Y), 2, 15
     IF KBOOT = 0 THEN PSET (X + 4, Y - 3), 9
     IF KBOOT = 0 THEN DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
     IF KBOOT = 0 THEN PSET (X + 8, Y + 3), 9
     IF KBOOT = 0 THEN DRAW "R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
     IF KBOOT <> 0 THEN LOCATE 2, 1
     IF KBOOT <> 0 THEN PRINT KBOOTN; " solutions, random selection"
     RETURN
6000 R5 = SQR(R4# / M)
     BZ = SZ#
     X1 = CSNG(X1#): X2 = CSNG(X2#): X3 = CSNG(X3#)
     K1 = CSNG(K1#): K2 = CSNG(K2#): K3 = CSNG(K3#)
     L1 = CSNG(L1#): L2 = CSNG(L2#): L3 = CSNG(L3#)
     M1 = CSNG(M1#): M2 = CSNG(M2#): M3 = CSNG(M3#)
     IF KCONF <> 0 AND CON <> 1 THEN RETURN
     CC$ = ""
     IF CON <> 1 THEN KCONF = 0
     IF CC$ = "1" OR CC$ = "2" THEN GOTO 910
     IF CC$ = "" THEN CC$ = "0"
     IF MF = .01 THEN MF = 0!
     MF = MF + MUS
     IF KBOOT <> 0 THEN KBOOTN = KBOOTN + 1
     IF KBOOTN < KBOOT THEN GOTO 233
     IF MF <= MUX THEN GOTO 910
     GOTO 8210
8000 COTOT = 0: NORM = 0
     FOR Y = 1 TO NF
     A1 = N1(Y) ^ 2
     B1 = N1(Y) * S1(Y)
     A2 = N2(Y) ^ 2
     B2 = N2(Y) * S2(Y)
     A3 = N3(Y) ^ 2
     B3 = N3(Y) * S3(Y)
     A4 = 2 * N2(Y) * N3(Y)
     B4 = (N2(Y) * S3(Y) + S2(Y) * N3(Y))
     A5 = 2 * N1(Y) * N3(Y)
     B5 = (N3(Y) * S1(Y) + S3(Y) * N1(Y))
     A6 = 2 * N1(Y) * N2(Y)
     B6 = N1(Y) * S2(Y) + S1(Y) * N2(Y)
     SN = A1 * SX# + A2 * SY# + A3 * SZ# + A4 * SYZ# + A5 * SXZ# + A6 * SXY#
     SSH = -(B1 * SX# + B2 * SY# + B3 * SZ# + B4 * SYZ# + B5 * SXZ# + B6 * SXY#)
     FRIC(Y) = SSH / SN
     COH = SSH - SN * MU
     COTOT = COTOT + COH
     NORM = NORM + SN * MU
     NEXT Y
     MEANCO = COTOT / NF
     NORM = NORM / NF
     Y$ = ""
8171 TOTROT = 0: TOTROTS = 0: MR = NF: MISFIT = 0
     NUMSLIP = 0: NUMHF = 0: CDR = 0
     FOR J = 1 TO 18
     MIS(J) = 0
     MISS(J) = 0
     NEXT J
     FOR I = 1 TO NF
8172 IF KBOOT <> 0 THEN GOTO 8173
     IF I > NF AND DFL <> 0 THEN GOTO 235
8173 RX = (N1(I) * SX# + N2(I) * SXY# + N3(I) * SXZ#)
     RY = (N1(I) * SXY# + N2(I) * SY# + N3(I) * SYZ#)
     RZ = (N1(I) * SXZ# + N2(I) * SYZ# + N3(I) * SZ#)
     SIGN = N1(I) * RX + N2(I) * RY + N3(I) * RZ
     RP = SQR(RX ^ 2 + RY ^ 2 + RZ ^ 2)
     IF ABS(SIGN) > RP THEN SIGN = -.9999 * RP
     SIGS = SQR(RP ^ 2 - SIGN ^ 2)
     FCMAX = ABS(SIGS / SIGN)
8174 RX = RX / RP: RY = RY / RP: RZ = RZ / RP
     RT = ABS(S1(I) * N1(I) + S2(I) * N2(I) + S3(I) * N3(I))
     IF RT >= 1 THEN RT = .99999
     RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
     RT = ABS(RT * 180 / PI#)
     ALP = ATN(MU)
     ALP = PI / 4 - ALP / 2
     ALP1 = ALP * RT / 90
     ALP2 = RT * PI# / 180 - ALP1
     G(1) = -N1(I) * COS(ALP2) + S1(I) * COS(ALP1)
     G(2) = -N2(I) * COS(ALP2) + S2(I) * COS(ALP1)
     G(3) = -N3(I) * COS(ALP2) + S3(I) * COS(ALP1)
     GTT = SQR(G(1) ^ 2 + G(2) ^ 2 + G(3) ^ 2)
     G(1) = G(1) / GTT: G(2) = G(2) / GTT: G(3) = G(3) / GTT
     IF ABS(G(1)) > ABS(G(2)) AND ABS(G(1)) > ABS(G(3)) THEN GMARK = 1
     IF ABS(G(2)) > ABS(G(1)) AND ABS(G(2)) > ABS(G(3)) THEN GMARK = 2
     IF ABS(G(3)) > ABS(G(1)) AND ABS(G(3)) > ABS(G(2)) THEN GMARK = 3
     FOR K = 1 TO 3
     IF CC$ = "0" THEN MARK = SGN(BW(K))
     IF CC$ = "0" AND ABS(BW(K)) > .579 THEN GOTO 8490
     IF CC$ = "1" THEN MARK = SGN(BW1(K))
     IF CC$ = "1" AND ABS(BW1(K)) > .579 THEN GOTO 8490
     IF CC$ = "2" THEN MARK = SGN(BW1(K))
     IF CC$ = "2" AND ABS(BW2(K)) > .579 THEN GOTO 8490
     NEXT K
8490 IF GMARK = 1 THEN GOTO 8491
     IF GMARK = 2 THEN GOTO 8492
     IF CC$ = "0" AND ABS(BW(3)) > ABS(BW(2)) OR CC$ = "0" AND ABS(BW(3)) > ABS(BW(1)) THEN GOTO 8496
     IF CC$ = "1" AND ABS(BW1(3)) > ABS(BW1(2)) OR CC$ = "0" AND ABS(BW1(3)) > ABS(BW1(1)) THEN GOTO 8496
     IF CC$ = "2" AND ABS(BW2(3)) > ABS(BW2(2)) OR CC$ = "0" AND ABS(BW2(3)) > ABS(BW2(1)) THEN GOTO 8496
     GOTO 8498
8491 IF CC$ = "0" AND ABS(BW(1)) > ABS(BW(2)) OR CC$ = "0" AND ABS(BW(1)) > ABS(BW(3)) THEN GOTO 8496
     IF CC$ = "1" AND ABS(BW1(1)) > ABS(BW1(2)) OR CC$ = "0" AND ABS(BW1(1)) > ABS(BW1(3)) THEN GOTO 8496
     IF CC$ = "2" AND ABS(BW2(1)) > ABS(BW2(2)) OR CC$ = "0" AND ABS(BW2(1)) > ABS(BW2(3)) THEN GOTO 8496
     GOTO 8498
8492 IF CC$ = "0" AND ABS(BW(2)) > ABS(BW(1)) OR CC$ = "0" AND ABS(BW(2)) > ABS(BW(3)) THEN GOTO 8496
     IF CC$ = "1" AND ABS(BW1(2)) > ABS(BW1(1)) OR CC$ = "0" AND ABS(BW1(2)) > ABS(BW1(3)) THEN GOTO 8496
     IF CC$ = "2" AND ABS(BW2(2)) > ABS(BW2(1)) OR CC$ = "0" AND ABS(BW2(2)) > ABS(BW2(3)) THEN GOTO 8496
     GOTO 8498
8496 IF CC$ = "0" AND SGN(G(GMARK)) = SGN(BW(GMARK)) THEN GOTO 8498
     IF CC$ = "1" AND SGN(G(GMARK)) = SGN(BW1(GMARK)) THEN GOTO 8498
     IF CC$ = "2" AND SGN(G(GMARK)) = SGN(BW2(GMARK)) THEN GOTO 8498
     G(1) = -G(1): G(2) = -G(2): G(3) = -G(3)
8498 IF CC$ = "0" THEN ROT = ABS(BW(1) * G(1) + BW(2) * G(2) + BW(3) * G(3))
     IF CC$ = "1" THEN ROT = ABS(BW1(1) * G(1) + BW1(2) * G(2) + BW1(3) * G(3))
     IF CC$ = "2" THEN ROT = ABS(BW2(1) * G(1) + BW2(2) * G(2) + BW2(3) * G(3))
     IF ROT >= 1 THEN ROT = .99999
     ROT = PI / 2 - ATN(ROT / SQR(1 - ROT ^ 2))
     ROT = ABS(ROT * 180 / PI#)
     G31 = G(2) * B3(I) - G(3) * B2(I)
     G32 = G(3) * B1(I) - G(1) * B3(I)
     G33 = G(1) * B2(I) - G(2) * B1(I)
     G21 = B1(I)
     G22 = B2(I)
     G23 = B3(I)
     IF CC$ = "0" THEN ROT2 = ABS(BW(4) * G21 + BW(5) * G22 + BW(6) * G23)
     IF CC$ = "1" THEN ROT2 = ABS(BW1(4) * G21 + BW1(5) * G22 + BW1(6) * G23)
     IF CC$ = "2" THEN ROT2 = ABS(BW2(4) * G21 + BW2(5) * G22 + BW2(6) * G23)
     IF ROT2 >= 1 THEN ROT2 = .99999
     ROT2 = PI / 2 - ATN(ROT2 / SQR(1 - ROT2 ^ 2))
     ROT2 = ABS(ROT2 * 180 / PI#)
     IF CC$ = "0" THEN ROT3 = ABS(BW(7) * G31 + BW(8) * G32 + BW(9) * G33)
     IF CC$ = "1" THEN ROT3 = ABS(BW1(7) * G31 + BW1(8) * G32 + BW1(9) * G33)
     IF CC$ = "2" THEN ROT3 = ABS(BW2(7) * G31 + BW2(8) * G32 + BW2(9) * G33)
     IF ROT3 >= 1 THEN ROT3 = .99999
     ROT3 = PI / 2 - ATN(ROT3 / SQR(1 - ROT3 ^ 2))
     ROT3 = ABS(ROT3 * 180 / PI#)
     ROTPA = (ROT * (1 - PHI) + ROT3 * PHI)
     IMIS = INT((5 + ROTPA) / 5)
     MIS(IMIS) = MIS(IMIS) + 1
     IF ROTPA > MISANG THEN NUMHF = NUMHF + 1
     MISFIT = MISFIT + ROTPA
     B1 = N2(I) * RZ - N3(I) * RY
     B2 = N3(I) * RX - N1(I) * RZ
     B3 = N1(I) * RY - N2(I) * RX
     RB = SQR(B1 ^ 2 + B2 ^ 2 + B3 ^ 2)
     B1 = B1 / RB: B2 = B2 / RB: B3 = B3 / RB
     Q1 = N2(I) * B3 - N3(I) * B2
     Q2 = N3(I) * B1 - N1(I) * B3
     Q3 = N1(I) * B2 - N2(I) * B1
     RQ = SQR(Q1 ^ 2 + Q2 ^ 2 + Q3 ^ 2)
     Q1 = -Q1 / RQ: Q2 = -Q2 / RQ: Q3 = -Q3 / RQ
     ROTS = (Q1 * S1(I) + Q2 * S2(I) + Q3 * S3(I))
     IF ROTS >= 1 THEN ROTS = .999
     ROTS = PI# / 2 - ATN(ROTS / SQR(1 - ROTS ^ 2))
     ROTS = ABS(ROTS * 180 / PI#)
     IMISS = INT((5 + ABS(ROTS)) / 5)
     MISS(IMISS) = MISS(IMISS) + 1
     IF ROTS > MISSLP THEN NUMSLIP = NUMSLIP + 1
     IF YD$ = "A" THEN GOTO 8176
     IF Y$ = "" THEN GOTO 8180
    PRINT
     DIF = ABS(ST(I) - DD(I))
    IF ST(I) = DD(I) THEN SENSE$ = "     NORMAL     "
    IF ST(I) > DD(I) AND DIF <= 45 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST(I) > DD(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST(I) > DD(I) AND DIF = 90 THEN SENSE$ = "     DEXTRAL     "
    IF ST(I) > DD(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST(I) > DD(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST(I) > DD(I) AND DIF = 180 THEN SENSE$ = "    REVERSE      "
    IF ST(I) > DD(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST(I) > DD(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST(I) > DD(I) AND DIF = 270 THEN SENSE$ = "    SINISTRAL    "
    IF ST(I) > DD(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST(I) > DD(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST(I) > DD(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
    IF ST(I) < DD(I) AND DIF <= 45 THEN SENSE$ = "NORMAL-SINISTRAL"
    IF ST(I) < DD(I) AND DIF > 45 AND DIF < 90 THEN SENSE$ = "SINISTRAL-NORMAL"
    IF ST(I) < DD(I) AND DIF = 90 THEN SENSE$ = "    SINISTRAL    "
    IF ST(I) < DD(I) AND DIF > 90 AND DIF < 135 THEN SENSE$ = "SINISTRAL-REVERSE"
    IF ST(I) < DD(I) AND DIF >= 135 AND DIF < 180 THEN SENSE$ = "REVERSE-SINISTRAL"
    IF ST(I) < DD(I) AND DIF = 180 THEN SENSE$ = "    REVERSE    "
    IF ST(I) < DD(I) AND DIF > 180 AND DIF < 225 THEN SENSE$ = " REVERSE-DEXTRAL "
    IF ST(I) < DD(I) AND DIF >= 225 AND DIF < 270 THEN SENSE$ = " DEXTRAL-REVERSE "
    IF ST(I) < DD(I) AND DIF = 270 THEN SENSE$ = "     DEXTRAL    "
    IF ST(I) < DD(I) AND DIF > 270 AND DIF < 315 THEN SENSE$ = " DEXTRAL-NORMAL "
    IF ST(I) < DD(I) AND DIF >= 315 AND DIF < 360 THEN SENSE$ = " NORMAL-DEXTRAL "
    IF ST(I) < DD(I) AND DIF = 360 THEN SENSE$ = "     NORMAL     "
     IF Y$ <> "" AND YQ$ <> "Q" THEN CLS
     IF Y$ <> "" THEN PRINT "Fault # "; I;
     PRINT "Original fault: plane "; DF(I); "/"; DD(I); " slip axis "; INT(.5 + SP(I)); "/"; INT(.5 + ST(I))
     PRINT "                slip sense          : "; SENSE$
     PRINT "                normal to slip angle: ";
     PRINT USING "###.##  "; RT
     IF YQ$ <> "Q" THEN PRINT
     PRINT "SLIP MISFIT"
     PRINT "  (Angle between slip axis and maximum resolved shear direction  = ";
     PRINT USING "##.##"; ROTS
     PRINT "PRINCIPAL AXES MISFIT"
     PRINT "  (angle between general tensor and ideal tensor for this fault) = ";
     PRINT USING "##.##"; ROTPA
     PRINT "Misfits:  Axis 1    Axis 2     Axis 3"
     PRINT "   ";
     PRINT USING "    ##.##    "; ROT, ROT2, ROT3

     IF YQ$ <> "Q" THEN PRINT
     PRINT "Maximum shear stress/normal stress on this fault                 = ";
     PRINT USING "##.##"; FCMAX
     PRINT "Shear stress/normal stress in slip direction                     = ";
     PRINT USING "##.##"; FRIC(I)
     IF YQ$ <> "Q" THEN PRINT
     IF YQ$ <> "Q" THEN PRINT "Note: if normal to slip angle is NOT 89.8-90.2 then maximum shear/normal"
     IF YQ$ <> "Q" THEN PRINT "      ratio may be SMALLER then shear/normal ratio in slip direction !!"
     DR = 0
     IF YQ$ <> "Q" THEN GOTO 8160
     CDR = CDR + 1
     IF INT(CDR / 2) <> CDR / 2 THEN GOTO 8180
     INPUT "1-delete first, 2-delete second, 3-return to main [CONTINUE]  "; DR
     PRINT
     GOTO 8178
8160 INPUT "2-delete current fault, 3-return to main [CONTINUE]  "; DR
     PRINT
     GOTO 8178
8176 DR = 0
     IF YQ$ <> "Q" THEN GOTO 8177
     CDR = CDR + 1
     IF FSP <> 1 THEN GOTO 8170
     IF INT(CDR / 2) <> CDR / 2 THEN TEMPANG = ROTPA
     IF INT(CDR / 2) <> CDR / 2 THEN GOTO 8178
     IF TEMPANG > ROTPA THEN DR = 1
     IF TEMPANG <= ROTPA THEN DR = 2
     GOTO 8178
8170 IF INT(CDR / 2) <> CDR / 2 THEN TEMS = ROTS
     IF INT(CDR / 2) <> CDR / 2 THEN GOTO 8178
     IF TEMS > ROTS THEN DR = 1
     IF TEMS <= ROTS THEN DR = 2
     GOTO 8178
8177 IF YD$ = "A" AND ROTS > MISSLP THEN DR = 2
     IF YD$ = "A" AND ROTPA > MISANG THEN DR = 2
8178 IF DR = 3 THEN GOTO 8199
     IF DR = 1 OR DR = 2 THEN SMARK = 1
     IF DR = 0 THEN GOTO 8180
   
   
     IF DR = 1 THEN GOTO 8495
     NMR = NMR + 1
     TEMP(1, NMR) = DF(I)
     TEMP(2, NMR) = DD(I)
     TEMP(3, NMR) = SP(I)
     TEMP(4, NMR) = ST(I)
     TEMP(5, NMR) = NUMBER(I)
     DFL = DFL + 1: NF = NF - 1: DFACTOR = 1
     FOR JL = I TO NF
     jJ = JL + 1
     DF(JL) = DF(jJ): DD(JL) = DD(jJ)
     SP(JL) = SP(jJ): ST(JL) = ST(jJ)
     N1(JL) = N1(jJ): N2(JL) = N2(jJ): N3(JL) = N3(jJ)
     S1(JL) = S1(jJ): S2(JL) = S2(jJ): S3(JL) = S3(jJ)
     B1(JL) = B1(jJ): B2(JL) = B2(jJ): B3(JL) = B3(jJ)
     NUMBER(JL) = NUMBER(jJ)
     FRIC(JL) = FRIC(jJ)
     NEXT JL
     IF DR = 2 THEN GOTO 8487
8495 NMR = NMR + 1
     TEMP(1, NMR) = DF(I - 1)
     TEMP(2, NMR) = DD(I - 1)
     TEMP(3, NMR) = SP(I - 1)
     TEMP(4, NMR) = ST(I - 1)
     TEMP(5, NMR) = NUMBER(I - 1)
     DFL = DFL + 1: NF = NF - 1: DFACTOR = 1
     FOR JL = I - 1 TO NF
     jJ = JL + 1
     DF(JL) = DF(jJ): DD(JL) = DD(jJ)
     SP(JL) = SP(jJ): ST(JL) = ST(jJ)
     N1(JL) = N1(jJ): N2(JL) = N2(jJ): N3(JL) = N3(jJ)
     S1(JL) = S1(jJ): S2(JL) = S2(jJ): S3(JL) = S3(jJ)
     B1(JL) = B1(jJ): B2(JL) = B2(jJ): B3(JL) = B3(jJ)
     NUMBER(JL) = NUMBER(jJ)
     FRIC(JL) = FRIC(jJ)
     NEXT JL
8487 GOTO 8172
8180 SIGNOR = SIGN * MU
     IF KBOOT <> 0 THEN GOTO 8185
     IF SIGNOR > 0 OR ABS(SIGNOR) < ABS(NORM) / 10 THEN MR = MR - 1
     IF SIGNOR > 0 OR ABS(SIGNOR) < ABS(NORM) / 10 THEN IFAULT(I) = 1
     IF IFAULT(I) = 1 THEN PRINT " Fault # "; I; " was rejected (tensile normal stress)"
     IF SIGNOR > 0 OR ABS(SIGNOR) < ABS(NORM) / 10 THEN GOTO 8190
8185 TOTROT = TOTROT + ROT
     TOTROTS = TOTROTS + ROTS
8190 NEXT I
     IF MR = 0 THEN GOTO 8191
     MEANROT = TOTROT / MR
     MEANROTS = TOTROTS / MR
8191 IF KCONF = 0 THEN PRINT " Mean calculated COHESION / Vertical stress= ";
     IF KCONF = 0 THEN PRINT USING "###.#### "; MEANCO / 100
     IF KCONF = 0 THEN PRINT "MISFIT ANGLES (degrees): "
     IF KCONF = 0 THEN PRINT "    Mean angle between OBSERVED and CALCULATED Slip axis :         ";
     IF KCONF = 0 THEN PRINT USING "##.##"; INT(100 * MEANROTS) / 100;
     IF KCONF = 0 THEN PRINT CHR$(248)
     IF KCONF = 0 THEN PRINT "    Mean angle between GENERAL and IDEAL principal stress axes:    ";
     IF KCONF = 0 THEN PRINT USING "##.##"; INT(100 * (MISFIT / MR)) / 100;
     IF KCONF = 0 THEN PRINT CHR$(248)
     IF KCONF = 0 THEN PRINT "Faults to be deleted:"
     IF KCONF = 0 THEN PRINT "   "; NUMSLIP; " faults with slip misfit larger then ";
     IF KCONF = 0 THEN PRINT USING "##.#"; MISSLP;
     IF KCONF = 0 THEN PRINT CHR$(248)
     IF KCONF = 0 THEN PRINT "   "; NUMHF; " faults with principal axes misfit larger then ";
     IF KCONF = 0 THEN PRINT USING "##.#"; MISANG;
     IF KCONF = 0 THEN PRINT CHR$(248)
     IF KCONF = 0 THEN PRINT
     DAT(KDAT, 1) = INT(100 * MF) / 100
     DAT(KDAT, 2) = MR
     DAT(KDAT, 3) = INT(100 * (MISFIT / MR)) / 100
     DAT(KDAT, 4) = INT(100 * MEANROTS) / 100
     DAT(KDAT, 5) = INT(100 * (MISFIT / MR)) / 100
     DAT(KDAT, 6) = INT(KTEST * 100) / 100
     DAT(KDAT, 7) = X1#
     DAT(KDAT, 8) = X2#
     DAT(KDAT, 9) = X3#
     IF CC$ = "1" THEN UL$(KDAT) = "U"
     IF CC$ = "2" THEN UL$(KDAT) = "L"
     IF CC$ = "0" THEN UL$(KDAT) = "S"
8199 YQ$ = "": Y$ = "": YD$ = "": YD$ = ""
COLOR (2)
     IF KCONF = 0 THEN INPUT "Continue [YES] "; Y$
     IF KCONF = 0 THEN PRINT "Type one the options for further examination of results:"
     IF KCONF = 0 THEN PRINT "  Y  examine results for each individual fault,"
     IF KCONF = 0 THEN PRINT "  A  display distribution of misfit angles and automatic deletion of faults,"
     IF KCONF = 0 THEN PRINT "  S  save the calculated stress tensor for use in other programs,"
     IF KCONF = 0 THEN PRINT "  X  exit (all results can be saved)."
     IF KCONF = 0 THEN INPUT "  [ENTER]  continue.    "; Y$
     IF Y$ = "S" OR Y$ = "s" THEN OPEN STS$ FOR OUTPUT AS #3
     IF Y$ = "S" OR Y$ = "s" THEN PRINT #3, SX# / 100, SY# / 100, SZ# / 100, SXY# / 100, SXZ# / 100, SYZ# / 100
     IF Y$ = "S" OR Y$ = "s" THEN CLOSE #3
     IF Y$ = "S" OR Y$ = "s" THEN GOTO 8199
     IF Y$ = "Y" OR Y$ = "y" THEN GOTO 8198
     IF Y$ = "" THEN GOTO 8198
     IF Y$ = "Q" OR Y$ = "q" THEN GOTO 8198
     IF Y$ = "A" OR Y$ = "a" THEN GOTO 8198
     IF Y$ = "X" OR Y$ = "x" THEN GOTO 8210
     CLS
     GOTO 8199
8198 IF NUMSLIP + NUMHF > 0 AND CON = 1 THEN Y$ = "A"
     IF KBOOT <> 0 THEN Y$ = ""
     IF Y$ = "Q" OR Y$ = "q" THEN YQ$ = "Q"
     FSP = 0
     IF YQ$ = "Q" THEN INPUT "Focal-plane selection using PRINCIPAL AXES (type 1) or [SLIP] misfit "; FSP
     IF YQ$ = "Q" THEN YD$ = "A"
     IF Y$ = "X" OR Y$ = "x" THEN GOTO 8210
     IF Y$ = "A" OR Y$ = "a" THEN YD$ = "A"
     IF YD$ = "A" THEN Y$ = ""
     IF YD$ = "A" THEN GOTO 8300
     IF Y$ = "" THEN GOTO 8195
8150 IF Y$ = "Y" OR Y$ = "y" THEN INPUT "Type Q to examine focal-plane solutions in pairs, H-help [NO] "; PF$
     IF PF$ = "" THEN GOTO 8155
     IF PF$ = "Q" OR PF$ = "q" THEN YQ$ = "Q"
     IF PF$ = "Q" OR PF$ = "q" THEN GOTO 8155
     CLS
     PRINT
     PRINT "Focal-plane solutions should appear in the original file in pairs- a fault plane"
     PRINT "  and its auxiliary plane.  Type Q to observe the TWO planes together"
     PRINT "  and then you can delete the plane with the larger misfit angles."
     PRINT "  This process can be done automatically during the previous command."
     PRINT
     GOTO 8150
8155 GOTO 8171
8195 RETURN
8300 IF KBOOT = 0 THEN CLS
     IF YQ$ <> "Q" THEN GOTO 8315
     MISANG = 90: MISSLP = 180
     GOTO 8335
8315 IF KCONF = 1 THEN GOTO 8335
     IF SCOL = 12 THEN COLOR 10, 4
     CLS
     IF SCOL = 12 THEN COLOR 10, 4

     COLOR (15)
     PRINT "Frequency of:"
     COLOR (2): PRINT "PRINCIPAL AXES MISFIT   ";
     COLOR (4): PRINT "           SLIP AXES MISFIT"
     COLOR (2)
     PRINT " ANGLE     FREQUENCY        ";
     COLOR (4)
     PRINT "       ANGLE       FREQUENCY "
     MAXP = 0: MAXS = 0
     FOR I = 1 TO 18
        MISP(I) = MIS(I)
        MISSP(I) = MISS(I)
                IF MIS(I) > MAXP THEN MAXP = MIS(I)
                IF MISS(I) > MAXS THEN MAXS = MISS(I)
     NEXT I

     FOR I = 1 TO 18
                IF MIS(I) <> 0 THEN MIS(I) = INT(1 + MIS(I) * 24 / MAXP)
                IF MISS(I) <> 0 THEN MISS(I) = INT(1 + MISS(I) * 24 / MAXS)
     'IF SCOL = 12 THEN COLOR 7, 12
     COLOR (2)
      PRINT USING "  ## "; I * 5;
     'IF SCOL = 12 THEN COLOR 10, 4
     FOR J = 1 TO MIS(I)
        IF J < MIS(I) THEN PRINT CHR$(178);
     NEXT J
     'IF SCOL = 12 THEN COLOR 7, 12
     IF MIS(I) <> 0 THEN KS = 31
     IF MIS(I) = 0 THEN KS = 30
     FOR K = MIS(I) + 1 TO KS
        PRINT " ";
     NEXT K
     COLOR (4)
     IF MISS(I) <> 0 THEN PRINT USING " ### "; I * 5;
     IF MISS(I) = 0 THEN PRINT USING " ### "; I * 5
     'IF SCOL = 12 THEN COLOR 1, 4
     FOR J = 1 TO MISS(I)
        IF J < MISS(I) THEN PRINT CHR$(178);
        IF J = MISS(I) THEN PRINT CHR$(178)
     NEXT J
     'IF SCOL = 12 THEN COLOR 7, 12

     NEXT I
     COLOR (2)
     PRINT "Note: slip misfits larger then 90 degrees are not shown here."
     PRINT
     PRINT "Save data of this plot for use by a spreadsheet in "; PR$; "  [NO]";
     INPUT R$
     IF R$ = "" THEN GOTO 8329
     OPEN PR$ FOR OUTPUT AS #3
     PRINT #3, "Plot data of file "; PR$; " to be used from spreadsheet"
     PRINT #3, "Note that the maximum for principal axes is 90 deg. and for slip 180"
     PRINT #3, "Slip misfits larger then 90 degrees have been deleted in STRESS."
     PRINT #3,
     PRINT #3, "ANGLE    PRINCIPAL AXES      SLIP"
     FOR I = 1 TO 18
     PRINT #3, I * 5, MISP(I), MISSP(I)
     NEXT I
8329 PRINT "Current cutoff angles: PRINCIPAL= "; MISANG; ", SLIP= "; MISSLP; ".    New [NO] ";
     INPUT NM$
8330 FOR J = 1 TO 18
     MIS(J) = 0
     MISS(J) = 0
     NEXT J
     IF NM$ = "" THEN GOTO 8171
     INPUT "New cutoff angles : PRINCIPAL, SLIP "; MISANG, MISSLP





8335 IF SCOL = 12 THEN COLOR 7, 12
     GOTO 8171
8210 CLOSE
  
     PRINT
     IF KBOOT = 0 THEN PRINT "Save SELECTED faults: Y-save as "; H$; ", Name for YOUR file [NO] ";
     IF KBOOT = 0 THEN INPUT NF$
     NFD$ = ""
     IF NF$ = "" THEN GOTO 8215
     IF NF$ = "Y" OR NF$ = "y" THEN NF$ = H$
     OPEN NF$ FOR OUTPUT AS #4
     PRINT #4, MR
     FOR I = 1 TO MR
     PRINT #4, DF(I), DD(I), SP(I), ST(I)
     NEXT I
     CLOSE #4
     IF KBOOT = 0 THEN PRINT "Save DELETED faults: Y-save as "; XH$; ", Name for YOUR file [NO] ";
     IF KBOOT = 0 THEN INPUT NFD$
     IF NFD$ = "" THEN GOTO 8215
     IF NFD$ = "Y" OR NFD$ = "y" THEN NFD$ = XH$
     OPEN NFD$ FOR OUTPUT AS #3
     PRINT #3, NMR
     FOR I = 1 TO NMR
     PRINT #3, TEMP(1, I), TEMP(2, I), TEMP(3, I), TEMP(4, I)
     NEXT I
     PRINT #3, "List of the numbers of faults which were deleted."
     PRINT #3, "  This list can be compared with the original list"
     PRINT #3, "  to detect the reasons for deletion.  This list does not"
     PRINT #3, "  prevent using this file as input for STRESS."
     FOR I = 1 TO NMR
     PRINT #3, TEMP(5, I); "  ";
     NEXT I
     CLOSE
  
  
8215 IF KBOOT = 0 THEN INPUT "Show results on screen [NO] "; DAT$
     IF DAT$ = "" THEN GOTO 8216
     IF KBOOT = 0 THEN CLS
     PRINT "Results of "; A$; "                   Date: "; DATE$
     PRINT "   Selected pore pressure is "; PP * SZ; " and mean cohesion is "; CH * SZ
     PRINT "#   STATUS FRICTION    MISFITS     STRESS MAGNITUDE      STRESS ORIENTATIONS"
     PRINT "FA          COEF.  PRINC.  SLIP FRIC   "; CHR$(229); "1   "; CHR$(229); "2   "; CHR$(229); "3    "; CHR$(237); "   "; CHR$(229); "1     "; CHR$(229); "2     "; CHR$(229); "3"
     
     PRINT
     KDAT = KDAT
     FOR I = 1 TO KDAT
     IF DAT(I, 3) = 0 OR DAT(I, 4) = 0 THEN GOTO 8217
     PRINT USING "### "; DAT(I, 2);
     IF UL$(I) = "S" THEN PRINT "LEAST ";
     IF UL$(I) = "L" THEN PRINT "LEVEL1";
     IF UL$(I) = "U" THEN PRINT "LEVEL2";
     PRINT USING " ##.## "; DAT(I, 1), DAT(I, 3), DAT(I, 4);
     PRINT USING "##.## "; DAT(I, 16);
     PRINT USING " ####"; DAT(I, 7), DAT(I, 8), DAT(I, 9);
    
     IF ABS(DAT(I, 7) - DAT(I, 9)) > .0000001 THEN PRINT USING " .##"; (DAT(I, 8) - DAT(I, 9)) / (DAT(I, 7) - DAT(I, 9));
     IF ABS(DAT(I, 7) - DAT(I, 9)) < .0000001 THEN PRINT " NA";
     PRINT USING " ##"; DAT(I, 10);
     PRINT "/";
     PRINT USING "### "; DAT(I, 11);
     PRINT USING "##"; DAT(I, 12);
     PRINT "/";
     PRINT USING "### "; DAT(I, 13);
     PRINT USING "##"; DAT(I, 14);
     PRINT "/";
     PRINT USING "###"; DAT(I, 15)
8217 NEXT I
     PRINT
8216 IF KBOOTN >= KBOOT AND KBOOT <> 0 THEN GOTO 8800
     IF KBOOT = 0 THEN PRINT "Results: Y-saved as "; XRH$; ", Name for YOUR file, S-insert comments [NO] ";
     IF KBOOT = 0 THEN INPUT RSL$
     IF RSL$ = "S" OR RSL$ = "s" THEN PRINT "Type one line to be added to the results file.  Start & end with quotation";
     IF RSL$ = "S" OR RSL$ = "s" THEN COMMENT$ = ""
     IF RSL$ = "S" OR RSL$ = "s" THEN INPUT COMMENT$
     IF RSL$ = "S" OR RSL$ = "s" THEN GOTO 8216
     IF RSL$ = "" THEN GOTO 8218
     RES$ = RSL$
     IF RSL$ = "Y" OR RSL$ = "y" THEN RES$ = XRH$
     OPEN RES$ FOR OUTPUT AS #3
     PRINT #3, "Results of "; A$; "                   Date: "; DATE$
     PRINT #3, "   Selected pore pressure is "; PP * SZ; " and mean cohesion is "; CH * SZ
     PRINT #3, "#   STATUS FRICTION   MISFITS     STRESS MAGNITUDE      STRESS ORIENTATIONS"
     PRINT #3, "FA          COEF.  PRINC.  SLIP FRIC    1    2    3   Phi  1      2      3"
     FOR I = 1 TO KDAT
     IF DAT(I, 3) = 0 OR DAT(I, 4) = 0 THEN GOTO 8214
     PRINT #3, USING "### "; DAT(I, 2);
     IF UL$(I) = "S" THEN PRINT #3, "LEAST ";
     IF UL$(I) = "L" THEN PRINT #3, "LEVEL1";
     IF UL$(I) = "U" THEN PRINT #3, "LEVEL2";
     PRINT #3, USING " ##.## "; DAT(I, 1), DAT(I, 3), DAT(I, 4);
     PRINT #3, USING "##.## "; DAT(I, 16);
     PRINT #3, USING " ####"; DAT(I, 7), DAT(I, 8), DAT(I, 9);
     IF ABS(DAT(I, 7) - DAT(I, 9)) > .0000001 THEN PRINT #3, USING " .## "; (DAT(I, 8) - DAT(I, 9)) / (DAT(I, 7) - DAT(I, 9));
     IF ABS(DAT(I, 7) - DAT(I, 9)) < .0000001 THEN PRINT #3, " NA";
     PRINT #3, USING " ##"; DAT(I, 10);
     PRINT #3, "/";
     PRINT #3, USING "### "; DAT(I, 11);
     PRINT #3, USING "##"; DAT(I, 12);
     PRINT #3, "/";
     PRINT #3, USING "### "; DAT(I, 13);
     PRINT #3, USING "##"; DAT(I, 14);
     PRINT #3, "/";
     PRINT #3, USING "###"; DAT(I, 15)
8214 NEXT I
     IF COMMENT$ <> "" THEN PRINT #3, "Comment:  "; COMMENT$
     CLOSE #3
8218 IF NF$ <> "" THEN PRINT "Present faults are saved in "; NF$
     IF NFD$ <> "" THEN PRINT "Deleted faults are saved in "; NFD$
     IF NFD$ <> "" THEN PRINT "Note: Numbers of deleted faults are saved at the end of "; NFD$
     IF KBOOT <> 0 THEN GOTO 8220
8222 PRINT
     IF KBOOT = 0 THEN INPUT "Calculate confidence margins [NO] "; KBOOT$
     IF KBOOT$ = "" THEN GOTO 8224
     CLS
     PRINT "                 CONFIDENCE MARGINS"
     PRINT
     PRINT "The confidence range of the solution is calculated here by the bootstrap method"
     PRINT "    after Michael, 1987, JGR.  Run README for more details."
     PRINT "    The complete analysis requires 500 iterations (the maximum allowed).  "
     PRINT
     PRINT "Use the following procedure:  "
     PRINT "    First, FIND best solution (best friction, delete unfitted faults, etc....)"
     PRINT "    Second, RERUN (or continue) with the best friction for 10-50 iterations"
     PRINT "            to observe the confidence margins."
     PRINT "    Third, EXIT and RERUN with best friction and full number of iterations."
     PRINT
     INPUT "Number of iterations, < 500, (you can stop any time) [500] "; KBOOT
     IF KBOOT = 0 THEN KBOOT = 500
8224 IF KBOOT <> 0 THEN KBOOTN = 0
     IF KBOOT <> 0 THEN GOTO 225
8220 INPUT "More analyses [NO] "; M$
     CLS
     IF M$ <> "" THEN GOTO 40
     END
8800 KBOOT = KBOOTN
     LOCATE 3, 1
     INPUT "Show margins [YES] "; U$
     IF FBT = 1 THEN GOTO 8801
     FOR I = 2 TO KBOOT
     FLL = 1: FMM = 1
     NNS = 1
     IF BOOT(1, 0) * BOOT(1, I) + BOOT(2, 0) * BOOT(2, I) + BOOT(3, 0) * BOOT(3, I) < 0 THEN FLL = -1
     IF BOOT(4, 0) * BOOT(4, I) + BOOT(5, 0) * BOOT(5, I) + BOOT(6, 0) * BOOT(6, I) < 0 THEN FMM = -1
     IF BOOT(7, 0) * BOOT(7, I) + BOOT(8, 0) * BOOT(8, I) + BOOT(9, 0) * BOOT(9, I) < 0 THEN NNS = -1
     SL1 = SL1 + FLL * BOOT(1, I): SL2 = SL2 + FLL * BOOT(2, I): SL3 = SL3 + FLL * BOOT(3, I)
     SM1 = SM1 + FMM * BOOT(4, I): SM2 = SM2 + FMM * BOOT(5, I): SM3 = SM3 + FMM * BOOT(6, I)
     SN1 = SN1 + NNS * BOOT(7, I): SN2 = SN2 + NNS * BOOT(8, I): SN3 = SN3 + NNS * BOOT(9, I)
     NEXT I
     RL = SQR(SL1 ^ 2 + SL2 ^ 2 + SL3 ^ 2)
     RM = SQR(SM1 ^ 2 + SM2 ^ 2 + SM3 ^ 2)
     RN = SQR(SN1 ^ 2 + SN2 ^ 2 + SN3 ^ 2)
     SL1 = SL1 / RL: SL2 = SL2 / RL: SL3 = SL3 / RL
     SM1 = SM1 / RM: SM2 = SM2 / RM: SM3 = SM3 / RM
     SN1 = SN1 / RN: SN2 = SN2 / RN: SN3 = SN3 / RN
     LOCATE 15, 1
     KBT = KBOOT - 2
     KFISHL = (KBT - 1) / (KBT - RL)
     KFISHM = (KBT - 1) / (KBT - RM)
     KFISHN = (KBT - 1) / (KBT - RN)
    


     L95 = 140 / SQR(KFISHL): M95 = 140 / SQR(KFISHM): N95 = 140 / SQR(KFISHN)



     IF SL3 > 0 THEN GOTO 8803
     SL1 = -SL1: SL2 = -SL2: SL3 = -SL3
8803 ALPHA = ATN(SL2 / SL1)
     IF SL1 < 0 THEN ALPHA = PI + ALPHA
     IF SL2 < 0 AND SL1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF SL3 = 1 THEN SL3 = .9999
     DIP = ATN(SL3 / SQR(1 - SL3 ^ 2))
     DIP = 180 * DIP / PI
     FOR I = 1 TO 8
     PRINT
     NEXT I
     PRINT "Mean Axes "; CHR$(241)
     PRINT "    Radius of confidence"
     PRINT " "; CHR$(229); "1    ";
     PRINT USING "###"; INT(DIP);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; INT(ALPHA);
     PRINT CHR$(248);
     PRINT " "; CHR$(241); INT(L95); CHR$(248)
     IF SM3 > 0 THEN GOTO 8804
     SM1 = -SM1: SM2 = -SM2: SM3 = -SM3
8804 ALPHA = ATN(SM2 / SM1)
     IF SM1 < 0 THEN ALPHA = PI + ALPHA
     IF SM2 < 0 AND SM1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF SM3 = 1 THEN SM3 = .9999
     DIP = ATN(SM3 / SQR(1 - SM3 ^ 2))
     DIP = 180 * DIP / PI
     PRINT " "; CHR$(229); "2    ";
     PRINT USING "###"; INT(DIP);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; INT(ALPHA);
     PRINT CHR$(248);
     PRINT " "; CHR$(241); INT(M95); CHR$(248)
     IF SN3 > 0 THEN GOTO 8805
     SN1 = -SN1: SN2 = -SN2: SN3 = -SN3
8805 ALPHA = ATN(SN2 / SN1)
     IF SN1 < 0 THEN ALPHA = PI + ALPHA
     IF SN2 < 0 AND SN1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF SN3 = 1 THEN SN3 = .9999
     DIP = ATN(SN3 / SQR(1 - SN3 ^ 2))
     DIP = 180 * DIP / PI
     PRINT " "; CHR$(229); "3    ";
     PRINT USING "###"; INT(DIP);
     PRINT CHR$(248);
     PRINT "/";
     PRINT USING "###"; INT(ALPHA);
     PRINT CHR$(248);
     PRINT " "; CHR$(241); INT(N95); CHR$(248)
     IF SCOL = 12 THEN LINE (40, 382)-(54, 431), 15, BF
     CIRCLE (47, 390), 4, 12
     CIRCLE (47, 407), 3, 2
     CIRCLE (47, 424), 2, 9

     BOOT(1, 0) = SL1: BOOT(2, 0) = SL2: BOOT(3, 0) = SL3
     BOOT(4, 0) = SM1: BOOT(5, 0) = SM2: BOOT(6, 0) = SM3
     BOOT(7, 0) = SN1: BOOT(8, 0) = SN2: BOOT(9, 0) = SN3
     K1# = BOOT(1, 0): K2# = BOOT(2, 0): K3# = BOOT(3, 0)
     L1# = BOOT(4, 0): L2# = BOOT(5, 0): L3# = BOOT(6, 0)
     M1# = BOOT(7, 0): M2# = BOOT(8, 0): M3# = BOOT(9, 0)
     FBT = 7
     GOSUB 4820
     FBT = 1


8801 FOR I = 2 TO KBOOT
     W1 = ABS(BOOT(1, 0) * BOOT(1, I) + BOOT(2, 0) * BOOT(2, I) + BOOT(3, 0) * BOOT(3, I))
     W2 = ABS(BOOT(4, 0) * BOOT(4, I) + BOOT(5, 0) * BOOT(5, I) + BOOT(6, 0) * BOOT(6, I))
     W3 = ABS(BOOT(7, 0) * BOOT(7, I) + BOOT(8, 0) * BOOT(8, I) + BOOT(9, 0) * BOOT(9, I))
     IF W1 >= 1 THEN W1 = .99999
     W1 = PI / 2 - ATN(W1 / SQR(1 - W1 ^ 2))
     W1 = ABS(W1 * 180 / PI#)
     IF W2 >= 1 THEN W2 = .99999
     W2 = PI / 2 - ATN(W2 / SQR(1 - W2 ^ 2))
     W2 = ABS(W2 * 180 / PI#)
     IF W3 >= 1 THEN W3 = .99999
     W3 = PI / 2 - ATN(W3 / SQR(1 - W3 ^ 2))
     W3 = ABS(W3 * 180 / PI#)
     BOOT(10, I) = (W1 + W2 + W3) / 3
     NEXT I
8802 FOR I = 2 TO KBOOT
     NB = 1
     FOR J = 2 TO KBOOT
     IF BOOT(10, I) > BOOT(10, J) THEN NB = NB + 1
     NEXT J
     BOOT(11, I) = NB
8806 NEXT I

8904 LOCATE 3, 1
     PRINT INT(FCUTOFF * KBOOT); "  solutions deleted  "
     PRINT
     LOCATE 1, 1
     IF KBOOT <> 0 THEN PRINT "Results of "; A$; ", friction= "; MUM
     LOCATE 5, 1
     IF KBOOT <> 0 THEN PRINT "Misfit: "; MISANG, MISSLP
     PRINT
     PRINT "Enter cutoff of cases:"
     PRINT "1 for "; CHR$(241); " one S.D.,"
     PRINT "2 for "; CHR$(241); " two S.D., or"
     PRINT "fraction of total"
     PRINT "cases to be deleted."
     PRINT
     INPUT "New cutoff [END]"; FCUT
     IF FCUT = 0 THEN GOTO 8820
     IF FCUT = 1 THEN FCUTOFF = .3173
     IF FCUT = 2 THEN FCUTOFF = .0455
     IF FCUT <> 0 AND FCUT < 1 THEN FCUTOFF = FCUT
8807 FOR I = 2 TO KBOOT - 1
     IF BOOT(11, I) < INT((KBOOT) * (1 - FCUTOFF)) THEN GOTO 8808
        K1# = BOOT(1, I): K2# = BOOT(2, I): K3# = BOOT(3, I)
        L1# = BOOT(4, I): L2# = BOOT(5, I): L3# = BOOT(6, I)
        M1# = BOOT(7, I): M2# = BOOT(8, I): M3# = BOOT(9, I)
     DELBOOT = DELBOOT + 1
     FBOOT = 0
     GOSUB 4820
8808 NEXT I
     GOTO 8904
8820 INPUT "END"; OK
     END
9000 PRINT
     PRINT "Error in computation."
     PRINT
     GOTO 8210



